/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20221104(e764c5b816a99eb8673b2fc4fc028827f202872f)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(F){for(var r=[],A=0,e=F.length;A<e;A++)r[A]=X[F[A]];return r},Ee=this,Re=typeof global=="object"?global:{},se;(function(F){F.global=Ee;var r=function(){function A(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(A.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),A.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=A._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},A._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},A}();F.Environment=r})(se||(se={}));var se;(function(F){var r=function(){function N(f,v,m){this.type=f,this.detail=v,this.timestamp=m}return N}();F.LoaderEvent=r;var A=function(){function N(f){this._events=[new r(1,"",f)]}return N.prototype.record=function(f,v){this._events.push(new r(f,v,F.Utilities.getHighPerformanceTimestamp()))},N.prototype.getEvents=function(){return this._events},N}();F.LoaderEventRecorder=A;var e=function(){function N(){}return N.prototype.record=function(f,v){},N.prototype.getEvents=function(){return[]},N.INSTANCE=new N,N}();F.NullLoaderEventRecorder=e})(se||(se={}));var se;(function(F){var r=function(){function A(){}return A.fileUriToFilePath=function(e,N){if(N=decodeURI(N).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(N))return N.substr(8);if(/^file:\/\//.test(N))return N.substr(5)}else if(/^file:\/\//.test(N))return N.substr(7);return N},A.startsWith=function(e,N){return e.length>=N.length&&e.substr(0,N.length)===N},A.endsWith=function(e,N){return e.length>=N.length&&e.substr(e.length-N.length)===N},A.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},A.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},A.forEachProperty=function(e,N){if(e){var f=void 0;for(f in e)e.hasOwnProperty(f)&&N(f,e[f])}},A.isEmpty=function(e){var N=!0;return A.forEachProperty(e,function(){N=!1}),N},A.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var N=Array.isArray(e)?[]:{};return A.forEachProperty(e,function(f,v){v&&typeof v=="object"?N[f]=A.recursiveClone(v):N[f]=v}),N},A.generateAnonymousModule=function(){return"===anonymous"+A.NEXT_ANONYMOUS_ID+++"==="},A.isAnonymousModule=function(e){return A.startsWith(e,"===anonymous")},A.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},A.NEXT_ANONYMOUS_ID=1,A.PERFORMANCE_NOW_PROBED=!1,A.HAS_PERFORMANCE_NOW=!1,A}();F.Utilities=r})(se||(se={}));var se;(function(F){function r(N){if(N instanceof Error)return N;var f=new Error(N.message||String(N)||"Unknown Error");return N.stack&&(f.stack=N.stack),f}F.ensureError=r;var A=function(){function N(){}return N.validateConfigurationOptions=function(f){function v(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory function of "'+l.moduleId+'" has thrown an exception'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=v),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(F.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){var m=r(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",f.onError(m),f.nodeCachedData=void 0}return f},N.mergeConfigurationOptions=function(f,v){f===void 0&&(f=null),v===void 0&&(v=null);var m=F.Utilities.recursiveClone(v||{});return F.Utilities.forEachProperty(f,function(l,c){l==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(c):l==="paths"&&typeof m.paths<"u"?F.Utilities.forEachProperty(c,function(p,t){return m.paths[p]=t}):l==="config"&&typeof m.config<"u"?F.Utilities.forEachProperty(c,function(p,t){return m.config[p]=t}):m[l]=F.Utilities.recursiveClone(c)}),N.validateConfigurationOptions(m)},N}();F.ConfigurationOptionsUtil=A;var e=function(){function N(f,v){if(this._env=f,this.options=A.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var m=this.options.nodeRequire.main.filename,l=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,l+1)}}return N.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0},N.prototype._createSortedPathsRules=function(){var f=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(v,m){Array.isArray(m)?f.sortedPathsRules.push({from:v,to:m}):f.sortedPathsRules.push({from:v,to:[m]})}),this.sortedPathsRules.sort(function(v,m){return m.from.length-v.from.length})},N.prototype.cloneAndMerge=function(f){return new N(this._env,A.mergeConfigurationOptions(f,this.options))},N.prototype.getOptionsLiteral=function(){return this.options},N.prototype._applyPaths=function(f){for(var v,m=0,l=this.sortedPathsRules.length;m<l;m++)if(v=this.sortedPathsRules[m],F.Utilities.startsWith(f,v.from)){for(var c=[],p=0,t=v.to.length;p<t;p++)c.push(v.to[p]+f.substr(v.from.length));return c}return[f]},N.prototype._addUrlArgsToUrl=function(f){return F.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs},N.prototype._addUrlArgsIfNecessaryToUrl=function(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f},N.prototype._addUrlArgsIfNecessaryToUrls=function(f){if(this.options.urlArgs)for(var v=0,m=f.length;v<m;v++)f[v]=this._addUrlArgsToUrl(f[v]);return f},N.prototype.moduleIdToPaths=function(f){if(this._env.isNode){var v=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f);if(v)return this.isBuild()?["empty:"]:["node|"+f]}var m=f,l;if(!F.Utilities.endsWith(m,".js")&&!F.Utilities.isAbsolutePath(m)){l=this._applyPaths(m);for(var c=0,p=l.length;c<p;c++)this.isBuild()&&l[c]==="empty:"||(F.Utilities.isAbsolutePath(l[c])||(l[c]=this.options.baseUrl+l[c]),!F.Utilities.endsWith(l[c],".js")&&!F.Utilities.containsQueryString(l[c])&&(l[c]=l[c]+".js"))}else!F.Utilities.endsWith(m,".js")&&!F.Utilities.containsQueryString(m)&&(m=m+".js"),l=[m];return this._addUrlArgsIfNecessaryToUrls(l)},N.prototype.requireToUrl=function(f){var v=f;return F.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],F.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)},N.prototype.isBuild=function(){return this.options.isBuild},N.prototype.shouldInvokeFactory=function(f){return!!(!this.options.isBuild||F.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])},N.prototype.isDuplicateMessageIgnoredFor=function(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)},N.prototype.getConfigForModule=function(f){if(this.options.config)return this.options.config[f]},N.prototype.shouldCatchError=function(){return this.options.catchError},N.prototype.shouldRecordStats=function(){return this.options.recordStats},N.prototype.onError=function(f){this.options.onError(f)},N}();F.Configuration=e})(se||(se={}));var se;(function(F){var r=function(){function l(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(c,p,t,w){var u=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new N;else if(this._env.isElectronRenderer){var _=c.getConfig().getOptionsLiteral().preferScriptTags;_?this._scriptLoader=new A:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new A;var L={callback:t,errorback:w};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(L);return}this._callbackMap[p]=[L],this._scriptLoader.load(c,p,function(){return u.triggerCallback(p)},function(y){return u.triggerErrorback(p,y)})},l.prototype.triggerCallback=function(c){var p=this._callbackMap[c];delete this._callbackMap[c];for(var t=0;t<p.length;t++)p[t].callback()},l.prototype.triggerErrorback=function(c,p){var t=this._callbackMap[c];delete this._callbackMap[c];for(var w=0;w<t.length;w++)t[w].errorback(p)},l}(),A=function(){function l(){}return l.prototype.attachListeners=function(c,p,t){var w=function(){c.removeEventListener("load",u),c.removeEventListener("error",_)},u=function(L){w(),p()},_=function(L){w(),t(L)};c.addEventListener("load",u),c.addEventListener("error",_)},l.prototype.load=function(c,p,t,w){if(/^node\|/.test(p)){var u=c.getConfig().getOptionsLiteral(),_=v(c.getRecorder(),u.nodeRequire||F.global.nodeRequire),L=p.split("|"),y=null;try{y=_(L[1])}catch(i){w(i);return}c.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,t,w);var g=c.getConfig().getOptionsLiteral().trustedTypesPolicy;g&&(p=g.createScriptURL(p)),S.setAttribute("src",p);var s=c.getConfig().getOptionsLiteral().cspNonce;s&&S.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(S)}},l}();function e(l){var c=l.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var p=c?self.eval(c.createScript("","true")):new Function("true");return p.call(self),!0}catch{return!1}}var N=function(){function l(){this._cachedCanUseEval=null}return l.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(c)),this._cachedCanUseEval},l.prototype.load=function(c,p,t,w){if(/^node\|/.test(p)){var u=c.getConfig().getOptionsLiteral(),_=v(c.getRecorder(),u.nodeRequire||F.global.nodeRequire),L=p.split("|"),y=null;try{y=_(L[1])}catch(s){w(s);return}c.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var S=c.getConfig().getOptionsLiteral().trustedTypesPolicy,g=/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin;if(!g&&this._canUseEval(c)){fetch(p).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+p;var i=S?self.eval(S.createScript("",s)):new Function(s);i.call(self),t()}).then(void 0,w);return}try{S&&(p=S.createScriptURL(p)),importScripts(p),t()}catch(s){w(s)}}},l}(),f=function(){function l(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},l.prototype._initNodeRequire=function(c,p){var t=p.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,u=c("module");function _(L){var y=L.constructor,S=function(s){try{return L.require(s)}finally{}};return S.resolve=function(s,i){return y._resolveFilename(s,L,!1,i)},S.resolve.paths=function(s){return y._resolveLookupPaths(s,L)},S.main=process.mainModule,S.extensions=y._extensions,S.cache=y._cache,S}u.prototype._compile=function(L,y){var S=u.wrap(L.replace(/^#!.*/,"")),g=p.getRecorder(),s=w._getCachedDataPath(t,y),i={filename:y},o;try{var b=w._fs.readFileSync(s);o=b.slice(0,16),i.cachedData=b.slice(16),g.record(60,s)}catch{g.record(61,s)}var h=new w._vm.Script(S,i),a=h.runInThisContext(i),d=w._path.dirname(y),C=_(this),E=[this.exports,C,this,y,d,process,Re,Buffer],R=a.apply(this.exports,E);return w._handleCachedData(h,S,s,!i.cachedData,p),w._verifyCachedData(h,S,s,o,p),R}},l.prototype.load=function(c,p,t,w){var u=this,_=c.getConfig().getOptionsLiteral(),L=v(c.getRecorder(),_.nodeRequire||F.global.nodeRequire),y=_.nodeInstrumenter||function(a){return a};this._init(L),this._initNodeRequire(L,c);var S=c.getRecorder();if(/^node\|/.test(p)){var g=p.split("|"),s=null;try{s=L(g[1])}catch(a){w(a);return}c.enqueueDefineAnonymousModule([],function(){return s}),t()}else{p=F.Utilities.fileUriToFilePath(this._env.isWindows,p);var i=this._path.normalize(p),o=this._getElectronRendererScriptPathOrUri(i),b=Boolean(_.nodeCachedData),h=b?this._getCachedDataPath(_.nodeCachedData,p):void 0;this._readSourceAndCachedData(i,h,S,function(a,d,C,E){if(a){w(a);return}var R;d.charCodeAt(0)===l._BOM?R=l._PREFIX+d.substring(1)+l._SUFFIX:R=l._PREFIX+d+l._SUFFIX,R=y(R,i);var D={filename:o,cachedData:C},P=u._createAndEvalScript(c,R,D,t,w);u._handleCachedData(P,R,h,b&&!C,c),u._verifyCachedData(P,R,h,E,c)})}},l.prototype._createAndEvalScript=function(c,p,t,w,u){var _=c.getRecorder();_.record(31,t.filename);var L=new this._vm.Script(p,t),y=L.runInThisContext(t),S=c.getGlobalAMDDefineFunc(),g=!1,s=function(){return g=!0,S.apply(null,arguments)};return s.amd=S.amd,y.call(F.global,c.getGlobalAMDRequireFunc(),s,t.filename,this._path.dirname(t.filename)),_.record(32,t.filename),g?w():u(new Error("Didn't receive define call in "+t.filename+"!")),L},l.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var p=c.match(/^([a-z])\:(.*)/i);return p?"file:///"+(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/"):"file://"+c},l.prototype._getCachedDataPath=function(c,p){var t=this._crypto.createHash("md5").update(p,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(p).replace(/\.js$/,"");return this._path.join(c.path,w+"-"+t+".code")},l.prototype._handleCachedData=function(c,p,t,w,u){var _=this;c.cachedDataRejected?this._fs.unlink(t,function(L){u.getRecorder().record(62,t),_._createAndWriteCachedData(c,p,t,u),L&&u.getConfig().onError(L)}):w&&this._createAndWriteCachedData(c,p,t,u)},l.prototype._createAndWriteCachedData=function(c,p,t,w){var u=this,_=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,y=0,S=void 0,g=function(){setTimeout(function(){S||(S=u._crypto.createHash("md5").update(p,"utf8").digest());var s=c.createCachedData();if(!(s.length===0||s.length===L||y>=5)){if(s.length<L){g();return}L=s.length,u._fs.writeFile(t,Buffer.concat([S,s]),function(i){i&&w.getConfig().onError(i),w.getRecorder().record(63,t),g()})}},_*Math.pow(4,y++))};g()},l.prototype._readSourceAndCachedData=function(c,p,t,w){if(!p)this._fs.readFile(c,{encoding:"utf8"},w);else{var u=void 0,_=void 0,L=void 0,y=2,S=function(g){g?w(g):--y===0&&w(void 0,u,_,L)};this._fs.readFile(c,{encoding:"utf8"},function(g,s){u=s,S(g)}),this._fs.readFile(p,function(g,s){!g&&s&&s.length>0?(L=s.slice(0,16),_=s.slice(16),t.record(60,p)):t.record(61,p),S()})}},l.prototype._verifyCachedData=function(c,p,t,w,u){var _=this;!w||c.cachedDataRejected||setTimeout(function(){var L=_._crypto.createHash("md5").update(p,"utf8").digest();w.equals(L)||(u.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),_._fs.unlink(t,function(y){y&&u.getConfig().onError(y)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function v(l,c){if(c.__$__isRecorded)return c;var p=function(w){l.record(33,w);try{return c(w)}finally{l.record(34,w)}};return p.__$__isRecorded=!0,p}F.ensureRecordedNodeRequire=v;function m(l){return new r(l)}F.createScriptLoader=m})(se||(se={}));var se;(function(F){var r=function(){function m(l){var c=l.lastIndexOf("/");c!==-1?this.fromModulePath=l.substr(0,c+1):this.fromModulePath=""}return m._normalizeModuleId=function(l){var c=l,p;for(p=/\/\.\//;p.test(c);)c=c.replace(p,"/");for(c=c.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(c);)c=c.replace(p,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},m.prototype.resolveModule=function(l){var c=l;return F.Utilities.isAbsolutePath(c)||(F.Utilities.startsWith(c,"./")||F.Utilities.startsWith(c,"../"))&&(c=m._normalizeModuleId(this.fromModulePath+c)),c},m.ROOT=new m(""),m}();F.ModuleIdResolver=r;var A=function(){function m(l,c,p,t,w,u){this.id=l,this.strId=c,this.dependencies=p,this._callback=t,this._errorback=w,this.moduleIdResolver=u,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return m._safeInvokeFunction=function(l,c){try{return{returnedValue:l.apply(F.global,c),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}},m._invokeFactory=function(l,c,p,t){return l.shouldInvokeFactory(c)?l.shouldCatchError()?this._safeInvokeFunction(p,t):{returnedValue:p.apply(F.global,t),producedError:null}:{returnedValue:null,producedError:null}},m.prototype.complete=function(l,c,p,t){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);var u=m._invokeFactory(c,this.strId,this._callback,p);w=u.producedError,l.record(22,this.strId),!w&&typeof u.returnedValue<"u"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=u.returnedValue)}else this.exports=this._callback;if(w){var _=F.ensureError(w);_.phase="factory",_.moduleId=this.strId,_.neededBy=t(this.id),this.error=_,c.onError(_)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},m.prototype.onDependencyError=function(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1},m.prototype.isComplete=function(){return this._isComplete},m}();F.Module=A;var e=function(){function m(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return m.prototype.getMaxModuleId=function(){return this._nextId},m.prototype.getModuleId=function(l){var c=this._strModuleIdToIntModuleId.get(l);return typeof c>"u"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(l,c),this._intModuleIdToStrModuleId[c]=l),c},m.prototype.getStrModuleId=function(l){return this._intModuleIdToStrModuleId[l]},m}(),N=function(){function m(l){this.id=l}return m.EXPORTS=new m(0),m.MODULE=new m(1),m.REQUIRE=new m(2),m}();F.RegularDependency=N;var f=function(){function m(l,c,p){this.id=l,this.pluginId=c,this.pluginParam=p}return m}();F.PluginDependency=f;var v=function(){function m(l,c,p,t,w){w===void 0&&(w=0),this._env=l,this._scriptLoader=c,this._loaderAvailableTimestamp=w,this._defineFunc=p,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return m.prototype.reset=function(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},m.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},m.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},m._findRelevantLocationInStack=function(l,c){for(var p=function(i){return i.replace(/\\/g,"/")},t=p(l),w=c.split(/\n/),u=0;u<w.length;u++){var _=w[u].match(/(.*):(\d+):(\d+)\)?$/);if(_){var L=_[1],y=_[2],S=_[3],g=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(g),L=p(L),L===t){var s={line:parseInt(y,10),col:parseInt(S,10)};return s.line===1&&(s.col-=53),s}}}throw new Error("Could not correlate define call site for needle "+l)},m.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var l=[],c=0,p=0,t=this._modules2.length;p<t;p++){var w=this._modules2[p];if(!!w){var u=this._buildInfoPath[w.id]||null,_=this._buildInfoDefineStack[w.id]||null,L=this._buildInfoDependencies[w.id];l[c++]={id:w.strId,path:u,defineLocation:u&&_?m._findRelevantLocationInStack(u,_):null,dependencies:L,shim:null,exports:w.exports}}}return l},m.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},m.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},m.prototype.enqueueDefineAnonymousModule=function(l,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:l,callback:c}},m.prototype.defineModule=function(l,c,p,t,w,u){var _=this;u===void 0&&(u=new r(l));var L=this._moduleIdProvider.getModuleId(l);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}var y=new A(L,l,this._normalizeDependencies(c,u),p,t,u);this._modules2[L]=y,this._config.isBuild()&&(this._buildInfoDefineStack[L]=w,this._buildInfoDependencies[L]=(y.dependencies||[]).map(function(S){return _._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(y)},m.prototype._normalizeDependency=function(l,c){if(l==="exports")return N.EXPORTS;if(l==="module")return N.MODULE;if(l==="require")return N.REQUIRE;var p=l.indexOf("!");if(p>=0){var t=c.resolveModule(l.substr(0,p)),w=c.resolveModule(l.substr(p+1)),u=this._moduleIdProvider.getModuleId(t+"!"+w),_=this._moduleIdProvider.getModuleId(t);return new f(u,_,w)}return new N(this._moduleIdProvider.getModuleId(c.resolveModule(l)))},m.prototype._normalizeDependencies=function(l,c){for(var p=[],t=0,w=0,u=l.length;w<u;w++)p[t++]=this._normalizeDependency(l[w],c);return p},m.prototype._relativeRequire=function(l,c,p,t){if(typeof c=="string")return this.synchronousRequire(c,l);this.defineModule(F.Utilities.generateAnonymousModule(),c,p,t,null,l)},m.prototype.synchronousRequire=function(l,c){c===void 0&&(c=new r(l));var p=this._normalizeDependency(l,c),t=this._modules2[p.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},m.prototype.configure=function(l,c){var p=this._config.shouldRecordStats();c?this._config=new F.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!p&&(this._recorder=null)},m.prototype.getConfig=function(){return this._config},m.prototype._onLoad=function(l){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),c.dependencies,c.callback,null,c.stack)}},m.prototype._createLoadError=function(l,c){var p=this,t=this._moduleIdProvider.getStrModuleId(l),w=(this._inverseDependencies2[l]||[]).map(function(_){return p._moduleIdProvider.getStrModuleId(_)}),u=F.ensureError(c);return u.phase="loading",u.moduleId=t,u.neededBy=w,u},m.prototype._onLoadError=function(l,c){var p=this._createLoadError(l,c);this._modules2[l]||(this._modules2[l]=new A(l,this._moduleIdProvider.getStrModuleId(l),[],function(){},null,null));for(var t=[],w=0,u=this._moduleIdProvider.getMaxModuleId();w<u;w++)t[w]=!1;var _=!1,L=[];for(L.push(l),t[l]=!0;L.length>0;){var y=L.shift(),S=this._modules2[y];S&&(_=S.onDependencyError(p)||_);var g=this._inverseDependencies2[y];if(g)for(var w=0,u=g.length;w<u;w++){var s=g[w];t[s]||(L.push(s),t[s]=!0)}}_||this._config.onError(p)},m.prototype._hasDependencyPath=function(l,c){var p=this._modules2[l];if(!p)return!1;for(var t=[],w=0,u=this._moduleIdProvider.getMaxModuleId();w<u;w++)t[w]=!1;var _=[];for(_.push(p),t[l]=!0;_.length>0;){var L=_.shift(),y=L.dependencies;if(y)for(var w=0,u=y.length;w<u;w++){var S=y[w];if(S.id===c)return!0;var g=this._modules2[S.id];g&&!t[S.id]&&(t[S.id]=!0,_.push(g))}}return!1},m.prototype._findCyclePath=function(l,c,p){if(l===c||p===50)return[l];var t=this._modules2[l];if(!t)return null;var w=t.dependencies;if(w)for(var u=0,_=w.length;u<_;u++){var L=this._findCyclePath(w[u].id,c,p+1);if(L!==null)return L.push(l),L}return null},m.prototype._createRequire=function(l){var c=this,p=function(t,w,u){return c._relativeRequire(l,t,w,u)};return p.toUrl=function(t){return c._config.requireToUrl(l.resolveModule(t))},p.getStats=function(){return c.getLoaderEvents()},p.hasDependencyCycle=function(){return c._hasDependencyCycle},p.config=function(t,w){w===void 0&&(w=!1),c.configure(t,w)},p.__$__nodeRequire=F.global.nodeRequire,p},m.prototype._loadModule=function(l){var c=this;if(!(this._modules2[l]||this._knownModules2[l])){this._knownModules2[l]=!0;var p=this._moduleIdProvider.getStrModuleId(l),t=this._config.moduleIdToPaths(p),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(p.indexOf("/")===-1||w.test(p))&&t.push("node|"+p);var u=-1,_=function(L){if(u++,u>=t.length)c._onLoadError(l,L);else{var y=t[u],S=c.getRecorder();if(c._config.isBuild()&&y==="empty:"){c._buildInfoPath[l]=y,c.defineModule(c._moduleIdProvider.getStrModuleId(l),[],null,null,null),c._onLoad(l);return}S.record(10,y),c._scriptLoader.load(c,y,function(){c._config.isBuild()&&(c._buildInfoPath[l]=y),S.record(11,y),c._onLoad(l)},function(g){S.record(12,y),_(g)})}};_(null)}},m.prototype._loadPluginDependency=function(l,c){var p=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var t=function(w){p.defineModule(p._moduleIdProvider.getStrModuleId(c.id),[],w,null,null)};t.error=function(w){p._config.onError(p._createLoadError(c.id,w))},l.load(c.pluginParam,this._createRequire(r.ROOT),t,this._config.getOptionsLiteral())}},m.prototype._resolve=function(l){var c=this,p=l.dependencies;if(p)for(var t=0,w=p.length;t<w;t++){var u=p[t];if(u===N.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(u===N.MODULE){l.unresolvedDependenciesCount--;continue}if(u===N.REQUIRE){l.unresolvedDependenciesCount--;continue}var _=this._modules2[u.id];if(_&&_.isComplete()){if(_.error){l.onDependencyError(_.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(u.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(u.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");var L=this._findCyclePath(u.id,l.id,0)||[];L.reverse(),L.push(u.id),console.warn(L.map(function(g){return c._moduleIdProvider.getStrModuleId(g)}).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[u.id]=this._inverseDependencies2[u.id]||[],this._inverseDependencies2[u.id].push(l.id),u instanceof f){var y=this._modules2[u.pluginId];if(y&&y.isComplete()){this._loadPluginDependency(y.exports,u);continue}var S=this._inversePluginDependencies2.get(u.pluginId);S||(S=[],this._inversePluginDependencies2.set(u.pluginId,S)),S.push(u),this._loadModule(u.pluginId);continue}this._loadModule(u.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)},m.prototype._onModuleComplete=function(l){var c=this,p=this.getRecorder();if(!l.isComplete()){var t=l.dependencies,w=[];if(t)for(var u=0,_=t.length;u<_;u++){var L=t[u];if(L===N.EXPORTS){w[u]=l.exports;continue}if(L===N.MODULE){w[u]={id:l.strId,config:function(){return c._config.getConfigForModule(l.strId)}};continue}if(L===N.REQUIRE){w[u]=this._createRequire(l.moduleIdResolver);continue}var y=this._modules2[L.id];if(y){w[u]=y.exports;continue}w[u]=null}var S=function(b){return(c._inverseDependencies2[b]||[]).map(function(h){return c._moduleIdProvider.getStrModuleId(h)})};l.complete(p,this._config,w,S);var g=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,g)for(var u=0,_=g.length;u<_;u++){var s=g[u],i=this._modules2[s];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var o=this._inversePluginDependencies2.get(l.id);if(o){this._inversePluginDependencies2.delete(l.id);for(var u=0,_=o.length;u<_;u++)this._loadPluginDependency(l.exports,o[u])}}},m}();F.ModuleManager=v})(se||(se={}));var Y,se;(function(F){var r=new F.Environment,A=null,e=function(m,l,c){typeof m!="string"&&(c=l,l=m,m=null),(typeof l!="object"||!Array.isArray(l))&&(c=l,l=null),l||(l=["require","exports","module"]),m?A.defineModule(m,l,c,null,null):A.enqueueDefineAnonymousModule(l,c)};e.amd={jQuery:!0};var N=function(m,l){l===void 0&&(l=!1),A.configure(m,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){N(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=N,f.getConfig=function(){return A.getConfig().getOptionsLiteral()},f.reset=function(){A=A.reset()},f.getBuildInfo=function(){return A.getBuildInfo()},f.getStats=function(){return A.getLoaderEvents()},f.define=e;function v(){if(typeof F.global.require<"u"||typeof require<"u"){var m=F.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){var l=F.ensureRecordedNodeRequire(A.getRecorder(),m);F.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}r.isNode&&!r.isElectronRenderer&&!r.isElectronNodeIntegrationWebWorker?module.exports=f:(r.isElectronRenderer||(F.global.define=e),F.global.require=f)}F.init=v,(typeof F.global.define!="function"||!F.global.define.amd)&&(A=new F.ModuleManager(r,F.createScriptLoader(r),e,f,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require<"u"&&typeof F.global.require!="function"&&f.config(F.global.require),Y=function(){return e.apply(null,arguments)},Y.amd=e.amd,typeof doNotInitLoader>"u"&&v())})(se||(se={}));var le=this&&this.__awaiter||function(F,r,A,e){function N(f){return f instanceof A?f:new A(function(v){v(f)})}return new(A||(A=Promise))(function(f,v){function m(p){try{c(e.next(p))}catch(t){v(t)}}function l(p){try{c(e.throw(p))}catch(t){v(t)}}function c(p){p.done?f(p.value):N(p.value).then(m,l)}c((e=e.apply(F,r||[])).next())})};Y(X[21],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.load=r.create=r.setPseudoTranslation=r.getConfiguredDefaultLocale=r.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const e="i-default";function N(_,L){let y;return L.length===0?y=_:y=_.replace(/\{(\d+)\}/g,(S,g)=>{const s=g[0],i=L[s];let o=S;return typeof i=="string"?o=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(o=String(i)),o}),A&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function f(_,L){let y=_[L];return y||(y=_["*"],y)?y:null}function v(_){return _.charAt(_.length-1)==="/"?_:_+"/"}function m(_,L,y){return le(this,void 0,void 0,function*(){const S=v(_)+v(L)+"vscode/"+v(y),g=yield fetch(S);if(g.ok)return yield g.json();throw new Error(`${g.status} - ${g.statusText}`)})}function l(_){return function(L,y){const S=Array.prototype.slice.call(arguments,2);return N(_[L],S)}}function c(_,L,...y){return N(L,y)}r.localize=c;function p(_){}r.getConfiguredDefaultLocale=p;function t(_){A=_}r.setPseudoTranslation=t;function w(_,L){var y;return{localize:l(L[_]),getConfiguredDefaultLocale:(y=L.getConfiguredDefaultLocale)!==null&&y!==void 0?y:S=>{}}}r.create=w;function u(_,L,y,S){var g;const s=(g=S["vs/nls"])!==null&&g!==void 0?g:{};if(!_||_.length===0)return y({localize:c,getConfiguredDefaultLocale:()=>{var a;return(a=s.availableLanguages)===null||a===void 0?void 0:a["*"]}});const i=s.availableLanguages?f(s.availableLanguages,_):null,o=i===null||i===e;let b=".nls";o||(b=b+"."+i);const h=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[_]),a.getConfiguredDefaultLocale=()=>{var d;return(d=s.availableLanguages)===null||d===void 0?void 0:d["*"]},y(a)};typeof s.loadBundle=="function"?s.loadBundle(_,i,(a,d)=>{a?L([_+".nls"],h):h(d)}):s.translationServiceUrl&&!o?le(this,void 0,void 0,function*(){var a;try{const d=yield m(s.translationServiceUrl,i,_);return h(d)}catch(d){if(!i.includes("-"))return console.error(d),L([_+".nls"],h);try{const C=i.split("-")[0],E=yield m(s.translationServiceUrl,C,_);return(a=s.availableLanguages)!==null&&a!==void 0||(s.availableLanguages={}),s.availableLanguages["*"]=C,h(E)}catch(C){return console.error(C),L([_+".nls"],h)}}}):L([_+b],h,a=>{if(b===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,a),L([_+".nls"],h)})}r.load=u}),function(){var F,r;const A=self.MonacoEnvironment,e=A&&A.baseUrl?A.baseUrl:"../../../",N=typeof((F=self.trustedTypes)===null||F===void 0?void 0:F.createPolicy)=="function"?(r=self.trustedTypes)===null||r===void 0?void 0:r.createPolicy("amdLoader",{createScriptURL:t=>t,createScript:(t,...w)=>{const u=w.slice(0,-1).join(","),_=w.pop().toString();return`(function anonymous(${u}) { ${_}
})`}}):void 0;function f(){try{return(N?self.eval(N.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function v(){return new Promise((t,w)=>{if(typeof self.define=="function"&&self.define.amd)return t();const u=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(u)&&u.substring(0,self.origin.length)!==self.origin)&&f()){fetch(u).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${u}`,(N?self.eval(N.createScript("",L)):new Function(L)).call(self),t()}).then(void 0,w);return}N?importScripts(N.createScriptURL(u)):importScripts(u),t()})}function m(){require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:N,amdModulesPattern:/^vs\//})}function l(t){v().then(()=>{m(),require([t],function(w){setTimeout(function(){const u=w.create((_,L)=>{self.postMessage(_,L)},null);for(self.onmessage=_=>u.onmessage(_.data,_.ports);p.length>0;)self.onmessage(p.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&m();let c=!0;const p=[];self.onmessage=t=>{if(!c){p.push(t);return}c=!1,l(t.data)}}(),Y(X[22],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CallbackIterable=r.ArrayQueue=r.findMinBy=r.findLastMaxBy=r.findMaxBy=r.numberComparator=r.compareBy=r.CompareResult=r.splice=r.insertInto=r.asArray=r.pushMany=r.pushToEnd=r.pushToStart=r.arrayInsert=r.range=r.firstOrDefault=r.lastIndex=r.findLast=r.distinct=r.isNonEmptyArray=r.isFalsyOrEmpty=r.coalesce=r.groupBy=r.quickSelect=r.findFirstInSorted=r.binarySearch2=r.binarySearch=r.removeFastWithoutKeepingOrder=r.equals=r.tail2=r.tail=void 0;function A(k,U=0){return k[k.length-(1+U)]}r.tail=A;function e(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}r.tail2=e;function N(k,U,T=(B,z)=>B===z){if(k===U)return!0;if(!k||!U||k.length!==U.length)return!1;for(let B=0,z=k.length;B<z;B++)if(!T(k[B],U[B]))return!1;return!0}r.equals=N;function f(k,U){const T=k.length-1;U<T&&(k[U]=k[T]),k.pop()}r.removeFastWithoutKeepingOrder=f;function v(k,U,T){return m(k.length,B=>T(k[B],U))}r.binarySearch=v;function m(k,U){let T=0,B=k-1;for(;T<=B;){const z=(T+B)/2|0,n=U(z);if(n<0)T=z+1;else if(n>0)B=z-1;else return z}return-(T+1)}r.binarySearch2=m;function l(k,U){let T=0,B=k.length;if(B===0)return 0;for(;T<B;){const z=Math.floor((T+B)/2);U(k[z])?B=z:T=z+1}return T}r.findFirstInSorted=l;function c(k,U,T){if(k=k|0,k>=U.length)throw new TypeError("invalid index");const B=U[Math.floor(U.length*Math.random())],z=[],n=[],ae=[];for(const de of U){const ge=T(de,B);ge<0?z.push(de):ge>0?n.push(de):ae.push(de)}return k<z.length?c(k,z,T):k<z.length+ae.length?ae[0]:c(k-(z.length+ae.length),n,T)}r.quickSelect=c;function p(k,U){const T=[];let B;for(const z of k.slice(0).sort(U))!B||U(B[0],z)!==0?(B=[z],T.push(B)):B.push(z);return T}r.groupBy=p;function t(k){return k.filter(U=>!!U)}r.coalesce=t;function w(k){return!Array.isArray(k)||k.length===0}r.isFalsyOrEmpty=w;function u(k){return Array.isArray(k)&&k.length>0}r.isNonEmptyArray=u;function _(k,U=T=>T){const T=new Set;return k.filter(B=>{const z=U(B);return T.has(z)?!1:(T.add(z),!0)})}r.distinct=_;function L(k,U){const T=y(k,U);if(T!==-1)return k[T]}r.findLast=L;function y(k,U){for(let T=k.length-1;T>=0;T--){const B=k[T];if(U(B))return T}return-1}r.lastIndex=y;function S(k,U){return k.length>0?k[0]:U}r.firstOrDefault=S;function g(k,U){let T=typeof U=="number"?k:0;typeof U=="number"?T=k:(T=0,U=k);const B=[];if(T<=U)for(let z=T;z<U;z++)B.push(z);else for(let z=T;z>U;z--)B.push(z);return B}r.range=g;function s(k,U,T){const B=k.slice(0,U),z=k.slice(U);return B.concat(T,z)}r.arrayInsert=s;function i(k,U){const T=k.indexOf(U);T>-1&&(k.splice(T,1),k.unshift(U))}r.pushToStart=i;function o(k,U){const T=k.indexOf(U);T>-1&&(k.splice(T,1),k.push(U))}r.pushToEnd=o;function b(k,U){for(const T of U)k.push(T)}r.pushMany=b;function h(k){return Array.isArray(k)?k:[k]}r.asArray=h;function a(k,U,T){const B=C(k,U),z=k.length,n=T.length;k.length=z+n;for(let ae=z-1;ae>=B;ae--)k[ae+n]=k[ae];for(let ae=0;ae<n;ae++)k[ae+B]=T[ae]}r.insertInto=a;function d(k,U,T,B){const z=C(k,U),n=k.splice(z,T);return a(k,z,B),n}r.splice=d;function C(k,U){return U<0?Math.max(U+k.length,0):Math.min(U,k.length)}var E;(function(k){function U(z){return z<0}k.isLessThan=U;function T(z){return z>0}k.isGreaterThan=T;function B(z){return z===0}k.isNeitherLessOrGreaterThan=B,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(E=r.CompareResult||(r.CompareResult={}));function R(k,U){return(T,B)=>U(k(T),k(B))}r.compareBy=R;const D=(k,U)=>k-U;r.numberComparator=D;function P(k,U){if(k.length===0)return;let T=k[0];for(let B=1;B<k.length;B++){const z=k[B];U(z,T)>0&&(T=z)}return T}r.findMaxBy=P;function O(k,U){if(k.length===0)return;let T=k[0];for(let B=1;B<k.length;B++){const z=k[B];U(z,T)>=0&&(T=z)}return T}r.findLastMaxBy=O;function W(k,U){return P(k,(T,B)=>-U(T,B))}r.findMinBy=W;class H{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let T=this.firstIdx;for(;T<this.items.length&&U(this.items[T]);)T++;const B=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,B}takeFromEndWhile(U){let T=this.lastIdx;for(;T>=0&&U(this.items[T]);)T--;const B=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,B}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const T=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,T}}r.ArrayQueue=H;class q{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(T=>(U.push(T),!0)),U}filter(U){return new q(T=>this.iterate(B=>U(B)?T(B):!0))}map(U){return new q(T=>this.iterate(B=>T(U(B))))}findLast(U){let T;return this.iterate(B=>(U(B)&&(T=B),!0)),T}findLastMaxBy(U){let T,B=!0;return this.iterate(z=>((B||E.isGreaterThan(U(z,T)))&&(B=!1,T=z),!0)),T}}r.CallbackIterable=q,q.empty=new q(k=>{})}),Y(X[23],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CachedFunction=r.LRUCachedFunction=void 0;class A{constructor(f){this.fn=f,this.lastCache=void 0,this.lastArgKey=void 0}get(f){const v=JSON.stringify(f);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(f)),this.lastCache}}r.LRUCachedFunction=A;class e{get cachedValues(){return this._map}constructor(f){this.fn=f,this._map=new Map}get(f){if(this._map.has(f))return this._map.get(f);const v=this.fn(f);return this._map.set(f,v),v}}r.CachedFunction=e}),Y(X[24],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CSSIcon=r.Codicon=r.getCodiconAriaLabel=void 0;function A(f){return f?f.replace(/\$\((.*?)\)/g,(v,m)=>` ${m} `).trim():""}r.getCodiconAriaLabel=A;class e{constructor(v,m,l){this.id=v,this.definition=m,this.description=l,e._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e._allCodicons}}r.Codicon=e,e._allCodicons=[],e.add=new e("add",{fontCharacter:"\\ea60"}),e.plus=new e("plus",e.add.definition),e.gistNew=new e("gist-new",e.add.definition),e.repoCreate=new e("repo-create",e.add.definition),e.lightbulb=new e("lightbulb",{fontCharacter:"\\ea61"}),e.lightBulb=new e("light-bulb",{fontCharacter:"\\ea61"}),e.repo=new e("repo",{fontCharacter:"\\ea62"}),e.repoDelete=new e("repo-delete",{fontCharacter:"\\ea62"}),e.gistFork=new e("gist-fork",{fontCharacter:"\\ea63"}),e.repoForked=new e("repo-forked",{fontCharacter:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{fontCharacter:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),e.recordKeys=new e("record-keys",{fontCharacter:"\\ea65"}),e.keyboard=new e("keyboard",{fontCharacter:"\\ea65"}),e.tag=new e("tag",{fontCharacter:"\\ea66"}),e.tagAdd=new e("tag-add",{fontCharacter:"\\ea66"}),e.tagRemove=new e("tag-remove",{fontCharacter:"\\ea66"}),e.person=new e("person",{fontCharacter:"\\ea67"}),e.personFollow=new e("person-follow",{fontCharacter:"\\ea67"}),e.personOutline=new e("person-outline",{fontCharacter:"\\ea67"}),e.personFilled=new e("person-filled",{fontCharacter:"\\ea67"}),e.gitBranch=new e("git-branch",{fontCharacter:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{fontCharacter:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{fontCharacter:"\\ea68"}),e.sourceControl=new e("source-control",{fontCharacter:"\\ea68"}),e.mirror=new e("mirror",{fontCharacter:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{fontCharacter:"\\ea69"}),e.star=new e("star",{fontCharacter:"\\ea6a"}),e.starAdd=new e("star-add",{fontCharacter:"\\ea6a"}),e.starDelete=new e("star-delete",{fontCharacter:"\\ea6a"}),e.starEmpty=new e("star-empty",{fontCharacter:"\\ea6a"}),e.comment=new e("comment",{fontCharacter:"\\ea6b"}),e.commentAdd=new e("comment-add",{fontCharacter:"\\ea6b"}),e.alert=new e("alert",{fontCharacter:"\\ea6c"}),e.warning=new e("warning",{fontCharacter:"\\ea6c"}),e.search=new e("search",{fontCharacter:"\\ea6d"}),e.searchSave=new e("search-save",{fontCharacter:"\\ea6d"}),e.logOut=new e("log-out",{fontCharacter:"\\ea6e"}),e.signOut=new e("sign-out",{fontCharacter:"\\ea6e"}),e.logIn=new e("log-in",{fontCharacter:"\\ea6f"}),e.signIn=new e("sign-in",{fontCharacter:"\\ea6f"}),e.eye=new e("eye",{fontCharacter:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{fontCharacter:"\\ea70"}),e.eyeWatch=new e("eye-watch",{fontCharacter:"\\ea70"}),e.circleFilled=new e("circle-filled",{fontCharacter:"\\ea71"}),e.primitiveDot=new e("primitive-dot",e.circleFilled.definition),e.closeDirty=new e("close-dirty",e.circleFilled.definition),e.debugBreakpoint=new e("debug-breakpoint",e.circleFilled.definition),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",e.circleFilled.definition),e.debugHint=new e("debug-hint",e.circleFilled.definition),e.primitiveSquare=new e("primitive-square",{fontCharacter:"\\ea72"}),e.edit=new e("edit",{fontCharacter:"\\ea73"}),e.pencil=new e("pencil",{fontCharacter:"\\ea73"}),e.info=new e("info",{fontCharacter:"\\ea74"}),e.issueOpened=new e("issue-opened",{fontCharacter:"\\ea74"}),e.gistPrivate=new e("gist-private",{fontCharacter:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{fontCharacter:"\\ea75"}),e.lock=new e("lock",{fontCharacter:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{fontCharacter:"\\ea75"}),e.close=new e("close",{fontCharacter:"\\ea76"}),e.removeClose=new e("remove-close",{fontCharacter:"\\ea76"}),e.x=new e("x",{fontCharacter:"\\ea76"}),e.repoSync=new e("repo-sync",{fontCharacter:"\\ea77"}),e.sync=new e("sync",{fontCharacter:"\\ea77"}),e.clone=new e("clone",{fontCharacter:"\\ea78"}),e.desktopDownload=new e("desktop-download",{fontCharacter:"\\ea78"}),e.beaker=new e("beaker",{fontCharacter:"\\ea79"}),e.microscope=new e("microscope",{fontCharacter:"\\ea79"}),e.vm=new e("vm",{fontCharacter:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{fontCharacter:"\\ea7a"}),e.file=new e("file",{fontCharacter:"\\ea7b"}),e.fileText=new e("file-text",{fontCharacter:"\\ea7b"}),e.more=new e("more",{fontCharacter:"\\ea7c"}),e.ellipsis=new e("ellipsis",{fontCharacter:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{fontCharacter:"\\ea7c"}),e.mailReply=new e("mail-reply",{fontCharacter:"\\ea7d"}),e.reply=new e("reply",{fontCharacter:"\\ea7d"}),e.organization=new e("organization",{fontCharacter:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{fontCharacter:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{fontCharacter:"\\ea7e"}),e.newFile=new e("new-file",{fontCharacter:"\\ea7f"}),e.fileAdd=new e("file-add",{fontCharacter:"\\ea7f"}),e.newFolder=new e("new-folder",{fontCharacter:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{fontCharacter:"\\ea80"}),e.trash=new e("trash",{fontCharacter:"\\ea81"}),e.trashcan=new e("trashcan",{fontCharacter:"\\ea81"}),e.history=new e("history",{fontCharacter:"\\ea82"}),e.clock=new e("clock",{fontCharacter:"\\ea82"}),e.folder=new e("folder",{fontCharacter:"\\ea83"}),e.fileDirectory=new e("file-directory",{fontCharacter:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{fontCharacter:"\\ea83"}),e.logoGithub=new e("logo-github",{fontCharacter:"\\ea84"}),e.markGithub=new e("mark-github",{fontCharacter:"\\ea84"}),e.github=new e("github",{fontCharacter:"\\ea84"}),e.terminal=new e("terminal",{fontCharacter:"\\ea85"}),e.console=new e("console",{fontCharacter:"\\ea85"}),e.repl=new e("repl",{fontCharacter:"\\ea85"}),e.zap=new e("zap",{fontCharacter:"\\ea86"}),e.symbolEvent=new e("symbol-event",{fontCharacter:"\\ea86"}),e.error=new e("error",{fontCharacter:"\\ea87"}),e.stop=new e("stop",{fontCharacter:"\\ea87"}),e.variable=new e("variable",{fontCharacter:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{fontCharacter:"\\ea88"}),e.array=new e("array",{fontCharacter:"\\ea8a"}),e.symbolArray=new e("symbol-array",{fontCharacter:"\\ea8a"}),e.symbolModule=new e("symbol-module",{fontCharacter:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{fontCharacter:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{fontCharacter:"\\ea8b"}),e.symbolObject=new e("symbol-object",{fontCharacter:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{fontCharacter:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{fontCharacter:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{fontCharacter:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{fontCharacter:"\\ea8f"}),e.symbolNull=new e("symbol-null",{fontCharacter:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{fontCharacter:"\\ea90"}),e.symbolNumber=new e("symbol-number",{fontCharacter:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{fontCharacter:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{fontCharacter:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{fontCharacter:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{fontCharacter:"\\ea92"}),e.symbolKey=new e("symbol-key",{fontCharacter:"\\ea93"}),e.symbolText=new e("symbol-text",{fontCharacter:"\\ea93"}),e.symbolReference=new e("symbol-reference",{fontCharacter:"\\ea94"}),e.goToFile=new e("go-to-file",{fontCharacter:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{fontCharacter:"\\ea95"}),e.symbolValue=new e("symbol-value",{fontCharacter:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{fontCharacter:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{fontCharacter:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{fontCharacter:"\\ea97"}),e.archive=new e("archive",{fontCharacter:"\\ea98"}),e.arrowBoth=new e("arrow-both",{fontCharacter:"\\ea99"}),e.arrowDown=new e("arrow-down",{fontCharacter:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{fontCharacter:"\\ea9b"}),e.arrowRight=new e("arrow-right",{fontCharacter:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{fontCharacter:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{fontCharacter:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{fontCharacter:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{fontCharacter:"\\eaa0"}),e.arrowUp=new e("arrow-up",{fontCharacter:"\\eaa1"}),e.bell=new e("bell",{fontCharacter:"\\eaa2"}),e.bold=new e("bold",{fontCharacter:"\\eaa3"}),e.book=new e("book",{fontCharacter:"\\eaa4"}),e.bookmark=new e("bookmark",{fontCharacter:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{fontCharacter:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),e.briefcase=new e("briefcase",{fontCharacter:"\\eaac"}),e.broadcast=new e("broadcast",{fontCharacter:"\\eaad"}),e.browser=new e("browser",{fontCharacter:"\\eaae"}),e.bug=new e("bug",{fontCharacter:"\\eaaf"}),e.calendar=new e("calendar",{fontCharacter:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{fontCharacter:"\\eab1"}),e.check=new e("check",{fontCharacter:"\\eab2"}),e.checklist=new e("checklist",{fontCharacter:"\\eab3"}),e.chevronDown=new e("chevron-down",{fontCharacter:"\\eab4"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition),e.chevronLeft=new e("chevron-left",{fontCharacter:"\\eab5"}),e.chevronRight=new e("chevron-right",{fontCharacter:"\\eab6"}),e.chevronUp=new e("chevron-up",{fontCharacter:"\\eab7"}),e.chromeClose=new e("chrome-close",{fontCharacter:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{fontCharacter:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{fontCharacter:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{fontCharacter:"\\eabb"}),e.circle=new e("circle",{fontCharacter:"\\eabc"}),e.circleOutline=new e("circle-outline",e.circle.definition),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",e.circle.definition),e.circleSlash=new e("circle-slash",{fontCharacter:"\\eabd"}),e.circuitBoard=new e("circuit-board",{fontCharacter:"\\eabe"}),e.clearAll=new e("clear-all",{fontCharacter:"\\eabf"}),e.clippy=new e("clippy",{fontCharacter:"\\eac0"}),e.closeAll=new e("close-all",{fontCharacter:"\\eac1"}),e.cloudDownload=new e("cloud-download",{fontCharacter:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{fontCharacter:"\\eac3"}),e.code=new e("code",{fontCharacter:"\\eac4"}),e.collapseAll=new e("collapse-all",{fontCharacter:"\\eac5"}),e.colorMode=new e("color-mode",{fontCharacter:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{fontCharacter:"\\eac7"}),e.compareChanges=new e("compare-changes",{fontCharacter:"\\eafd"}),e.creditCard=new e("credit-card",{fontCharacter:"\\eac9"}),e.dash=new e("dash",{fontCharacter:"\\eacc"}),e.dashboard=new e("dashboard",{fontCharacter:"\\eacd"}),e.database=new e("database",{fontCharacter:"\\eace"}),e.debugContinue=new e("debug-continue",{fontCharacter:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{fontCharacter:"\\ead0"}),e.debugPause=new e("debug-pause",{fontCharacter:"\\ead1"}),e.debugRestart=new e("debug-restart",{fontCharacter:"\\ead2"}),e.debugStart=new e("debug-start",{fontCharacter:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{fontCharacter:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{fontCharacter:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{fontCharacter:"\\ead6"}),e.debugStop=new e("debug-stop",{fontCharacter:"\\ead7"}),e.debug=new e("debug",{fontCharacter:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{fontCharacter:"\\ead9"}),e.deviceCamera=new e("device-camera",{fontCharacter:"\\eada"}),e.deviceMobile=new e("device-mobile",{fontCharacter:"\\eadb"}),e.diffAdded=new e("diff-added",{fontCharacter:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{fontCharacter:"\\eadd"}),e.diffModified=new e("diff-modified",{fontCharacter:"\\eade"}),e.diffRemoved=new e("diff-removed",{fontCharacter:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{fontCharacter:"\\eae0"}),e.diff=new e("diff",{fontCharacter:"\\eae1"}),e.discard=new e("discard",{fontCharacter:"\\eae2"}),e.editorLayout=new e("editor-layout",{fontCharacter:"\\eae3"}),e.emptyWindow=new e("empty-window",{fontCharacter:"\\eae4"}),e.exclude=new e("exclude",{fontCharacter:"\\eae5"}),e.extensions=new e("extensions",{fontCharacter:"\\eae6"}),e.eyeClosed=new e("eye-closed",{fontCharacter:"\\eae7"}),e.fileBinary=new e("file-binary",{fontCharacter:"\\eae8"}),e.fileCode=new e("file-code",{fontCharacter:"\\eae9"}),e.fileMedia=new e("file-media",{fontCharacter:"\\eaea"}),e.filePdf=new e("file-pdf",{fontCharacter:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{fontCharacter:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{fontCharacter:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{fontCharacter:"\\eaee"}),e.fileZip=new e("file-zip",{fontCharacter:"\\eaef"}),e.files=new e("files",{fontCharacter:"\\eaf0"}),e.filter=new e("filter",{fontCharacter:"\\eaf1"}),e.flame=new e("flame",{fontCharacter:"\\eaf2"}),e.foldDown=new e("fold-down",{fontCharacter:"\\eaf3"}),e.foldUp=new e("fold-up",{fontCharacter:"\\eaf4"}),e.fold=new e("fold",{fontCharacter:"\\eaf5"}),e.folderActive=new e("folder-active",{fontCharacter:"\\eaf6"}),e.folderOpened=new e("folder-opened",{fontCharacter:"\\eaf7"}),e.gear=new e("gear",{fontCharacter:"\\eaf8"}),e.gift=new e("gift",{fontCharacter:"\\eaf9"}),e.gistSecret=new e("gist-secret",{fontCharacter:"\\eafa"}),e.gist=new e("gist",{fontCharacter:"\\eafb"}),e.gitCommit=new e("git-commit",{fontCharacter:"\\eafc"}),e.gitCompare=new e("git-compare",{fontCharacter:"\\eafd"}),e.gitMerge=new e("git-merge",{fontCharacter:"\\eafe"}),e.githubAction=new e("github-action",{fontCharacter:"\\eaff"}),e.githubAlt=new e("github-alt",{fontCharacter:"\\eb00"}),e.globe=new e("globe",{fontCharacter:"\\eb01"}),e.grabber=new e("grabber",{fontCharacter:"\\eb02"}),e.graph=new e("graph",{fontCharacter:"\\eb03"}),e.gripper=new e("gripper",{fontCharacter:"\\eb04"}),e.heart=new e("heart",{fontCharacter:"\\eb05"}),e.home=new e("home",{fontCharacter:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{fontCharacter:"\\eb07"}),e.hubot=new e("hubot",{fontCharacter:"\\eb08"}),e.inbox=new e("inbox",{fontCharacter:"\\eb09"}),e.issueClosed=new e("issue-closed",{fontCharacter:"\\eba4"}),e.issueReopened=new e("issue-reopened",{fontCharacter:"\\eb0b"}),e.issues=new e("issues",{fontCharacter:"\\eb0c"}),e.italic=new e("italic",{fontCharacter:"\\eb0d"}),e.jersey=new e("jersey",{fontCharacter:"\\eb0e"}),e.json=new e("json",{fontCharacter:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{fontCharacter:"\\eb10"}),e.key=new e("key",{fontCharacter:"\\eb11"}),e.law=new e("law",{fontCharacter:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{fontCharacter:"\\eb13"}),e.linkExternal=new e("link-external",{fontCharacter:"\\eb14"}),e.link=new e("link",{fontCharacter:"\\eb15"}),e.listOrdered=new e("list-ordered",{fontCharacter:"\\eb16"}),e.listUnordered=new e("list-unordered",{fontCharacter:"\\eb17"}),e.liveShare=new e("live-share",{fontCharacter:"\\eb18"}),e.loading=new e("loading",{fontCharacter:"\\eb19"}),e.location=new e("location",{fontCharacter:"\\eb1a"}),e.mailRead=new e("mail-read",{fontCharacter:"\\eb1b"}),e.mail=new e("mail",{fontCharacter:"\\eb1c"}),e.markdown=new e("markdown",{fontCharacter:"\\eb1d"}),e.megaphone=new e("megaphone",{fontCharacter:"\\eb1e"}),e.mention=new e("mention",{fontCharacter:"\\eb1f"}),e.milestone=new e("milestone",{fontCharacter:"\\eb20"}),e.mortarBoard=new e("mortar-board",{fontCharacter:"\\eb21"}),e.move=new e("move",{fontCharacter:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{fontCharacter:"\\eb23"}),e.mute=new e("mute",{fontCharacter:"\\eb24"}),e.noNewline=new e("no-newline",{fontCharacter:"\\eb25"}),e.note=new e("note",{fontCharacter:"\\eb26"}),e.octoface=new e("octoface",{fontCharacter:"\\eb27"}),e.openPreview=new e("open-preview",{fontCharacter:"\\eb28"}),e.package_=new e("package",{fontCharacter:"\\eb29"}),e.paintcan=new e("paintcan",{fontCharacter:"\\eb2a"}),e.pin=new e("pin",{fontCharacter:"\\eb2b"}),e.play=new e("play",{fontCharacter:"\\eb2c"}),e.run=new e("run",{fontCharacter:"\\eb2c"}),e.plug=new e("plug",{fontCharacter:"\\eb2d"}),e.preserveCase=new e("preserve-case",{fontCharacter:"\\eb2e"}),e.preview=new e("preview",{fontCharacter:"\\eb2f"}),e.project=new e("project",{fontCharacter:"\\eb30"}),e.pulse=new e("pulse",{fontCharacter:"\\eb31"}),e.question=new e("question",{fontCharacter:"\\eb32"}),e.quote=new e("quote",{fontCharacter:"\\eb33"}),e.radioTower=new e("radio-tower",{fontCharacter:"\\eb34"}),e.reactions=new e("reactions",{fontCharacter:"\\eb35"}),e.references=new e("references",{fontCharacter:"\\eb36"}),e.refresh=new e("refresh",{fontCharacter:"\\eb37"}),e.regex=new e("regex",{fontCharacter:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{fontCharacter:"\\eb39"}),e.remote=new e("remote",{fontCharacter:"\\eb3a"}),e.remove=new e("remove",{fontCharacter:"\\eb3b"}),e.replaceAll=new e("replace-all",{fontCharacter:"\\eb3c"}),e.replace=new e("replace",{fontCharacter:"\\eb3d"}),e.repoClone=new e("repo-clone",{fontCharacter:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{fontCharacter:"\\eb3f"}),e.repoPull=new e("repo-pull",{fontCharacter:"\\eb40"}),e.repoPush=new e("repo-push",{fontCharacter:"\\eb41"}),e.report=new e("report",{fontCharacter:"\\eb42"}),e.requestChanges=new e("request-changes",{fontCharacter:"\\eb43"}),e.rocket=new e("rocket",{fontCharacter:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{fontCharacter:"\\eb45"}),e.rootFolder=new e("root-folder",{fontCharacter:"\\eb46"}),e.rss=new e("rss",{fontCharacter:"\\eb47"}),e.ruby=new e("ruby",{fontCharacter:"\\eb48"}),e.saveAll=new e("save-all",{fontCharacter:"\\eb49"}),e.saveAs=new e("save-as",{fontCharacter:"\\eb4a"}),e.save=new e("save",{fontCharacter:"\\eb4b"}),e.screenFull=new e("screen-full",{fontCharacter:"\\eb4c"}),e.screenNormal=new e("screen-normal",{fontCharacter:"\\eb4d"}),e.searchStop=new e("search-stop",{fontCharacter:"\\eb4e"}),e.server=new e("server",{fontCharacter:"\\eb50"}),e.settingsGear=new e("settings-gear",{fontCharacter:"\\eb51"}),e.settings=new e("settings",{fontCharacter:"\\eb52"}),e.shield=new e("shield",{fontCharacter:"\\eb53"}),e.smiley=new e("smiley",{fontCharacter:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{fontCharacter:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{fontCharacter:"\\eb56"}),e.splitVertical=new e("split-vertical",{fontCharacter:"\\eb57"}),e.squirrel=new e("squirrel",{fontCharacter:"\\eb58"}),e.starFull=new e("star-full",{fontCharacter:"\\eb59"}),e.starHalf=new e("star-half",{fontCharacter:"\\eb5a"}),e.symbolClass=new e("symbol-class",{fontCharacter:"\\eb5b"}),e.symbolColor=new e("symbol-color",{fontCharacter:"\\eb5c"}),e.symbolCustomColor=new e("symbol-customcolor",{fontCharacter:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{fontCharacter:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{fontCharacter:"\\eb5e"}),e.symbolField=new e("symbol-field",{fontCharacter:"\\eb5f"}),e.symbolFile=new e("symbol-file",{fontCharacter:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{fontCharacter:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{fontCharacter:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{fontCharacter:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{fontCharacter:"\\eb64"}),e.symbolProperty=new e("symbol-property",{fontCharacter:"\\eb65"}),e.wrench=new e("wrench",{fontCharacter:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{fontCharacter:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{fontCharacter:"\\eb66"}),e.tasklist=new e("tasklist",{fontCharacter:"\\eb67"}),e.telescope=new e("telescope",{fontCharacter:"\\eb68"}),e.textSize=new e("text-size",{fontCharacter:"\\eb69"}),e.threeBars=new e("three-bars",{fontCharacter:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{fontCharacter:"\\eb6b"}),e.thumbsup=new e("thumbsup",{fontCharacter:"\\eb6c"}),e.tools=new e("tools",{fontCharacter:"\\eb6d"}),e.triangleDown=new e("triangle-down",{fontCharacter:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{fontCharacter:"\\eb6f"}),e.triangleRight=new e("triangle-right",{fontCharacter:"\\eb70"}),e.triangleUp=new e("triangle-up",{fontCharacter:"\\eb71"}),e.twitter=new e("twitter",{fontCharacter:"\\eb72"}),e.unfold=new e("unfold",{fontCharacter:"\\eb73"}),e.unlock=new e("unlock",{fontCharacter:"\\eb74"}),e.unmute=new e("unmute",{fontCharacter:"\\eb75"}),e.unverified=new e("unverified",{fontCharacter:"\\eb76"}),e.verified=new e("verified",{fontCharacter:"\\eb77"}),e.versions=new e("versions",{fontCharacter:"\\eb78"}),e.vmActive=new e("vm-active",{fontCharacter:"\\eb79"}),e.vmOutline=new e("vm-outline",{fontCharacter:"\\eb7a"}),e.vmRunning=new e("vm-running",{fontCharacter:"\\eb7b"}),e.watch=new e("watch",{fontCharacter:"\\eb7c"}),e.whitespace=new e("whitespace",{fontCharacter:"\\eb7d"}),e.wholeWord=new e("whole-word",{fontCharacter:"\\eb7e"}),e.window=new e("window",{fontCharacter:"\\eb7f"}),e.wordWrap=new e("word-wrap",{fontCharacter:"\\eb80"}),e.zoomIn=new e("zoom-in",{fontCharacter:"\\eb81"}),e.zoomOut=new e("zoom-out",{fontCharacter:"\\eb82"}),e.listFilter=new e("list-filter",{fontCharacter:"\\eb83"}),e.listFlat=new e("list-flat",{fontCharacter:"\\eb84"}),e.listSelection=new e("list-selection",{fontCharacter:"\\eb85"}),e.selection=new e("selection",{fontCharacter:"\\eb85"}),e.listTree=new e("list-tree",{fontCharacter:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{fontCharacter:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{fontCharacter:"\\eb89"}),e.circleSmallFilled=new e("circle-small-filled",{fontCharacter:"\\eb8a"}),e.debugStackframeDot=new e("debug-stackframe-dot",e.circleSmallFilled.definition),e.debugStackframe=new e("debug-stackframe",{fontCharacter:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),e.symbolString=new e("symbol-string",{fontCharacter:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{fontCharacter:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{fontCharacter:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{fontCharacter:"\\eb90"}),e.callIncoming=new e("call-incoming",{fontCharacter:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{fontCharacter:"\\eb93"}),e.menu=new e("menu",{fontCharacter:"\\eb94"}),e.expandAll=new e("expand-all",{fontCharacter:"\\eb95"}),e.feedback=new e("feedback",{fontCharacter:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{fontCharacter:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),e.account=new e("account",{fontCharacter:"\\eb99"}),e.bellDot=new e("bell-dot",{fontCharacter:"\\eb9a"}),e.debugConsole=new e("debug-console",{fontCharacter:"\\eb9b"}),e.library=new e("library",{fontCharacter:"\\eb9c"}),e.output=new e("output",{fontCharacter:"\\eb9d"}),e.runAll=new e("run-all",{fontCharacter:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{fontCharacter:"\\eb9f"}),e.pinned=new e("pinned",{fontCharacter:"\\eba0"}),e.githubInverted=new e("github-inverted",{fontCharacter:"\\eba1"}),e.debugAlt=new e("debug-alt",{fontCharacter:"\\eb91"}),e.serverProcess=new e("server-process",{fontCharacter:"\\eba2"}),e.serverEnvironment=new e("server-environment",{fontCharacter:"\\eba3"}),e.pass=new e("pass",{fontCharacter:"\\eba4"}),e.stopCircle=new e("stop-circle",{fontCharacter:"\\eba5"}),e.playCircle=new e("play-circle",{fontCharacter:"\\eba6"}),e.record=new e("record",{fontCharacter:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{fontCharacter:"\\eba8"}),e.vmConnect=new e("vm-connect",{fontCharacter:"\\eba9"}),e.cloud=new e("cloud",{fontCharacter:"\\ebaa"}),e.merge=new e("merge",{fontCharacter:"\\ebab"}),e.exportIcon=new e("export",{fontCharacter:"\\ebac"}),e.graphLeft=new e("graph-left",{fontCharacter:"\\ebad"}),e.magnet=new e("magnet",{fontCharacter:"\\ebae"}),e.notebook=new e("notebook",{fontCharacter:"\\ebaf"}),e.redo=new e("redo",{fontCharacter:"\\ebb0"}),e.checkAll=new e("check-all",{fontCharacter:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{fontCharacter:"\\ebb2"}),e.passFilled=new e("pass-filled",{fontCharacter:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{fontCharacter:"\\ebb4"}),e.circleLarge=new e("circle-large",{fontCharacter:"\\ebb5"}),e.circleLargeOutline=new e("circle-large-outline",e.circleLarge.definition),e.combine=new e("combine",{fontCharacter:"\\ebb6"}),e.gather=new e("gather",{fontCharacter:"\\ebb6"}),e.table=new e("table",{fontCharacter:"\\ebb7"}),e.variableGroup=new e("variable-group",{fontCharacter:"\\ebb8"}),e.typeHierarchy=new e("type-hierarchy",{fontCharacter:"\\ebb9"}),e.typeHierarchySub=new e("type-hierarchy-sub",{fontCharacter:"\\ebba"}),e.typeHierarchySuper=new e("type-hierarchy-super",{fontCharacter:"\\ebbb"}),e.gitPullRequestCreate=new e("git-pull-request-create",{fontCharacter:"\\ebbc"}),e.runAbove=new e("run-above",{fontCharacter:"\\ebbd"}),e.runBelow=new e("run-below",{fontCharacter:"\\ebbe"}),e.notebookTemplate=new e("notebook-template",{fontCharacter:"\\ebbf"}),e.debugRerun=new e("debug-rerun",{fontCharacter:"\\ebc0"}),e.workspaceTrusted=new e("workspace-trusted",{fontCharacter:"\\ebc1"}),e.workspaceUntrusted=new e("workspace-untrusted",{fontCharacter:"\\ebc2"}),e.workspaceUnspecified=new e("workspace-unspecified",{fontCharacter:"\\ebc3"}),e.terminalCmd=new e("terminal-cmd",{fontCharacter:"\\ebc4"}),e.terminalDebian=new e("terminal-debian",{fontCharacter:"\\ebc5"}),e.terminalLinux=new e("terminal-linux",{fontCharacter:"\\ebc6"}),e.terminalPowershell=new e("terminal-powershell",{fontCharacter:"\\ebc7"}),e.terminalTmux=new e("terminal-tmux",{fontCharacter:"\\ebc8"}),e.terminalUbuntu=new e("terminal-ubuntu",{fontCharacter:"\\ebc9"}),e.terminalBash=new e("terminal-bash",{fontCharacter:"\\ebca"}),e.arrowSwap=new e("arrow-swap",{fontCharacter:"\\ebcb"}),e.copy=new e("copy",{fontCharacter:"\\ebcc"}),e.personAdd=new e("person-add",{fontCharacter:"\\ebcd"}),e.filterFilled=new e("filter-filled",{fontCharacter:"\\ebce"}),e.wand=new e("wand",{fontCharacter:"\\ebcf"}),e.debugLineByLine=new e("debug-line-by-line",{fontCharacter:"\\ebd0"}),e.inspect=new e("inspect",{fontCharacter:"\\ebd1"}),e.layers=new e("layers",{fontCharacter:"\\ebd2"}),e.layersDot=new e("layers-dot",{fontCharacter:"\\ebd3"}),e.layersActive=new e("layers-active",{fontCharacter:"\\ebd4"}),e.compass=new e("compass",{fontCharacter:"\\ebd5"}),e.compassDot=new e("compass-dot",{fontCharacter:"\\ebd6"}),e.compassActive=new e("compass-active",{fontCharacter:"\\ebd7"}),e.azure=new e("azure",{fontCharacter:"\\ebd8"}),e.issueDraft=new e("issue-draft",{fontCharacter:"\\ebd9"}),e.gitPullRequestClosed=new e("git-pull-request-closed",{fontCharacter:"\\ebda"}),e.gitPullRequestDraft=new e("git-pull-request-draft",{fontCharacter:"\\ebdb"}),e.debugAll=new e("debug-all",{fontCharacter:"\\ebdc"}),e.debugCoverage=new e("debug-coverage",{fontCharacter:"\\ebdd"}),e.runErrors=new e("run-errors",{fontCharacter:"\\ebde"}),e.folderLibrary=new e("folder-library",{fontCharacter:"\\ebdf"}),e.debugContinueSmall=new e("debug-continue-small",{fontCharacter:"\\ebe0"}),e.beakerStop=new e("beaker-stop",{fontCharacter:"\\ebe1"}),e.graphLine=new e("graph-line",{fontCharacter:"\\ebe2"}),e.graphScatter=new e("graph-scatter",{fontCharacter:"\\ebe3"}),e.pieChart=new e("pie-chart",{fontCharacter:"\\ebe4"}),e.bracket=new e("bracket",e.json.definition),e.bracketDot=new e("bracket-dot",{fontCharacter:"\\ebe5"}),e.bracketError=new e("bracket-error",{fontCharacter:"\\ebe6"}),e.lockSmall=new e("lock-small",{fontCharacter:"\\ebe7"}),e.azureDevops=new e("azure-devops",{fontCharacter:"\\ebe8"}),e.verifiedFilled=new e("verified-filled",{fontCharacter:"\\ebe9"}),e.newLine=new e("newline",{fontCharacter:"\\ebea"}),e.layout=new e("layout",{fontCharacter:"\\ebeb"}),e.layoutActivitybarLeft=new e("layout-activitybar-left",{fontCharacter:"\\ebec"}),e.layoutActivitybarRight=new e("layout-activitybar-right",{fontCharacter:"\\ebed"}),e.layoutPanelLeft=new e("layout-panel-left",{fontCharacter:"\\ebee"}),e.layoutPanelCenter=new e("layout-panel-center",{fontCharacter:"\\ebef"}),e.layoutPanelJustify=new e("layout-panel-justify",{fontCharacter:"\\ebf0"}),e.layoutPanelRight=new e("layout-panel-right",{fontCharacter:"\\ebf1"}),e.layoutPanel=new e("layout-panel",{fontCharacter:"\\ebf2"}),e.layoutSidebarLeft=new e("layout-sidebar-left",{fontCharacter:"\\ebf3"}),e.layoutSidebarRight=new e("layout-sidebar-right",{fontCharacter:"\\ebf4"}),e.layoutStatusbar=new e("layout-statusbar",{fontCharacter:"\\ebf5"}),e.layoutMenubar=new e("layout-menubar",{fontCharacter:"\\ebf6"}),e.layoutCentered=new e("layout-centered",{fontCharacter:"\\ebf7"}),e.layoutSidebarRightOff=new e("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),e.layoutPanelOff=new e("layout-panel-off",{fontCharacter:"\\ec01"}),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),e.target=new e("target",{fontCharacter:"\\ebf8"}),e.indent=new e("indent",{fontCharacter:"\\ebf9"}),e.recordSmall=new e("record-small",{fontCharacter:"\\ebfa"}),e.errorSmall=new e("error-small",{fontCharacter:"\\ebfb"}),e.arrowCircleDown=new e("arrow-circle-down",{fontCharacter:"\\ebfc"}),e.arrowCircleLeft=new e("arrow-circle-left",{fontCharacter:"\\ebfd"}),e.arrowCircleRight=new e("arrow-circle-right",{fontCharacter:"\\ebfe"}),e.arrowCircleUp=new e("arrow-circle-up",{fontCharacter:"\\ebff"}),e.heartFilled=new e("heart-filled",{fontCharacter:"\\ec04"}),e.map=new e("map",{fontCharacter:"\\ec05"}),e.mapFilled=new e("map-filled",{fontCharacter:"\\ec06"}),e.circleSmall=new e("circle-small",{fontCharacter:"\\ec07"}),e.bellSlash=new e("bell-slash",{fontCharacter:"\\ec08"}),e.bellSlashDot=new e("bell-slash-dot",{fontCharacter:"\\ec09"}),e.commentUnresolved=new e("comment-unresolved",{fontCharacter:"\\ec0a"}),e.gitPullRequestGoToChanges=new e("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),e.gitPullRequestNewChanges=new e("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),e.searchFuzzy=new e("search-fuzzy",{fontCharacter:"\\ec0d"}),e.dialogError=new e("dialog-error",e.error.definition),e.dialogWarning=new e("dialog-warning",e.warning.definition),e.dialogInfo=new e("dialog-info",e.info.definition),e.dialogClose=new e("dialog-close",e.close.definition),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.definition),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.definition),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.definition),e.treeFilterClear=new e("tree-filter-clear",e.close.definition),e.treeItemLoading=new e("tree-item-loading",e.loading.definition),e.menuSelection=new e("menu-selection",e.check.definition),e.menuSubmenu=new e("menu-submenu",e.chevronRight.definition),e.menuBarMore=new e("menubar-more",e.more.definition),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.definition),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.definition),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.definition),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.definition),e.toolBarMore=new e("toolbar-more",e.more.definition),e.quickInputBack=new e("quick-input-back",e.arrowLeft.definition);var N;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function m(p){if(p instanceof e)return["codicon","codicon-"+p.id];const t=v.exec(p.id);if(!t)return m(e.error);const[,w,u]=t,_=["codicon","codicon-"+w];return u&&_.push("codicon-modifier-"+u.substr(1)),_}f.asClassNameArray=m;function l(p){return m(p).join(" ")}f.asClassName=l;function c(p){return"."+m(p).join(".")}f.asCSSSelector=c})(N=r.CSSIcon||(r.CSSIcon={}))}),Y(X[25],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffChange=void 0;class A{constructor(N,f,v,m){this.originalStart=N,this.originalLength=f,this.modifiedStart=v,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}r.DiffChange=A}),Y(X[8],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BugIndicatingError=r.ErrorNoTelemetry=r.NotSupportedError=r.illegalState=r.illegalArgument=r.canceled=r.CancellationError=r.isCancellationError=r.transformErrorForSerialization=r.onUnexpectedExternalError=r.onUnexpectedError=r.errorHandler=r.ErrorHandler=void 0;class A{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(y){setTimeout(()=>{throw y.stack?u.isErrorNoTelemetry(y)?new u(y.message+`

`+y.stack):new Error(y.message+`

`+y.stack):y},0)}}emit(y){this.listeners.forEach(S=>{S(y)})}onUnexpectedError(y){this.unexpectedErrorHandler(y),this.emit(y)}onUnexpectedExternalError(y){this.unexpectedErrorHandler(y)}}r.ErrorHandler=A,r.errorHandler=new A;function e(L){m(L)||r.errorHandler.onUnexpectedError(L)}r.onUnexpectedError=e;function N(L){m(L)||r.errorHandler.onUnexpectedExternalError(L)}r.onUnexpectedExternalError=N;function f(L){if(L instanceof Error){const{name:y,message:S}=L,g=L.stacktrace||L.stack;return{$isError:!0,name:y,message:S,stack:g,noTelemetry:u.isErrorNoTelemetry(L)}}return L}r.transformErrorForSerialization=f;const v="Canceled";function m(L){return L instanceof l?!0:L instanceof Error&&L.name===v&&L.message===v}r.isCancellationError=m;class l extends Error{constructor(){super(v),this.name=this.message}}r.CancellationError=l;function c(){const L=new Error(v);return L.name=L.message,L}r.canceled=c;function p(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}r.illegalArgument=p;function t(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}r.illegalState=t;class w extends Error{constructor(y){super("NotSupported"),y&&(this.message=y)}}r.NotSupportedError=w;class u extends Error{constructor(y){super(y),this.name="CodeExpectedError"}static fromError(y){if(y instanceof u)return y;const S=new u;return S.message=y.message,S.stack=y.stack,S}static isErrorNoTelemetry(y){return y.name==="CodeExpectedError"}}r.ErrorNoTelemetry=u;class _ extends Error{constructor(y){super(y||"An unexpected bug occurred."),Object.setPrototypeOf(this,_.prototype);debugger}}r.BugIndicatingError=_}),Y(X[9],Z([0,1,8]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.checkAdjacentItems=r.assertFn=r.assertNever=r.ok=void 0;function e(m,l){if(!m)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}r.ok=e;function N(m,l="Unreachable"){throw new Error(l)}r.assertNever=N;function f(m){if(!m()){debugger;m(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}r.assertFn=f;function v(m,l){let c=0;for(;c<m.length-1;){const p=m[c],t=m[c+1];if(!l(p,t))return!1;c++}return!0}r.checkAdjacentItems=v}),Y(X[26],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.once=void 0;function A(e){const N=this;let f=!1,v;return function(){return f||(f=!0,v=e.apply(N,arguments)),v}}r.once=A}),Y(X[13],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Iterable=void 0;var A;(function(e){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}e.is=N;const f=Object.freeze([]);function v(){return f}e.empty=v;function*m(i){yield i}e.single=m;function l(i){return N(i)?i:m(i)}e.wrap=l;function c(i){return i||f}e.from=c;function p(i){return!i||i[Symbol.iterator]().next().done===!0}e.isEmpty=p;function t(i){return i[Symbol.iterator]().next().value}e.first=t;function w(i,o){for(const b of i)if(o(b))return!0;return!1}e.some=w;function u(i,o){for(const b of i)if(o(b))return b}e.find=u;function*_(i,o){for(const b of i)o(b)&&(yield b)}e.filter=_;function*L(i,o){let b=0;for(const h of i)yield o(h,b++)}e.map=L;function*y(...i){for(const o of i)for(const b of o)yield b}e.concat=y;function S(i,o,b){let h=b;for(const a of i)h=o(h,a);return h}e.reduce=S;function*g(i,o,b=i.length){for(o<0&&(o+=i.length),b<0?b+=i.length:b>i.length&&(b=i.length);o<b;o++)yield i[o]}e.slice=g;function s(i,o=Number.POSITIVE_INFINITY){const b=[];if(o===0)return[b,i];const h=i[Symbol.iterator]();for(let a=0;a<o;a++){const d=h.next();if(d.done)return[b,e.empty()];b.push(d.value)}return[b,{[Symbol.iterator](){return h}}]}e.consume=s})(A=r.Iterable||(r.Iterable={}))}),Y(X[27],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.KeyChord=r.KeyCodeUtils=r.IMMUTABLE_KEY_CODE_TO_CODE=r.IMMUTABLE_CODE_TO_KEY_CODE=r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=r.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,u){this._keyCodeToStr[w]=u,this._strToKeyCode[u.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const e=new A,N=new A,f=new A;r.EVENT_KEY_CODE_MAP=new Array(230),r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const v=[],m=Object.create(null),l=Object.create(null);r.IMMUTABLE_CODE_TO_KEY_CODE=[],r.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)r.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)r.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],u=[],_=[];for(const L of w){const[y,S,g,s,i,o,b,h,a,d]=L;if(_[g]||(_[g]=!0,v[g]=s,m[s]=g,l[s.toLowerCase()]=g,S&&(r.IMMUTABLE_CODE_TO_KEY_CODE[g]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(r.IMMUTABLE_KEY_CODE_TO_CODE[i]=g))),!u[i]){if(u[i]=!0,!o)throw new Error(`String representation missing for key code ${i} around scan code ${s}`);e.define(i,o),N.define(i,a||o),f.define(i,d||a||o)}b&&(r.EVENT_KEY_CODE_MAP[b]=i),h&&(r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=i)}r.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var c;(function(t){function w(g){return e.keyCodeToStr(g)}t.toString=w;function u(g){return e.strToKeyCode(g)}t.fromString=u;function _(g){return N.keyCodeToStr(g)}t.toUserSettingsUS=_;function L(g){return f.keyCodeToStr(g)}t.toUserSettingsGeneral=L;function y(g){return N.strToKeyCode(g)||f.strToKeyCode(g)}t.fromUserSettings=y;function S(g){if(g>=93&&g<=108)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(g)}t.toElectronAccelerator=S})(c=r.KeyCodeUtils||(r.KeyCodeUtils={}));function p(t,w){const u=(w&65535)<<16>>>0;return(t|u)>>>0}r.KeyChord=p}),Y(X[28],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Lazy=void 0;class A{constructor(N){this.executor=N,this._didRun=!1}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(N){this._error=N}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}r.Lazy=A}),Y(X[10],Z([0,1,26,13]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DisposableMap=r.ImmortalReference=r.SafeDisposable=r.RefCountedDisposable=r.MutableDisposable=r.Disposable=r.DisposableStore=r.toDisposable=r.combinedDisposable=r.dispose=r.isDisposable=r.markAsSingleton=r.setDisposableTracker=void 0;const N=!1;let f=null;function v(h){f=h}if(r.setDisposableTracker=v,N){const h="__is_disposable_tracked__";v(new class{trackDisposable(a){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[h]||console.log(d)},3e3)}setParent(a,d){if(a&&a!==S.None)try{a[h]=!0}catch{}}markAsDisposed(a){if(a&&a!==S.None)try{a[h]=!0}catch{}}markAsSingleton(a){}})}function m(h){return f?.trackDisposable(h),h}function l(h){f?.markAsDisposed(h)}function c(h,a){f?.setParent(h,a)}function p(h,a){if(!!f)for(const d of h)f.setParent(d,a)}function t(h){return f?.markAsSingleton(h),h}r.markAsSingleton=t;function w(h){return typeof h.dispose=="function"&&h.dispose.length===0}r.isDisposable=w;function u(h){if(e.Iterable.is(h)){const a=[];for(const d of h)if(d)try{d.dispose()}catch(C){a.push(C)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}r.dispose=u;function _(...h){const a=L(()=>u(h));return p(h,a),a}r.combinedDisposable=_;function L(h){const a=m({dispose:(0,A.once)(()=>{l(a),h()})});return a}r.toDisposable=L;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,m(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return c(a,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}r.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new y,m(this),c(this._store,this)}dispose(){l(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}r.Disposable=S,S.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var d;this._isDisposed||a===this._value||((d=this._value)===null||d===void 0||d.dispose(),a&&c(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,l(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&c(a,null),a}}r.MutableDisposable=g;class s{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}r.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(a){let d=a;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,l(this))},this}}r.SafeDisposable=i;class o{constructor(a){this.object=a}dispose(){}}r.ImmortalReference=o;class b{constructor(){this._store=new Map,this._isDisposed=!1,m(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,d,C=!1){var E;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||(E=this._store.get(a))===null||E===void 0||E.dispose(),this._store.set(a,d)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}r.DisposableMap=b}),Y(X[14],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LinkedList=void 0;class A{constructor(f){this.element=f,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class e{constructor(){this._first=A.Undefined,this._last=A.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===A.Undefined}clear(){let f=this._first;for(;f!==A.Undefined;){const v=f.next;f.prev=A.Undefined,f.next=A.Undefined,f=v}this._first=A.Undefined,this._last=A.Undefined,this._size=0}unshift(f){return this._insert(f,!1)}push(f){return this._insert(f,!0)}_insert(f,v){const m=new A(f);if(this._first===A.Undefined)this._first=m,this._last=m;else if(v){const c=this._last;this._last=m,m.prev=c,c.next=m}else{const c=this._first;this._first=m,m.next=c,c.prev=m}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(m))}}shift(){if(this._first!==A.Undefined){const f=this._first.element;return this._remove(this._first),f}}pop(){if(this._last!==A.Undefined){const f=this._last.element;return this._remove(this._last),f}}_remove(f){if(f.prev!==A.Undefined&&f.next!==A.Undefined){const v=f.prev;v.next=f.next,f.next.prev=v}else f.prev===A.Undefined&&f.next===A.Undefined?(this._first=A.Undefined,this._last=A.Undefined):f.next===A.Undefined?(this._last=this._last.prev,this._last.next=A.Undefined):f.prev===A.Undefined&&(this._first=this._first.next,this._first.prev=A.Undefined);this._size-=1}*[Symbol.iterator](){let f=this._first;for(;f!==A.Undefined;)yield f.element,f=f.next}}r.LinkedList=e}),Y(X[4],Z([0,1,23,28]),function(F,r,A,e){"use strict";var N;Object.defineProperty(r,"__esModule",{value:!0}),r.InvisibleCharacters=r.AmbiguousCharacters=r.noBreakWhitespace=r.getLeftDeleteOffset=r.singleLetterHash=r.containsUppercaseCharacter=r.startsWithUTF8BOM=r.UTF8_BOM_CHARACTER=r.isEmojiImprecise=r.isFullWidthCharacter=r.containsUnusualLineTerminators=r.UNUSUAL_LINE_TERMINATORS=r.isBasicASCII=r.containsRTL=r.getCharContainingOffset=r.prevCharLength=r.nextCharLength=r.GraphemeIterator=r.CodePointIterator=r.getNextCodePoint=r.computeCodePoint=r.isLowSurrogate=r.isHighSurrogate=r.commonSuffixLength=r.commonPrefixLength=r.startsWithIgnoreCase=r.equalsIgnoreCase=r.isUpperAsciiLetter=r.isLowerAsciiLetter=r.isAsciiDigit=r.compareSubstringIgnoreCase=r.compareIgnoreCase=r.compareSubstring=r.compare=r.lastNonWhitespaceIndex=r.getLeadingWhitespace=r.firstNonWhitespaceIndex=r.splitLines=r.regExpFlags=r.regExpLeadsToEndlessLoop=r.createRegExp=r.stripWildcards=r.convertSimple2RegExpPattern=r.rtrim=r.ltrim=r.trim=r.escapeRegExpCharacters=r.escape=r.format=r.isFalsyOrWhitespace=void 0;function f(M){return!M||typeof M!="string"?!0:M.trim().length===0}r.isFalsyOrWhitespace=f;const v=/{(\d+)}/g;function m(M,...I){return I.length===0?M:M.replace(v,function(V,$){const K=parseInt($,10);return isNaN(K)||K<0||K>=I.length?V:I[K]})}r.format=m;function l(M){return M.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}r.escape=l;function c(M){return M.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}r.escapeRegExpCharacters=c;function p(M,I=" "){const V=t(M,I);return w(V,I)}r.trim=p;function t(M,I){if(!M||!I)return M;const V=I.length;if(V===0||M.length===0)return M;let $=0;for(;M.indexOf(I,$)===$;)$=$+V;return M.substring($)}r.ltrim=t;function w(M,I){if(!M||!I)return M;const V=I.length,$=M.length;if(V===0||$===0)return M;let K=$,re=-1;for(;re=M.lastIndexOf(I,K-1),!(re===-1||re+V!==K);){if(re===0)return"";K=re}return M.substring(0,K)}r.rtrim=w;function u(M){return M.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}r.convertSimple2RegExpPattern=u;function _(M){return M.replace(/\*/g,"")}r.stripWildcards=_;function L(M,I,V={}){if(!M)throw new Error("Cannot create regex from empty string");I||(M=c(M)),V.wholeWord&&(/\B/.test(M.charAt(0))||(M="\\b"+M),/\B/.test(M.charAt(M.length-1))||(M=M+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(M,$)}r.createRegExp=L;function y(M){return M.source==="^"||M.source==="^$"||M.source==="$"||M.source==="^\\s*$"?!1:!!(M.exec("")&&M.lastIndex===0)}r.regExpLeadsToEndlessLoop=y;function S(M){return(M.global?"g":"")+(M.ignoreCase?"i":"")+(M.multiline?"m":"")+(M.unicode?"u":"")}r.regExpFlags=S;function g(M){return M.split(/\r\n|\r|\n/)}r.splitLines=g;function s(M){for(let I=0,V=M.length;I<V;I++){const $=M.charCodeAt(I);if($!==32&&$!==9)return I}return-1}r.firstNonWhitespaceIndex=s;function i(M,I=0,V=M.length){for(let $=I;$<V;$++){const K=M.charCodeAt($);if(K!==32&&K!==9)return M.substring(I,$)}return M.substring(I,V)}r.getLeadingWhitespace=i;function o(M,I=M.length-1){for(let V=I;V>=0;V--){const $=M.charCodeAt(V);if($!==32&&$!==9)return V}return-1}r.lastNonWhitespaceIndex=o;function b(M,I){return M<I?-1:M>I?1:0}r.compare=b;function h(M,I,V=0,$=M.length,K=0,re=I.length){for(;V<$&&K<re;V++,K++){const fe=M.charCodeAt(V),ie=I.charCodeAt(K);if(fe<ie)return-1;if(fe>ie)return 1}const oe=$-V,be=re-K;return oe<be?-1:oe>be?1:0}r.compareSubstring=h;function a(M,I){return d(M,I,0,M.length,0,I.length)}r.compareIgnoreCase=a;function d(M,I,V=0,$=M.length,K=0,re=I.length){for(;V<$&&K<re;V++,K++){let fe=M.charCodeAt(V),ie=I.charCodeAt(K);if(fe===ie)continue;if(fe>=128||ie>=128)return h(M.toLowerCase(),I.toLowerCase(),V,$,K,re);E(fe)&&(fe-=32),E(ie)&&(ie-=32);const ce=fe-ie;if(ce!==0)return ce}const oe=$-V,be=re-K;return oe<be?-1:oe>be?1:0}r.compareSubstringIgnoreCase=d;function C(M){return M>=48&&M<=57}r.isAsciiDigit=C;function E(M){return M>=97&&M<=122}r.isLowerAsciiLetter=E;function R(M){return M>=65&&M<=90}r.isUpperAsciiLetter=R;function D(M,I){return M.length===I.length&&d(M,I)===0}r.equalsIgnoreCase=D;function P(M,I){const V=I.length;return I.length>M.length?!1:d(M,I,0,V)===0}r.startsWithIgnoreCase=P;function O(M,I){const V=Math.min(M.length,I.length);let $;for($=0;$<V;$++)if(M.charCodeAt($)!==I.charCodeAt($))return $;return V}r.commonPrefixLength=O;function W(M,I){const V=Math.min(M.length,I.length);let $;const K=M.length-1,re=I.length-1;for($=0;$<V;$++)if(M.charCodeAt(K-$)!==I.charCodeAt(re-$))return $;return V}r.commonSuffixLength=W;function H(M){return 55296<=M&&M<=56319}r.isHighSurrogate=H;function q(M){return 56320<=M&&M<=57343}r.isLowSurrogate=q;function k(M,I){return(M-55296<<10)+(I-56320)+65536}r.computeCodePoint=k;function U(M,I,V){const $=M.charCodeAt(V);if(H($)&&V+1<I){const K=M.charCodeAt(V+1);if(q(K))return k($,K)}return $}r.getNextCodePoint=U;function T(M,I){const V=M.charCodeAt(I-1);if(q(V)&&I>1){const $=M.charCodeAt(I-2);if(H($))return k($,V)}return V}class B{get offset(){return this._offset}constructor(I,V=0){this._str=I,this._len=I.length,this._offset=V}setOffset(I){this._offset=I}prevCodePoint(){const I=T(this._str,this._offset);return this._offset-=I>=65536?2:1,I}nextCodePoint(){const I=U(this._str,this._len,this._offset);return this._offset+=I>=65536?2:1,I}eol(){return this._offset>=this._len}}r.CodePointIterator=B;class z{get offset(){return this._iterator.offset}constructor(I,V=0){this._iterator=new B(I,V)}nextGraphemeLength(){const I=ne.getInstance(),V=this._iterator,$=V.offset;let K=I.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const re=V.offset,oe=I.getGraphemeBreakType(V.nextCodePoint());if(te(K,oe)){V.setOffset(re);break}K=oe}return V.offset-$}prevGraphemeLength(){const I=ne.getInstance(),V=this._iterator,$=V.offset;let K=I.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const re=V.offset,oe=I.getGraphemeBreakType(V.prevCodePoint());if(te(oe,K)){V.setOffset(re);break}K=oe}return $-V.offset}eol(){return this._iterator.eol()}}r.GraphemeIterator=z;function n(M,I){return new z(M,I).nextGraphemeLength()}r.nextCharLength=n;function ae(M,I){return new z(M,I).prevGraphemeLength()}r.prevCharLength=ae;function de(M,I){I>0&&q(M.charCodeAt(I))&&I--;const V=I+n(M,I);return[V-ae(M,V),V]}r.getCharContainingOffset=de;let ge;function Le(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(M){return ge||(ge=Le()),ge.test(M)}r.containsRTL=ye;const Se=/^[\t\n\r\x20-\x7E]*$/;function Ae(M){return Se.test(M)}r.isBasicASCII=Ae,r.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(M){return r.UNUSUAL_LINE_TERMINATORS.test(M)}r.containsUnusualLineTerminators=J;function j(M){return M>=11904&&M<=55215||M>=63744&&M<=64255||M>=65281&&M<=65374}r.isFullWidthCharacter=j;function Q(M){return M>=127462&&M<=127487||M===8986||M===8987||M===9200||M===9203||M>=9728&&M<=10175||M===11088||M===11093||M>=127744&&M<=128591||M>=128640&&M<=128764||M>=128992&&M<=129008||M>=129280&&M<=129535||M>=129648&&M<=129782}r.isEmojiImprecise=Q,r.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(M){return!!(M&&M.length>0&&M.charCodeAt(0)===65279)}r.startsWithUTF8BOM=G;function x(M,I=!1){return M?(I&&(M=M.replace(/\\./g,"")),M.toLowerCase()!==M):!1}r.containsUppercaseCharacter=x;function ee(M){return M=M%(2*26),M<26?String.fromCharCode(97+M):String.fromCharCode(65+M-26)}r.singleLetterHash=ee;function te(M,I){return M===0?I!==5&&I!==7:M===2&&I===3?!1:M===4||M===2||M===3||I===4||I===2||I===3?!0:!(M===8&&(I===8||I===9||I===11||I===12)||(M===11||M===9)&&(I===9||I===10)||(M===12||M===10)&&I===10||I===5||I===13||I===7||M===1||M===13&&I===14||M===6&&I===6)}class ne{static getInstance(){return ne._INSTANCE||(ne._INSTANCE=new ne),ne._INSTANCE}constructor(){this._data=_e()}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const V=this._data,$=V.length/3;let K=1;for(;K<=$;)if(I<V[3*K])K=2*K;else if(I>V[3*K+1])K=2*K+1;else return V[3*K+2];return 0}}ne._INSTANCE=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(M,I){if(M===0)return 0;const V=ve(M,I);if(V!==void 0)return V;const $=new B(I,M);return $.prevCodePoint(),$.offset}r.getLeftDeleteOffset=we;function ve(M,I){const V=new B(I,M);let $=V.prevCodePoint();for(;Ce($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!Q($))return;let K=V.offset;return K>0&&V.prevCodePoint()===8205&&(K=V.offset),K}function Ce(M){return 127995<=M&&M<=127999}r.noBreakWhitespace="\xA0";class ue{static getInstance(I){return ue.cache.get(Array.from(I))}static getLocales(){return ue._locales.getValue()}constructor(I){this.confusableDictionary=I}isAmbiguous(I){return this.confusableDictionary.has(I)}getPrimaryConfusable(I){return this.confusableDictionary.get(I)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r.AmbiguousCharacters=ue,N=ue,ue.ambiguousCharacterData=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.cache=new A.LRUCachedFunction(M=>{function I(ie){const ce=new Map;for(let he=0;he<ie.length;he+=2)ce.set(ie[he],ie[he+1]);return ce}function V(ie,ce){const he=new Map(ie);for(const[pe,Ne]of ce)he.set(pe,Ne);return he}function $(ie,ce){if(!ie)return ce;const he=new Map;for(const[pe,Ne]of ie)ce.has(pe)&&he.set(pe,Ne);return he}const K=N.ambiguousCharacterData.getValue();let re=M.filter(ie=>!ie.startsWith("_")&&ie in K);re.length===0&&(re=["_default"]);let oe;for(const ie of re){const ce=I(K[ie]);oe=$(oe,ce)}const be=I(K._common),fe=V(be,oe);return new ue(fe)}),ue._locales=new e.Lazy(()=>Object.keys(ue.ambiguousCharacterData.getValue()).filter(M=>!M.startsWith("_")));class me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(me.getRawData())),this._data}static isInvisibleCharacter(I){return me.getData().has(I)}static get codePoints(){return me.getData()}}r.InvisibleCharacters=me,me._data=void 0}),Y(X[29],Z([0,1,4]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StringSHA1=r.toHexString=r.stringHash=r.numberHash=r.doHash=r.hash=void 0;function e(L){return N(L,0)}r.hash=e;function N(L,y){switch(typeof L){case"object":return L===null?f(349,y):Array.isArray(L)?l(L,y):c(L,y);case"string":return m(L,y);case"boolean":return v(L,y);case"number":return f(L,y);case"undefined":return f(937,y);default:return f(617,y)}}r.doHash=N;function f(L,y){return(y<<5)-y+L|0}r.numberHash=f;function v(L,y){return f(L?433:863,y)}function m(L,y){y=f(149417,y);for(let S=0,g=L.length;S<g;S++)y=f(L.charCodeAt(S),y);return y}r.stringHash=m;function l(L,y){return y=f(104579,y),L.reduce((S,g)=>N(g,S),y)}function c(L,y){return y=f(181387,y),Object.keys(L).sort().reduce((S,g)=>(S=m(g,S),N(L[g],S)),y)}function p(L,y,S=32){const g=S-y,s=~((1<<g)-1);return(L<<y|(s&L)>>>g)>>>0}function t(L,y=0,S=L.byteLength,g=0){for(let s=0;s<S;s++)L[y+s]=g}function w(L,y,S="0"){for(;L.length<y;)L=S+L;return L}function u(L,y=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(S=>S.toString(16).padStart(2,"0")).join(""):w((L>>>0).toString(16),y/4)}r.toHexString=u;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const S=y.length;if(S===0)return;const g=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,o,b;for(i!==0?(o=i,b=-1,i=0):(o=y.charCodeAt(0),b=0);;){let h=o;if(A.isHighSurrogate(o))if(b+1<S){const a=y.charCodeAt(b+1);A.isLowSurrogate(a)?(b++,h=A.computeCodePoint(o,a)):h=65533}else{i=o;break}else A.isLowSurrogate(o)&&(h=65533);if(s=this._push(g,s,h),b++,b<S)o=y.charCodeAt(b);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(y,S,g){return g<128?y[S++]=g:g<2048?(y[S++]=192|(g&1984)>>>6,y[S++]=128|(g&63)>>>0):g<65536?(y[S++]=224|(g&61440)>>>12,y[S++]=128|(g&4032)>>>6,y[S++]=128|(g&63)>>>0):(y[S++]=240|(g&1835008)>>>18,y[S++]=128|(g&258048)>>>12,y[S++]=128|(g&4032)>>>6,y[S++]=128|(g&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,t(this._buff,this._buffLen),this._buffLen>56&&(this._step(),t(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=_._bigBlock32,S=this._buffDV;for(let C=0;C<64;C+=4)y.setUint32(C,S.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)y.setUint32(C,p(y.getUint32(C-12,!1)^y.getUint32(C-32,!1)^y.getUint32(C-56,!1)^y.getUint32(C-64,!1),1),!1);let g=this._h0,s=this._h1,i=this._h2,o=this._h3,b=this._h4,h,a,d;for(let C=0;C<80;C++)C<20?(h=s&i|~s&o,a=1518500249):C<40?(h=s^i^o,a=1859775393):C<60?(h=s&i|s&o|i&o,a=2400959708):(h=s^i^o,a=3395469782),d=p(g,5)+h+b+a+y.getUint32(C*4,!1)&4294967295,b=o,o=i,i=p(s,30),s=g,g=d;this._h0=this._h0+g&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+b&4294967295}}r.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[15],Z([0,1,25,29]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LcsDiff=r.MyArray=r.Debug=r.stringDiff=r.StringDiffSequence=void 0;class N{constructor(t){this.source=t}getElements(){const t=this.source,w=new Int32Array(t.length);for(let u=0,_=t.length;u<_;u++)w[u]=t.charCodeAt(u);return w}}r.StringDiffSequence=N;function f(p,t,w){return new c(new N(p),new N(t)).ComputeDiff(w).changes}r.stringDiff=f;class v{static Assert(t,w){if(!t)throw new Error(w)}}r.Debug=v;class m{static Copy(t,w,u,_,L){for(let y=0;y<L;y++)u[_+y]=t[w+y]}static Copy2(t,w,u,_,L){for(let y=0;y<L;y++)u[_+y]=t[w+y]}}r.MyArray=m;class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new A.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(t,w){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,w),this.m_originalCount++}AddModifiedElement(t,w){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,w),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class c{constructor(t,w,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=t,this._modifiedSequence=w;const[_,L,y]=c._getElements(t),[S,g,s]=c._getElements(w);this._hasStrings=y&&s,this._originalStringElements=_,this._originalElementsOrHash=L,this._modifiedStringElements=S,this._modifiedElementsOrHash=g,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(t){return t.length>0&&typeof t[0]=="string"}static _getElements(t){const w=t.getElements();if(c._isStringArray(w)){const u=new Int32Array(w.length);for(let _=0,L=w.length;_<L;_++)u[_]=(0,e.stringHash)(w[_],0);return[w,u,!0]}return w instanceof Int32Array?[[],w,!1]:[[],new Int32Array(w),!1]}ElementsAreEqual(t,w){return this._originalElementsOrHash[t]!==this._modifiedElementsOrHash[w]?!1:this._hasStrings?this._originalStringElements[t]===this._modifiedStringElements[w]:!0}ElementsAreStrictEqual(t,w){if(!this.ElementsAreEqual(t,w))return!1;const u=c._getStrictElement(this._originalSequence,t),_=c._getStrictElement(this._modifiedSequence,w);return u===_}static _getStrictElement(t,w){return typeof t.getStrictElement=="function"?t.getStrictElement(w):null}OriginalElementsAreEqual(t,w){return this._originalElementsOrHash[t]!==this._originalElementsOrHash[w]?!1:this._hasStrings?this._originalStringElements[t]===this._originalStringElements[w]:!0}ModifiedElementsAreEqual(t,w){return this._modifiedElementsOrHash[t]!==this._modifiedElementsOrHash[w]?!1:this._hasStrings?this._modifiedStringElements[t]===this._modifiedStringElements[w]:!0}ComputeDiff(t){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,t)}_ComputeDiff(t,w,u,_,L){const y=[!1];let S=this.ComputeDiffRecursive(t,w,u,_,y);return L&&(S=this.PrettifyChanges(S)),{quitEarly:y[0],changes:S}}ComputeDiffRecursive(t,w,u,_,L){for(L[0]=!1;t<=w&&u<=_&&this.ElementsAreEqual(t,u);)t++,u++;for(;w>=t&&_>=u&&this.ElementsAreEqual(w,_);)w--,_--;if(t>w||u>_){let o;return u<=_?(v.Assert(t===w+1,"originalStart should only be one more than originalEnd"),o=[new A.DiffChange(t,0,u,_-u+1)]):t<=w?(v.Assert(u===_+1,"modifiedStart should only be one more than modifiedEnd"),o=[new A.DiffChange(t,w-t+1,u,0)]):(v.Assert(t===w+1,"originalStart should only be one more than originalEnd"),v.Assert(u===_+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const y=[0],S=[0],g=this.ComputeRecursionPoint(t,w,u,_,y,S,L),s=y[0],i=S[0];if(g!==null)return g;if(!L[0]){const o=this.ComputeDiffRecursive(t,s,u,i,L);let b=[];return L[0]?b=[new A.DiffChange(s+1,w-(s+1)+1,i+1,_-(i+1)+1)]:b=this.ComputeDiffRecursive(s+1,w,i+1,_,L),this.ConcatenateChanges(o,b)}return[new A.DiffChange(t,w-t+1,u,_-u+1)]}WALKTRACE(t,w,u,_,L,y,S,g,s,i,o,b,h,a,d,C,E,R){let D=null,P=null,O=new l,W=w,H=u,q=h[0]-C[0]-_,k=-1073741824,U=this.m_forwardHistory.length-1;do{const T=q+t;T===W||T<H&&s[T-1]<s[T+1]?(o=s[T+1],a=o-q-_,o<k&&O.MarkNextChange(),k=o,O.AddModifiedElement(o+1,a),q=T+1-t):(o=s[T-1]+1,a=o-q-_,o<k&&O.MarkNextChange(),k=o-1,O.AddOriginalElement(o,a+1),q=T-1-t),U>=0&&(s=this.m_forwardHistory[U],t=s[0],W=1,H=s.length-1)}while(--U>=-1);if(D=O.getReverseChanges(),R[0]){let T=h[0]+1,B=C[0]+1;if(D!==null&&D.length>0){const z=D[D.length-1];T=Math.max(T,z.getOriginalEnd()),B=Math.max(B,z.getModifiedEnd())}P=[new A.DiffChange(T,b-T+1,B,d-B+1)]}else{O=new l,W=y,H=S,q=h[0]-C[0]-g,k=1073741824,U=E?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const T=q+L;T===W||T<H&&i[T-1]>=i[T+1]?(o=i[T+1]-1,a=o-q-g,o>k&&O.MarkNextChange(),k=o+1,O.AddOriginalElement(o+1,a+1),q=T+1-L):(o=i[T-1],a=o-q-g,o>k&&O.MarkNextChange(),k=o,O.AddModifiedElement(o+1,a+1),q=T-1-L),U>=0&&(i=this.m_reverseHistory[U],L=i[0],W=1,H=i.length-1)}while(--U>=-1);P=O.getChanges()}return this.ConcatenateChanges(D,P)}ComputeRecursionPoint(t,w,u,_,L,y,S){let g=0,s=0,i=0,o=0,b=0,h=0;t--,u--,L[0]=0,y[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=w-t+(_-u),d=a+1,C=new Int32Array(d),E=new Int32Array(d),R=_-u,D=w-t,P=t-u,O=w-_,H=(D-R)%2===0;C[R]=t,E[D]=w,S[0]=!1;for(let q=1;q<=a/2+1;q++){let k=0,U=0;i=this.ClipDiagonalBound(R-q,q,R,d),o=this.ClipDiagonalBound(R+q,q,R,d);for(let B=i;B<=o;B+=2){B===i||B<o&&C[B-1]<C[B+1]?g=C[B+1]:g=C[B-1]+1,s=g-(B-R)-P;const z=g;for(;g<w&&s<_&&this.ElementsAreEqual(g+1,s+1);)g++,s++;if(C[B]=g,g+s>k+U&&(k=g,U=s),!H&&Math.abs(B-D)<=q-1&&g>=E[B])return L[0]=g,y[0]=s,z<=E[B]&&1447>0&&q<=1447+1?this.WALKTRACE(R,i,o,P,D,b,h,O,C,E,g,w,L,s,_,y,H,S):null}const T=(k-t+(U-u)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(k,T))return S[0]=!0,L[0]=k,y[0]=U,T>0&&1447>0&&q<=1447+1?this.WALKTRACE(R,i,o,P,D,b,h,O,C,E,g,w,L,s,_,y,H,S):(t++,u++,[new A.DiffChange(t,w-t+1,u,_-u+1)]);b=this.ClipDiagonalBound(D-q,q,D,d),h=this.ClipDiagonalBound(D+q,q,D,d);for(let B=b;B<=h;B+=2){B===b||B<h&&E[B-1]>=E[B+1]?g=E[B+1]-1:g=E[B-1],s=g-(B-D)-O;const z=g;for(;g>t&&s>u&&this.ElementsAreEqual(g,s);)g--,s--;if(E[B]=g,H&&Math.abs(B-R)<=q&&g<=C[B])return L[0]=g,y[0]=s,z>=C[B]&&1447>0&&q<=1447+1?this.WALKTRACE(R,i,o,P,D,b,h,O,C,E,g,w,L,s,_,y,H,S):null}if(q<=1447){let B=new Int32Array(o-i+2);B[0]=R-i+1,m.Copy2(C,i,B,1,o-i+1),this.m_forwardHistory.push(B),B=new Int32Array(h-b+2),B[0]=D-b+1,m.Copy2(E,b,B,1,h-b+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(R,i,o,P,D,b,h,O,C,E,g,w,L,s,_,y,H,S)}PrettifyChanges(t){for(let w=0;w<t.length;w++){const u=t[w],_=w<t.length-1?t[w+1].originalStart:this._originalElementsOrHash.length,L=w<t.length-1?t[w+1].modifiedStart:this._modifiedElementsOrHash.length,y=u.originalLength>0,S=u.modifiedLength>0;for(;u.originalStart+u.originalLength<_&&u.modifiedStart+u.modifiedLength<L&&(!y||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!S||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const s=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!s)break;u.originalStart++,u.modifiedStart++}const g=[null];if(w<t.length-1&&this.ChangesOverlap(t[w],t[w+1],g)){t[w]=g[0],t.splice(w+1,1),w--;continue}}for(let w=t.length-1;w>=0;w--){const u=t[w];let _=0,L=0;if(w>0){const o=t[w-1];_=o.originalStart+o.originalLength,L=o.modifiedStart+o.modifiedLength}const y=u.originalLength>0,S=u.modifiedLength>0;let g=0,s=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let o=1;;o++){const b=u.originalStart-o,h=u.modifiedStart-o;if(b<_||h<L||y&&!this.OriginalElementsAreEqual(b,b+u.originalLength)||S&&!this.ModifiedElementsAreEqual(h,h+u.modifiedLength))break;const d=(b===_&&h===L?5:0)+this._boundaryScore(b,u.originalLength,h,u.modifiedLength);d>s&&(s=d,g=o)}u.originalStart-=g,u.modifiedStart-=g;const i=[null];if(w>0&&this.ChangesOverlap(t[w-1],t[w],i)){t[w-1]=i[0],t.splice(w,1),w++;continue}}if(this._hasStrings)for(let w=1,u=t.length;w<u;w++){const _=t[w-1],L=t[w],y=L.originalStart-_.originalStart-_.originalLength,S=_.originalStart,g=L.originalStart+L.originalLength,s=g-S,i=_.modifiedStart,o=L.modifiedStart+L.modifiedLength,b=o-i;if(y<5&&s<20&&b<20){const h=this._findBetterContiguousSequence(S,s,i,b,y);if(h){const[a,d]=h;(a!==_.originalStart+_.originalLength||d!==_.modifiedStart+_.modifiedLength)&&(_.originalLength=a-_.originalStart,_.modifiedLength=d-_.modifiedStart,L.originalStart=a+y,L.modifiedStart=d+y,L.originalLength=g-L.originalStart,L.modifiedLength=o-L.modifiedStart)}}}return t}_findBetterContiguousSequence(t,w,u,_,L){if(w<L||_<L)return null;const y=t+w-L+1,S=u+_-L+1;let g=0,s=0,i=0;for(let o=t;o<y;o++)for(let b=u;b<S;b++){const h=this._contiguousSequenceScore(o,b,L);h>0&&h>g&&(g=h,s=o,i=b)}return g>0?[s,i]:null}_contiguousSequenceScore(t,w,u){let _=0;for(let L=0;L<u;L++){if(!this.ElementsAreEqual(t+L,w+L))return 0;_+=this._originalStringElements[t+L].length}return _}_OriginalIsBoundary(t){return t<=0||t>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[t])}_OriginalRegionIsBoundary(t,w){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(w>0){const u=t+w;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(t){return t<=0||t>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[t])}_ModifiedRegionIsBoundary(t,w){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(w>0){const u=t+w;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(t,w,u,_){const L=this._OriginalRegionIsBoundary(t,w)?1:0,y=this._ModifiedRegionIsBoundary(u,_)?1:0;return L+y}ConcatenateChanges(t,w){const u=[];if(t.length===0||w.length===0)return w.length>0?w:t;if(this.ChangesOverlap(t[t.length-1],w[0],u)){const _=new Array(t.length+w.length-1);return m.Copy(t,0,_,0,t.length-1),_[t.length-1]=u[0],m.Copy(w,1,_,t.length,w.length-1),_}else{const _=new Array(t.length+w.length);return m.Copy(t,0,_,0,t.length),m.Copy(w,0,_,t.length,w.length),_}}ChangesOverlap(t,w,u){if(v.Assert(t.originalStart<=w.originalStart,"Left change is not less than or equal to right change"),v.Assert(t.modifiedStart<=w.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=w.originalStart||t.modifiedStart+t.modifiedLength>=w.modifiedStart){const _=t.originalStart;let L=t.originalLength;const y=t.modifiedStart;let S=t.modifiedLength;return t.originalStart+t.originalLength>=w.originalStart&&(L=w.originalStart+w.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=w.modifiedStart&&(S=w.modifiedStart+w.modifiedLength-t.modifiedStart),u[0]=new A.DiffChange(_,L,y,S),!0}else return u[0]=null,!1}ClipDiagonalBound(t,w,u,_){if(t>=0&&t<_)return t;const L=u,y=_-u-1,S=w%2===0;if(t<0){const g=L%2===0;return S===g?0:1}else{const g=y%2===0;return S===g?_-1:_-2}}}r.LcsDiff=c}),Y(X[30],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.withNullAsUndefined=r.validateConstraint=r.validateConstraints=r.isFunction=r.assertIsDefined=r.assertType=r.isUndefinedOrNull=r.isDefined=r.isUndefined=r.isBoolean=r.isIterable=r.isNumber=r.isTypedArray=r.isObject=r.isString=void 0;function A(S){return typeof S=="string"}r.isString=A;function e(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}r.isObject=e;function N(S){const g=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof g}r.isTypedArray=N;function f(S){return typeof S=="number"&&!isNaN(S)}r.isNumber=f;function v(S){return!!S&&typeof S[Symbol.iterator]=="function"}r.isIterable=v;function m(S){return S===!0||S===!1}r.isBoolean=m;function l(S){return typeof S>"u"}r.isUndefined=l;function c(S){return!p(S)}r.isDefined=c;function p(S){return l(S)||S===null}r.isUndefinedOrNull=p;function t(S,g){if(!S)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}r.assertType=t;function w(S){if(p(S))throw new Error("Assertion Failed: argument is undefined or null");return S}r.assertIsDefined=w;function u(S){return typeof S=="function"}r.isFunction=u;function _(S,g){const s=Math.min(S.length,g.length);for(let i=0;i<s;i++)L(S[i],g[i])}r.validateConstraints=_;function L(S,g){if(A(g)){if(typeof S!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(u(g)){try{if(S instanceof g)return}catch{}if(!p(S)&&S.constructor===g||g.length===1&&g.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}r.validateConstraint=L;function y(S){return S===null?void 0:S}r.withNullAsUndefined=y}),Y(X[11],Z([0,1,30]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createProxyObject=r.getAllMethodNames=r.getAllPropertyNames=r.equals=r.mixin=r.cloneAndChange=r.deepFreeze=r.deepClone=void 0;function e(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const _=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([L,y])=>{_[L]=y&&typeof y=="object"?e(y):y}),_}r.deepClone=e;function N(u){if(!u||typeof u!="object")return u;const _=[u];for(;_.length>0;){const L=_.shift();Object.freeze(L);for(const y in L)if(f.call(L,y)){const S=L[y];typeof S=="object"&&!Object.isFrozen(S)&&!(0,A.isTypedArray)(S)&&_.push(S)}}return u}r.deepFreeze=N;const f=Object.prototype.hasOwnProperty;function v(u,_){return m(u,_,new Set)}r.cloneAndChange=v;function m(u,_,L){if((0,A.isUndefinedOrNull)(u))return u;const y=_(u);if(typeof y<"u")return y;if(Array.isArray(u)){const S=[];for(const g of u)S.push(m(g,_,L));return S}if((0,A.isObject)(u)){if(L.has(u))throw new Error("Cannot clone recursive data-structure");L.add(u);const S={};for(const g in u)f.call(u,g)&&(S[g]=m(u[g],_,L));return L.delete(u),S}return u}function l(u,_,L=!0){return(0,A.isObject)(u)?((0,A.isObject)(_)&&Object.keys(_).forEach(y=>{y in u?L&&((0,A.isObject)(u[y])&&(0,A.isObject)(_[y])?l(u[y],_[y],L):u[y]=_[y]):u[y]=_[y]}),u):_}r.mixin=l;function c(u,_){if(u===_)return!0;if(u==null||_===null||_===void 0||typeof u!=typeof _||typeof u!="object"||Array.isArray(u)!==Array.isArray(_))return!1;let L,y;if(Array.isArray(u)){if(u.length!==_.length)return!1;for(L=0;L<u.length;L++)if(!c(u[L],_[L]))return!1}else{const S=[];for(y in u)S.push(y);S.sort();const g=[];for(y in _)g.push(y);if(g.sort(),!c(S,g))return!1;for(L=0;L<S.length;L++)if(!c(u[S[L]],_[S[L]]))return!1}return!0}r.equals=c;function p(u){let _=[],L=Object.getPrototypeOf(u);for(;Object.prototype!==L;)_=_.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return _}r.getAllPropertyNames=p;function t(u){const _=[];for(const L of p(u))typeof u[L]=="function"&&_.push(L);return _}r.getAllMethodNames=t;function w(u,_){const L=S=>function(){const g=Array.prototype.slice.call(arguments,0);return _(S,g)},y={};for(const S of u)y[S]=L(S);return y}r.createProxyObject=w}),Y(X[16],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.toUint32=r.toUint8=void 0;function A(N){return N<0?0:N>255?255:N|0}r.toUint8=A;function e(N){return N<0?0:N>4294967295?4294967295:N|0}r.toUint32=e}),Y(X[17],Z([0,1,16]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CharacterSet=r.CharacterClassifier=void 0;class e{constructor(v){const m=(0,A.toUint8)(v);this._defaultValue=m,this._asciiMap=e._createAsciiMap(m),this._map=new Map}static _createAsciiMap(v){const m=new Uint8Array(256);return m.fill(v),m}set(v,m){const l=(0,A.toUint8)(m);v>=0&&v<256?this._asciiMap[v]=l:this._map.set(v,l)}get(v){return v>=0&&v<256?this._asciiMap[v]:this._map.get(v)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}r.CharacterClassifier=e;class N{constructor(){this._actual=new e(0)}add(v){this._actual.set(v,1)}has(v){return this._actual.get(v)===1}clear(){return this._actual.clear()}}r.CharacterSet=N}),Y(X[3],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Position=void 0;class A{constructor(N,f){this.lineNumber=N,this.column=f}with(N=this.lineNumber,f=this.column){return N===this.lineNumber&&f===this.column?this:new A(N,f)}delta(N=0,f=0){return this.with(this.lineNumber+N,this.column+f)}equals(N){return A.equals(this,N)}static equals(N,f){return!N&&!f?!0:!!N&&!!f&&N.lineNumber===f.lineNumber&&N.column===f.column}isBefore(N){return A.isBefore(this,N)}static isBefore(N,f){return N.lineNumber<f.lineNumber?!0:f.lineNumber<N.lineNumber?!1:N.column<f.column}isBeforeOrEqual(N){return A.isBeforeOrEqual(this,N)}static isBeforeOrEqual(N,f){return N.lineNumber<f.lineNumber?!0:f.lineNumber<N.lineNumber?!1:N.column<=f.column}static compare(N,f){const v=N.lineNumber|0,m=f.lineNumber|0;if(v===m){const l=N.column|0,c=f.column|0;return l-c}return v-m}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(N){return new A(N.lineNumber,N.column)}static isIPosition(N){return N&&typeof N.lineNumber=="number"&&typeof N.column=="number"}}r.Position=A}),Y(X[2],Z([0,1,3]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Range=void 0;class e{constructor(f,v,m,l){f>m||f===m&&v>l?(this.startLineNumber=m,this.startColumn=l,this.endLineNumber=f,this.endColumn=v):(this.startLineNumber=f,this.startColumn=v,this.endLineNumber=m,this.endColumn=l)}isEmpty(){return e.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return e.containsPosition(this,f)}static containsPosition(f,v){return!(v.lineNumber<f.startLineNumber||v.lineNumber>f.endLineNumber||v.lineNumber===f.startLineNumber&&v.column<f.startColumn||v.lineNumber===f.endLineNumber&&v.column>f.endColumn)}static strictContainsPosition(f,v){return!(v.lineNumber<f.startLineNumber||v.lineNumber>f.endLineNumber||v.lineNumber===f.startLineNumber&&v.column<=f.startColumn||v.lineNumber===f.endLineNumber&&v.column>=f.endColumn)}containsRange(f){return e.containsRange(this,f)}static containsRange(f,v){return!(v.startLineNumber<f.startLineNumber||v.endLineNumber<f.startLineNumber||v.startLineNumber>f.endLineNumber||v.endLineNumber>f.endLineNumber||v.startLineNumber===f.startLineNumber&&v.startColumn<f.startColumn||v.endLineNumber===f.endLineNumber&&v.endColumn>f.endColumn)}strictContainsRange(f){return e.strictContainsRange(this,f)}static strictContainsRange(f,v){return!(v.startLineNumber<f.startLineNumber||v.endLineNumber<f.startLineNumber||v.startLineNumber>f.endLineNumber||v.endLineNumber>f.endLineNumber||v.startLineNumber===f.startLineNumber&&v.startColumn<=f.startColumn||v.endLineNumber===f.endLineNumber&&v.endColumn>=f.endColumn)}plusRange(f){return e.plusRange(this,f)}static plusRange(f,v){let m,l,c,p;return v.startLineNumber<f.startLineNumber?(m=v.startLineNumber,l=v.startColumn):v.startLineNumber===f.startLineNumber?(m=v.startLineNumber,l=Math.min(v.startColumn,f.startColumn)):(m=f.startLineNumber,l=f.startColumn),v.endLineNumber>f.endLineNumber?(c=v.endLineNumber,p=v.endColumn):v.endLineNumber===f.endLineNumber?(c=v.endLineNumber,p=Math.max(v.endColumn,f.endColumn)):(c=f.endLineNumber,p=f.endColumn),new e(m,l,c,p)}intersectRanges(f){return e.intersectRanges(this,f)}static intersectRanges(f,v){let m=f.startLineNumber,l=f.startColumn,c=f.endLineNumber,p=f.endColumn;const t=v.startLineNumber,w=v.startColumn,u=v.endLineNumber,_=v.endColumn;return m<t?(m=t,l=w):m===t&&(l=Math.max(l,w)),c>u?(c=u,p=_):c===u&&(p=Math.min(p,_)),m>c||m===c&&l>p?null:new e(m,l,c,p)}equalsRange(f){return e.equalsRange(this,f)}static equalsRange(f,v){return!f&&!v?!0:!!f&&!!v&&f.startLineNumber===v.startLineNumber&&f.startColumn===v.startColumn&&f.endLineNumber===v.endLineNumber&&f.endColumn===v.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(f){return new A.Position(f.endLineNumber,f.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(f){return new A.Position(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,v){return new e(this.startLineNumber,this.startColumn,f,v)}setStartPosition(f,v){return new e(f,v,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}delta(f){return new e(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static collapseToStart(f){return new e(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}static fromPositions(f,v=f){return new e(f.lineNumber,f.column,v.lineNumber,v.column)}static lift(f){return f?new e(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,v){return!(f.endLineNumber<v.startLineNumber||f.endLineNumber===v.startLineNumber&&f.endColumn<v.startColumn||v.endLineNumber<f.startLineNumber||v.endLineNumber===f.startLineNumber&&v.endColumn<f.startColumn)}static areIntersecting(f,v){return!(f.endLineNumber<v.startLineNumber||f.endLineNumber===v.startLineNumber&&f.endColumn<=v.startColumn||v.endLineNumber<f.startLineNumber||v.endLineNumber===f.startLineNumber&&v.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,v){if(f&&v){const c=f.startLineNumber|0,p=v.startLineNumber|0;if(c===p){const t=f.startColumn|0,w=v.startColumn|0;if(t===w){const u=f.endLineNumber|0,_=v.endLineNumber|0;if(u===_){const L=f.endColumn|0,y=v.endColumn|0;return L-y}return u-_}return t-w}return c-p}return(f?1:0)-(v?1:0)}static compareRangesUsingEnds(f,v){return f.endLineNumber===v.endLineNumber?f.endColumn===v.endColumn?f.startLineNumber===v.startLineNumber?f.startColumn-v.startColumn:f.startLineNumber-v.startLineNumber:f.endColumn-v.endColumn:f.endLineNumber-v.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}r.Range=e}),Y(X[31],Z([0,1,3,2]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Selection=void 0;class N extends e.Range{constructor(v,m,l,c){super(v,m,l,c),this.selectionStartLineNumber=v,this.selectionStartColumn=m,this.positionLineNumber=l,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return N.selectionsEqual(this,v)}static selectionsEqual(v,m){return v.selectionStartLineNumber===m.selectionStartLineNumber&&v.selectionStartColumn===m.selectionStartColumn&&v.positionLineNumber===m.positionLineNumber&&v.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,m){return this.getDirection()===0?new N(this.startLineNumber,this.startColumn,v,m):new N(v,m,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,m){return this.getDirection()===0?new N(v,m,this.endLineNumber,this.endColumn):new N(this.endLineNumber,this.endColumn,v,m)}static fromPositions(v,m=v){return new N(v.lineNumber,v.column,m.lineNumber,m.column)}static fromRange(v,m){return m===0?new N(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new N(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new N(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,m){if(v&&!m||!v&&m)return!1;if(!v&&!m)return!0;if(v.length!==m.length)return!1;for(let l=0,c=v.length;l<c;l++)if(!this.selectionsEqual(v[l],m[l]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,m,l,c,p){return p===0?new N(v,m,l,c):new N(l,c,v,m)}}r.Selection=N}),Y(X[32],Z([0,1,17]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getMapForWordSeparators=r.WordCharacterClassifier=void 0;class e extends A.CharacterClassifier{constructor(v){super(0);for(let m=0,l=v.length;m<l;m++)this.set(v.charCodeAt(m),2);this.set(32,1),this.set(9,1)}}r.WordCharacterClassifier=e;function N(f){const v={};return m=>(v.hasOwnProperty(m)||(v[m]=f(m)),v[m])}r.getMapForWordSeparators=N(f=>new e(f))}),Y(X[18],Z([0,1,13,14]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getWordAtText=r.ensureValidWordDefinition=r.DEFAULT_WORD_REGEXP=r.USUAL_WORD_SEPARATORS=void 0,r.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function N(c=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const t of r.USUAL_WORD_SEPARATORS)c.indexOf(t)>=0||(p+="\\"+t);return p+="\\s]+)",new RegExp(p,"g")}r.DEFAULT_WORD_REGEXP=N();function f(c){let p=r.DEFAULT_WORD_REGEXP;if(c&&c instanceof RegExp)if(c.global)p=c;else{let t="g";c.ignoreCase&&(t+="i"),c.multiline&&(t+="m"),c.unicode&&(t+="u"),p=new RegExp(c.source,t)}return p.lastIndex=0,p}r.ensureValidWordDefinition=f;const v=new e.LinkedList;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(c,p,t,w,u){if(u||(u=A.Iterable.first(v)),t.length>u.maxLen){let g=c-u.maxLen/2;return g<0?g=0:w+=g,t=t.substring(g,c+u.maxLen/2),m(c,p,t,w,u)}const _=Date.now(),L=c-1-w;let y=-1,S=null;for(let g=1;!(Date.now()-_>=u.timeBudget);g++){const s=L-u.windowSize*g;p.lastIndex=Math.max(0,s);const i=l(p,t,L,y);if(!i&&S||(S=i,s<=0))break;y=s}if(S){const g={word:S[0],startColumn:w+1+S.index,endColumn:w+1+S.index+S[0].length};return p.lastIndex=0,g}return null}r.getWordAtText=m;function l(c,p,t,w){let u;for(;u=c.exec(p);){const _=u.index||0;if(_<=t&&c.lastIndex>=t)return u;if(w>0&&_>w)return null}return null}}),Y(X[6],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.SequenceFromIntArray=r.OffsetRange=r.SequenceDiff=void 0;class A{constructor(v,m){this.seq1Range=v,this.seq2Range=m}reverse(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}r.SequenceDiff=A;class e{constructor(v,m){this.start=v,this.endExclusive=m}get isEmpty(){return this.start===this.endExclusive}delta(v){return new e(this.start+v,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}}r.OffsetRange=e;class N{constructor(v){this.arr=v}getElement(v){return this.arr[v]}get length(){return this.arr.length}}r.SequenceFromIntArray=N}),Y(X[33],Z([0,1,6]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shiftSequenceDiffs=r.joinSequenceDiffs=r.optimizeSequenceDiffs=void 0;function e(m,l,c){let p=c;return p=N(m,l,p),p=f(m,l,p),p}r.optimizeSequenceDiffs=e;function N(m,l,c){const p=[];c.length>0&&p.push(c[0]);for(let t=1;t<c.length;t++){const w=p[p.length-1],u=c[t];if(u.seq1Range.isEmpty){let _=!0;const L=u.seq1Range.start-w.seq1Range.endExclusive;for(let y=1;y<=L;y++)if(l.getElement(u.seq2Range.start-y)!==l.getElement(u.seq2Range.endExclusive-y)){_=!1;break}if(_){p[p.length-1]=new A.SequenceDiff(w.seq1Range,new A.OffsetRange(w.seq2Range.start,u.seq2Range.endExclusive-L));continue}}p.push(u)}return p}r.joinSequenceDiffs=N;function f(m,l,c){if(!m.getBoundaryScore||!l.getBoundaryScore)return c;for(let p=0;p<c.length;p++){const t=c[p];if(t.seq1Range.isEmpty){const w=p>0?c[p-1].seq2Range.endExclusive:-1,u=p+1<c.length?c[p+1].seq2Range.start:l.length+1;c[p]=v(t,m,l,u,w)}else if(t.seq2Range.isEmpty){const w=p>0?c[p-1].seq1Range.endExclusive:-1,u=p+1<c.length?c[p+1].seq1Range.start:m.length+1;c[p]=v(t.reverse(),l,m,u,w).reverse()}}return c}r.shiftSequenceDiffs=f;function v(m,l,c,p,t){let u=1;for(;m.seq1Range.start-u>t&&c.getElement(m.seq2Range.start-u)===c.getElement(m.seq2Range.endExclusive-u)&&u<20;)u++;u--;let _=1;for(;m.seq1Range.start+_<p&&c.getElement(m.seq2Range.start+_)===c.getElement(m.seq2Range.endExclusive+_)&&_<20;)_++;_--;let L=0,y=-1;for(let S=-u;S<_;S++){const g=m.seq2Range.start+S,s=m.seq2Range.endExclusive+S,i=m.seq1Range.start+S,o=l.getBoundaryScore(i)+c.getBoundaryScore(g)+c.getBoundaryScore(s);o>y&&(y=o,L=S)}return L!==0?new A.SequenceDiff(m.seq1Range.delta(L),m.seq2Range.delta(L)):m}}),Y(X[34],Z([0,1,6]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MyersDiffAlgorithm=void 0;class e{compute(l,c){if(l.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,0),new A.OffsetRange(0,c.length))];if(c.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,l.length),new A.OffsetRange(0,0))];function p(s,i){for(;s<l.length&&i<c.length&&l.getElement(s)===c.getElement(i);)s++,i++;return s}let t=0;const w=new f;w.set(0,p(0,0));const u=new v;u.set(0,w.get(0)===0?null:new N(null,0,0,w.get(0)));let _=0;e:for(;;)for(t++,_=-t;_<=t;_+=2){const s=_===t?-1:w.get(_+1),i=_===-t?-1:w.get(_-1)+1,o=Math.min(Math.max(s,i),l.length),b=o-_,h=p(o,b);w.set(_,h);const a=o===s?u.get(_+1):u.get(_-1);if(u.set(_,h!==o?new N(a,o,b,h-o):a),w.get(_)===l.length&&w.get(_)-_===c.length)break e}let L=u.get(_);const y=[];let S=l.length,g=c.length;for(;;){const s=L?L.x+L.length:0,i=L?L.y+L.length:0;if((s!==S||i!==g)&&y.push(new A.SequenceDiff(new A.OffsetRange(s,S),new A.OffsetRange(i,g))),!L)break;S=L.x,g=L.y,L=L.prev}return y.reverse(),y}}r.MyersDiffAlgorithm=e;class N{constructor(l,c,p,t){this.prev=l,this.x=c,this.y=p,this.length=t}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,c){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const p=this.negativeArr;this.negativeArr=new Int32Array(p.length*2),this.negativeArr.set(p)}this.negativeArr[l]=c}else{if(l>=this.positiveArr.length){const p=this.positiveArr;this.positiveArr=new Int32Array(p.length*2),this.positiveArr.set(p)}this.positiveArr[l]=c}}}class v{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,c){l<0?(l=-l-1,this.negativeArr[l]=c):this.positiveArr[l]=c}}}),Y(X[35],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Array2D=void 0;class A{constructor(N,f){this.width=N,this.height=f,this.array=[],this.array=new Array(N*f)}get(N,f){return this.array[N+f*this.width]}set(N,f,v){this.array[N+f*this.width]=v}}r.Array2D=A}),Y(X[36],Z([0,1,6,35]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DynamicProgrammingDiffing=void 0;class N{compute(v,m,l){const c=new e.Array2D(v.length,m.length),p=new e.Array2D(v.length,m.length),t=new e.Array2D(v.length,m.length);for(let g=0;g<v.length;g++)for(let s=0;s<m.length;s++){const i=g===0?0:c.get(g-1,s),o=s===0?0:c.get(g,s-1);let b;v.getElement(g)===m.getElement(s)?(g===0||s===0?b=0:b=c.get(g-1,s-1),g>0&&s>0&&p.get(g-1,s-1)===3&&(b+=.1),b+=l?l(g,s):1):b=-1;const h=Math.max(i,o,b);if(h===b){const a=g>0&&s>0?t.get(g-1,s-1):0;t.set(g,s,a+1),p.set(g,s,3)}else h===i?(t.set(g,s,0),p.set(g,s,1)):h===o&&(t.set(g,s,0),p.set(g,s,2));c.set(g,s,h)}const w=[];let u=v.length,_=m.length;function L(g,s){(g+1!==u||s+1!==_)&&w.push(new A.SequenceDiff(new A.OffsetRange(g+1,u),new A.OffsetRange(s+1,_))),u=g,_=s}let y=v.length-1,S=m.length-1;for(;y>=0&&S>=0;)p.get(y,S)===3?(L(y,S),y--,S--):p.get(y,S)===1?y--:S--;return L(-1,-1),w.reverse(),w}}r.DynamicProgrammingDiffing=N}),Y(X[19],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LineRange=r.RangeMapping=r.LineRangeMapping=void 0;class A{constructor(v,m,l){this.originalRange=v,this.modifiedRange=m,this.innerChanges=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.LineRangeMapping=A;class e{constructor(v,m){this.originalRange=v,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.RangeMapping=e;class N{constructor(v,m){this.startLineNumber=v,this.endLineNumberExclusive=m}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}join(v){return new N(Math.min(this.startLineNumber,v.startLineNumber),Math.max(this.endLineNumberExclusive,v.endLineNumberExclusive))}}r.LineRange=N}),Y(X[37],Z([0,1,15,19,4,2,9]),function(F,r,A,e,N,f,v){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffComputer=r.SmartLinesDiffComputer=void 0;const m=3;class l{computeDiff(i,o,b){var h;const d=new L(i,o,{maxComputationTime:b.maxComputationTime,shouldIgnoreTrimWhitespace:b.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),C=[];let E=null;for(const R of d.changes){let D;R.originalEndLineNumber===0?D=new e.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):D=new e.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let P;R.modifiedEndLineNumber===0?P=new e.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):P=new e.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let O=new e.LineRangeMapping(D,P,(h=R.charChanges)===null||h===void 0?void 0:h.map(W=>new e.RangeMapping(new f.Range(W.originalStartLineNumber,W.originalStartColumn,W.originalEndLineNumber,W.originalEndColumn),new f.Range(W.modifiedStartLineNumber,W.modifiedStartColumn,W.modifiedEndLineNumber,W.modifiedEndColumn))));E&&(E.modifiedRange.endLineNumberExclusive===O.modifiedRange.startLineNumber||E.originalRange.endLineNumberExclusive===O.originalRange.startLineNumber)&&(O=new e.LineRangeMapping(E.originalRange.join(O.originalRange),E.modifiedRange.join(O.modifiedRange),E.innerChanges&&O.innerChanges?E.innerChanges.concat(O.innerChanges):void 0),C.pop()),C.push(O),E=O}return(0,v.assertFn)(()=>(0,v.checkAdjacentItems)(C,(R,D)=>D.originalRange.startLineNumber-R.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-R.modifiedRange.endLineNumberExclusive&&R.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&R.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:C}}}r.SmartLinesDiffComputer=l;function c(s,i,o,b){return new A.LcsDiff(s,i,o).ComputeDiff(b)}class p{constructor(i){const o=[],b=[];for(let h=0,a=i.length;h<a;h++)o[h]=y(i[h],1),b[h]=S(i[h],1);this.lines=i,this._startColumns=o,this._endColumns=b}getElements(){const i=[];for(let o=0,b=this.lines.length;o<b;o++)i[o]=this.lines[o].substring(this._startColumns[o]-1,this._endColumns[o]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,o,b){const h=[],a=[],d=[];let C=0;for(let E=o;E<=b;E++){const R=this.lines[E],D=i?this._startColumns[E]:1,P=i?this._endColumns[E]:R.length+1;for(let O=D;O<P;O++)h[C]=R.charCodeAt(O-1),a[C]=E+1,d[C]=O,C++;!i&&E<b&&(h[C]=10,a[C]=E+1,d[C]=R.length+1,C++)}return new t(h,a,d)}}class t{constructor(i,o,b){this._charCodes=i,this._lineNumbers=o,this._columns=b}toString(){return"["+this._charCodes.map((i,o)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[o]},${this._columns[o]})`).join(", ")+"]"}_assertIndex(i,o){if(i<0||i>=o.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class w{constructor(i,o,b,h,a,d,C,E){this.originalStartLineNumber=i,this.originalStartColumn=o,this.originalEndLineNumber=b,this.originalEndColumn=h,this.modifiedStartLineNumber=a,this.modifiedStartColumn=d,this.modifiedEndLineNumber=C,this.modifiedEndColumn=E}static createFromDiffChange(i,o,b){const h=o.getStartLineNumber(i.originalStart),a=o.getStartColumn(i.originalStart),d=o.getEndLineNumber(i.originalStart+i.originalLength-1),C=o.getEndColumn(i.originalStart+i.originalLength-1),E=b.getStartLineNumber(i.modifiedStart),R=b.getStartColumn(i.modifiedStart),D=b.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),P=b.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new w(h,a,d,C,E,R,D,P)}}function u(s){if(s.length<=1)return s;const i=[s[0]];let o=i[0];for(let b=1,h=s.length;b<h;b++){const a=s[b],d=a.originalStart-(o.originalStart+o.originalLength),C=a.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(d,C)<m?(o.originalLength=a.originalStart+a.originalLength-o.originalStart,o.modifiedLength=a.modifiedStart+a.modifiedLength-o.modifiedStart):(i.push(a),o=a)}return i}class _{constructor(i,o,b,h,a){this.originalStartLineNumber=i,this.originalEndLineNumber=o,this.modifiedStartLineNumber=b,this.modifiedEndLineNumber=h,this.charChanges=a}static createFromDiffResult(i,o,b,h,a,d,C){let E,R,D,P,O;if(o.originalLength===0?(E=b.getStartLineNumber(o.originalStart)-1,R=0):(E=b.getStartLineNumber(o.originalStart),R=b.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(D=h.getStartLineNumber(o.modifiedStart)-1,P=0):(D=h.getStartLineNumber(o.modifiedStart),P=h.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),d&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&a()){const W=b.createCharSequence(i,o.originalStart,o.originalStart+o.originalLength-1),H=h.createCharSequence(i,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(W.getElements().length>0&&H.getElements().length>0){let q=c(W,H,a,!0).changes;C&&(q=u(q)),O=[];for(let k=0,U=q.length;k<U;k++)O.push(w.createFromDiffChange(q[k],W,H))}}return new _(E,R,D,P,O)}}class L{constructor(i,o,b){this.shouldComputeCharChanges=b.shouldComputeCharChanges,this.shouldPostProcessCharChanges=b.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=b.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=b.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=o,this.original=new p(i),this.modified=new p(o),this.continueLineDiff=g(b.maxComputationTime),this.continueCharDiff=g(b.maxComputationTime===0?0:Math.min(b.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=c(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),o=i.changes,b=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const C=[];for(let E=0,R=o.length;E<R;E++)C.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:b,changes:C}}const h=[];let a=0,d=0;for(let C=-1,E=o.length;C<E;C++){const R=C+1<E?o[C+1]:null,D=R?R.originalStart:this.originalLines.length,P=R?R.modifiedStart:this.modifiedLines.length;for(;a<D&&d<P;){const O=this.originalLines[a],W=this.modifiedLines[d];if(O!==W){{let H=y(O,1),q=y(W,1);for(;H>1&&q>1;){const k=O.charCodeAt(H-2),U=W.charCodeAt(q-2);if(k!==U)break;H--,q--}(H>1||q>1)&&this._pushTrimWhitespaceCharChange(h,a+1,1,H,d+1,1,q)}{let H=S(O,1),q=S(W,1);const k=O.length+1,U=W.length+1;for(;H<k&&q<U;){const T=O.charCodeAt(H-1),B=O.charCodeAt(q-1);if(T!==B)break;H++,q++}(H<k||q<U)&&this._pushTrimWhitespaceCharChange(h,a+1,H,k,d+1,q,U)}}a++,d++}R&&(h.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,R,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=R.originalLength,d+=R.modifiedLength)}return{quitEarly:b,changes:h}}_pushTrimWhitespaceCharChange(i,o,b,h,a,d,C){if(this._mergeTrimWhitespaceCharChange(i,o,b,h,a,d,C))return;let E;this.shouldComputeCharChanges&&(E=[new w(o,b,o,h,a,d,a,C)]),i.push(new _(o,o,a,a,E))}_mergeTrimWhitespaceCharChange(i,o,b,h,a,d,C){const E=i.length;if(E===0)return!1;const R=i[E-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber+1===o&&R.modifiedEndLineNumber+1===a?(R.originalEndLineNumber=o,R.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new w(o,b,o,h,a,d,a,C)),!0):!1}}r.DiffComputer=L;function y(s,i){const o=N.firstNonWhitespaceIndex(s);return o===-1?i:o+1}function S(s,i){const o=N.lastNonWhitespaceIndex(s);return o===-1?i:o+2}function g(s){if(s===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<s}}),Y(X[38],Z([0,1,9,3,2,6,36,33,34,19]),function(F,r,A,e,N,f,v,m,l,c){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.lineRangeMappingFromRangeMappings=r.StandardLinesDiffComputer=void 0;class p{constructor(){this.dynamicProgrammingDiffing=new v.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new l.MyersDiffAlgorithm}computeDiff(s,i,o){const b=new Map;function h(q){let k=b.get(q);return k===void 0&&(k=b.size,b.set(q,k)),k}const a=s.map(q=>h(q.trim())),d=i.map(q=>h(q.trim())),C=new f.SequenceFromIntArray(a),E=new f.SequenceFromIntArray(d),R=(()=>C.length+E.length<1500?this.dynamicProgrammingDiffing.compute(C,E,(q,k)=>s[q]===i[k]?i[k].length===0?.1:1+Math.log(1+i[k].length):.99):this.myersDiffingAlgorithm.compute(C,E))(),D=[],P=q=>{for(let k=0;k<q;k++){const U=O+k,T=W+k;if(s[U]!==i[T]){const B=this.refineDiff(s,i,new f.SequenceDiff(new f.OffsetRange(U,U+1),new f.OffsetRange(T,T+1)));for(const z of B)D.push(z)}}};let O=0,W=0;for(const q of R){(0,A.assertFn)(()=>q.seq1Range.start-O===q.seq2Range.start-W);const k=q.seq1Range.start-O;P(k),O=q.seq1Range.endExclusive,W=q.seq2Range.endExclusive;const U=this.refineDiff(s,i,q);for(const T of U)D.push(T)}P(s.length-O);const H=t(D);return{quitEarly:!1,changes:H}}refineDiff(s,i,o){const b=new u(s,o.seq1Range),h=new u(i,o.seq2Range),a=b.length+h.length<500?this.dynamicProgrammingDiffing.compute(b,h):this.myersDiffingAlgorithm.compute(b,h);return(0,m.optimizeSequenceDiffs)(b,h,a).map(E=>new c.RangeMapping(b.translateRange(E.seq1Range).delta(o.seq1Range.start),h.translateRange(E.seq2Range).delta(o.seq2Range.start)))}}r.StandardLinesDiffComputer=p;function t(g){const s=[];for(const i of w(g,(o,b)=>b.originalRange.startLineNumber-(o.originalRange.endLineNumber-(o.originalRange.endColumn>1?0:1))<=1||b.modifiedRange.startLineNumber-(o.modifiedRange.endLineNumber-(o.modifiedRange.endColumn>1?0:1))<=1)){const o=i[0],b=i[i.length-1];s.push(new c.LineRangeMapping(new c.LineRange(o.originalRange.startLineNumber,b.originalRange.endLineNumber+(b.originalRange.endColumn>1||b.modifiedRange.endColumn>1?1:0)),new c.LineRange(o.modifiedRange.startLineNumber,b.modifiedRange.endLineNumber+(b.originalRange.endColumn>1||b.modifiedRange.endColumn>1?1:0)),i))}return(0,A.assertFn)(()=>(0,A.checkAdjacentItems)(s,(i,o)=>o.originalRange.startLineNumber-i.originalRange.endLineNumberExclusive===o.modifiedRange.startLineNumber-i.modifiedRange.endLineNumberExclusive&&i.originalRange.endLineNumberExclusive<o.originalRange.startLineNumber&&i.modifiedRange.endLineNumberExclusive<o.modifiedRange.startLineNumber)),s}r.lineRangeMappingFromRangeMappings=t;function*w(g,s){let i,o;for(const b of g)o!==void 0&&s(o,b)?i.push(b):(i&&(yield i),i=[b]),o=b;i&&(yield i)}class u{constructor(s,i){this.lines=s,this.lineRange=i;let o=0;this.firstCharOnLineOffsets=new Int32Array(i.length);for(let h=i.start;h<i.endExclusive;h++)o+=s[h].length,this.firstCharOnLineOffsets[h-i.start]=o+1,o++;this.elements=new Int32Array(o);let b=0;for(let h=i.start;h<i.endExclusive;h++){const a=s[h];for(let d=0;d<a.length;d++)this.elements[b+d]=a.charCodeAt(d);b+=a.length,h<s.length-1&&(this.elements[b]=`
`.charCodeAt(0),b+=1)}}getElement(s){return this.elements[s]}get length(){return this.elements.length}getBoundaryScore(s){const i=L(s>0?this.elements[s-1]:-1),o=L(s<this.elements.length?this.elements[s]:-1);let b=0;return i!==o&&(b+=10),b+=i,b+=o,b}translateOffset(s){let i=0,o=this.firstCharOnLineOffsets.length;for(;i<o;){const h=Math.floor((i+o)/2);this.firstCharOnLineOffsets[h]>s?o=h:i=h+1}const b=i===0?0:this.firstCharOnLineOffsets[i-1];return new e.Position(i+1,s-b+1)}translateRange(s){return N.Range.fromPositions(this.translateOffset(s.start),this.translateOffset(s.endExclusive))}}function _(g){return g}function L(g){return S(g)?3:y(g)?0:g===-1?1:2}function y(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}function S(g){return g===32||g===9||g===10||g===13}}),Y(X[39],Z([0,1,37,38]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.linesDiffComputers=void 0,r.linesDiffComputers={smart:new A.SmartLinesDiffComputer,experimental:new e.StandardLinesDiffComputer}}),Y(X[40],Z([0,1,17]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.computeLinks=r.LinkComputer=r.StateMachine=void 0;class e{constructor(w,u,_){const L=new Uint8Array(w*u);for(let y=0,S=w*u;y<S;y++)L[y]=_;this._data=L,this.rows=w,this.cols=u}get(w,u){return this._data[w*this.cols+u]}set(w,u,_){this._data[w*this.cols+u]=_}}class N{constructor(w){let u=0,_=0;for(let y=0,S=w.length;y<S;y++){const[g,s,i]=w[y];s>u&&(u=s),g>_&&(_=g),i>_&&(_=i)}u++,_++;const L=new e(_,u,0);for(let y=0,S=w.length;y<S;y++){const[g,s,i]=w[y];L.set(g,s,i)}this._states=L,this._maxCharCode=u}nextState(w,u){return u<0||u>=this._maxCharCode?0:this._states.get(w,u)}}r.StateMachine=N;let f=null;function v(){return f===null&&(f=new N([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),f}let m=null;function l(){if(m===null){m=new A.CharacterClassifier(0);const t=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<t.length;u++)m.set(t.charCodeAt(u),1);const w=".,;:";for(let u=0;u<w.length;u++)m.set(w.charCodeAt(u),2)}return m}class c{static _createLink(w,u,_,L,y){let S=y-1;do{const g=u.charCodeAt(S);if(w.get(g)!==2)break;S--}while(S>L);if(L>0){const g=u.charCodeAt(L-1),s=u.charCodeAt(S);(g===40&&s===41||g===91&&s===93||g===123&&s===125)&&S--}return{range:{startLineNumber:_,startColumn:L+1,endLineNumber:_,endColumn:S+2},url:u.substring(L,S+1)}}static computeLinks(w,u=v()){const _=l(),L=[];for(let y=1,S=w.getLineCount();y<=S;y++){const g=w.getLineContent(y),s=g.length;let i=0,o=0,b=0,h=1,a=!1,d=!1,C=!1,E=!1;for(;i<s;){let R=!1;const D=g.charCodeAt(i);if(h===13){let P;switch(D){case 40:a=!0,P=0;break;case 41:P=a?0:1;break;case 91:C=!0,d=!0,P=0;break;case 93:C=!1,P=d?0:1;break;case 123:E=!0,P=0;break;case 125:P=E?0:1;break;case 39:case 34:case 96:b===D?P=1:b===39||b===34||b===96?P=0:P=1;break;case 42:P=b===42?1:0;break;case 124:P=b===124?1:0;break;case 32:P=C?0:1;break;default:P=_.get(D)}P===1&&(L.push(c._createLink(_,g,y,o,i)),R=!0)}else if(h===12){let P;D===91?(d=!0,P=0):P=_.get(D),P===1?R=!0:h=13}else h=u.nextState(h,D),h===0&&(R=!0);R&&(h=1,a=!1,d=!1,E=!1,o=i+1,b=D),i++}h===13&&L.push(c._createLink(_,g,y,o,s))}return L}}r.LinkComputer=c;function p(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:c.computeLinks(t)}r.computeLinks=p}),Y(X[41],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BasicInplaceReplace=void 0;class A{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(N,f,v,m,l){if(N&&f){const c=this.doNavigateValueSet(f,l);if(c)return{range:N,value:c}}if(v&&m){const c=this.doNavigateValueSet(m,l);if(c)return{range:v,value:c}}return null}doNavigateValueSet(N,f){const v=this.numberReplace(N,f);return v!==null?v:this.textReplace(N,f)}numberReplace(N,f){const v=Math.pow(10,N.length-(N.lastIndexOf(".")+1));let m=Number(N);const l=parseFloat(N);return!isNaN(m)&&!isNaN(l)&&m===l?m===0&&!f?null:(m=Math.floor(m*v),m+=f?v:-v,String(m/v)):null}textReplace(N,f){return this.valueSetsReplace(this._defaultValueSet,N,f)}valueSetsReplace(N,f,v){let m=null;for(let l=0,c=N.length;m===null&&l<c;l++)m=this.valueSetReplace(N[l],f,v);return m}valueSetReplace(N,f,v){let m=N.indexOf(f);return m>=0?(m+=v?1:-1,m<0?m=N.length-1:m%=N.length,N[m]):null}}r.BasicInplaceReplace=A,A.INSTANCE=new A}),Y(X[42],Z([0,1,11]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shouldSynchronizeModel=r.ApplyEditsResult=r.SearchData=r.ValidAnnotatedEditOperation=r.isITextSnapshot=r.FindMatch=r.TextModelResolvedOptions=r.InjectedTextCursorStops=r.MinimapPosition=r.OverviewRulerLane=void 0;var e;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(e=r.OverviewRulerLane||(r.OverviewRulerLane={}));var N;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(N=r.MinimapPosition||(r.MinimapPosition={}));var f;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(f=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));class v{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}r.TextModelResolvedOptions=v;class m{constructor(_,L){this._findMatchBrand=void 0,this.range=_,this.matches=L}}r.FindMatch=m;function l(u){return u&&typeof u.read=="function"}r.isITextSnapshot=l;class c{constructor(_,L,y,S,g,s){this.identifier=_,this.range=L,this.text=y,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=g,this._isTracked=s}}r.ValidAnnotatedEditOperation=c;class p{constructor(_,L,y){this.regex=_,this.wordSeparators=L,this.simpleSearch=y}}r.SearchData=p;class t{constructor(_,L,y){this.reverseEdits=_,this.changes=L,this.trimAutoWhitespaceLineNumbers=y}}r.ApplyEditsResult=t;function w(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}r.shouldSynchronizeModel=w}),Y(X[43],Z([0,1,22,16]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PrefixSumIndexOfResult=r.ConstantTimePrefixSumComputer=r.PrefixSumComputer=void 0;class N{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,c){l=(0,e.toUint32)(l);const p=this.values,t=this.prefixSum,w=c.length;return w===0?!1:(this.values=new Uint32Array(p.length+w),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l),l+w),this.values.set(c,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,c){return l=(0,e.toUint32)(l),c=(0,e.toUint32)(c),this.values[l]===c?!1:(this.values[l]=c,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,c){l=(0,e.toUint32)(l),c=(0,e.toUint32)(c);const p=this.values,t=this.prefixSum;if(l>=p.length)return!1;const w=p.length-l;return c>=w&&(c=w),c===0?!1:(this.values=new Uint32Array(p.length-c),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l+c),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,e.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let c=this.prefixSumValidIndex[0]+1;c===0&&(this.prefixSum[0]=this.values[0],c++),l>=this.values.length&&(l=this.values.length-1);for(let p=c;p<=l;p++)this.prefixSum[p]=this.prefixSum[p-1]+this.values[p];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let c=0,p=this.values.length-1,t=0,w=0,u=0;for(;c<=p;)if(t=c+(p-c)/2|0,w=this.prefixSum[t],u=w-this.values[t],l<u)p=t-1;else if(l>=w)c=t+1;else break;return new v(t,l-u)}}r.PrefixSumComputer=N;class f{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const c=this._indexBySum[l],p=c>0?this._prefixSum[c-1]:0;return new v(c,l-p)}removeValues(l,c){this._values.splice(l,c),this._invalidate(l)}insertValues(l,c){this._values=(0,A.arrayInsert)(this._values,l,c),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,c=this._values.length;l<c;l++){const p=this._values[l],t=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=t+p;for(let w=0;w<p;w++)this._indexBySum[t+w]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,c){this._values[l]!==c&&(this._values[l]=c,this._invalidate(l))}}r.ConstantTimePrefixSumComputer=f;class v{constructor(l,c){this.index=l,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=c}}r.PrefixSumIndexOfResult=v}),Y(X[44],Z([0,1,4,3,43]),function(F,r,A,e,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MirrorTextModel=void 0;class f{constructor(m,l,c,p){this._uri=m,this._lines=l,this._eol=c,this._versionId=p,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(m){m.eol&&m.eol!==this._eol&&(this._eol=m.eol,this._lineStarts=null);const l=m.changes;for(const c of l)this._acceptDeleteRange(c.range),this._acceptInsertText(new e.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=m.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const m=this._eol.length,l=this._lines.length,c=new Uint32Array(l);for(let p=0;p<l;p++)c[p]=this._lines[p].length+m;this._lineStarts=new N.PrefixSumComputer(c)}}_setLineText(m,l){this._lines[m]=l,this._lineStarts&&this._lineStarts.setValue(m,this._lines[m].length+this._eol.length)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.startLineNumber-1].substring(m.endColumn-1));return}this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.endLineNumber-1].substring(m.endColumn-1)),this._lines.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}_acceptInsertText(m,l){if(l.length===0)return;const c=(0,A.splitLines)(l);if(c.length===1){this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+c[0]+this._lines[m.lineNumber-1].substring(m.column-1));return}c[c.length-1]+=this._lines[m.lineNumber-1].substring(m.column-1),this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+c[0]);const p=new Uint32Array(c.length-1);for(let t=1;t<c.length;t++)this._lines.splice(m.lineNumber+t-1,0,c[t]),p[t-1]=c[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(m.lineNumber,p)}}r.MirrorTextModel=f}),Y(X[45],Z([0,1,4,32,3,2,42]),function(F,r,A,e,N,f,v){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Searcher=r.isValidMatch=r.TextModelSearch=r.createFindMatch=r.isMultilineRegexSource=r.SearchParams=void 0;const m=999;class l{constructor(g,s,i,o){this.searchString=g,this.isRegex=s,this.matchCase=i,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=c(this.searchString):g=this.searchString.indexOf(`
`)>=0;let s=null;try{s=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!g;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new v.SearchData(s,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}r.SearchParams=l;function c(S){if(!S||S.length===0)return!1;for(let g=0,s=S.length;g<s;g++){const i=S.charCodeAt(g);if(i===10)return!0;if(i===92){if(g++,g>=s)break;const o=S.charCodeAt(g);if(o===110||o===114||o===87)return!0}}return!1}r.isMultilineRegexSource=c;function p(S,g,s){if(!s)return new v.FindMatch(S,null);const i=[];for(let o=0,b=g.length;o<b;o++)i[o]=g[o];return new v.FindMatch(S,i)}r.createFindMatch=p;class t{constructor(g){const s=[];let i=0;for(let o=0,b=g.length;o<b;o++)g.charCodeAt(o)===10&&(s[i++]=o);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(g){const s=this._lineFeedsOffsets;let i=0,o=s.length-1;if(o===-1||g<=s[0])return 0;for(;i<o;){const b=i+((o-i)/2>>0);s[b]>=g?o=b-1:s[b+1]>=g?(i=b,o=b):i=b+1}return i+1}}class w{static findMatches(g,s,i,o,b){const h=s.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(g,i,new y(h.wordSeparators,h.regex),o,b):this._doFindMatchesLineByLine(g,i,h,o,b):[]}static _getMultilineMatchRange(g,s,i,o,b,h){let a,d=0;o?(d=o.findLineFeedCountBeforeOffset(b),a=s+b+d):a=s+b;let C;if(o){const P=o.findLineFeedCountBeforeOffset(b+h.length)-d;C=a+h.length+P}else C=a+h.length;const E=g.getPositionAt(a),R=g.getPositionAt(C);return new f.Range(E.lineNumber,E.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(g,s,i,o,b){const h=g.getOffsetAt(s.getStartPosition()),a=g.getValueInRange(s,1),d=g.getEOL()===`\r
`?new t(a):null,C=[];let E=0,R;for(i.reset(0);R=i.next(a);)if(C[E++]=p(this._getMultilineMatchRange(g,h,a,d,R.index,R[0]),R,o),E>=b)return C;return C}static _doFindMatchesLineByLine(g,s,i,o,b){const h=[];let a=0;if(s.startLineNumber===s.endLineNumber){const C=g.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return a=this._findMatchesInLine(i,C,s.startLineNumber,s.startColumn-1,a,h,o,b),h}const d=g.getLineContent(s.startLineNumber).substring(s.startColumn-1);a=this._findMatchesInLine(i,d,s.startLineNumber,s.startColumn-1,a,h,o,b);for(let C=s.startLineNumber+1;C<s.endLineNumber&&a<b;C++)a=this._findMatchesInLine(i,g.getLineContent(C),C,0,a,h,o,b);if(a<b){const C=g.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);a=this._findMatchesInLine(i,C,s.endLineNumber,0,a,h,o,b)}return h}static _findMatchesInLine(g,s,i,o,b,h,a,d){const C=g.wordSeparators;if(!a&&g.simpleSearch){const D=g.simpleSearch,P=D.length,O=s.length;let W=-P;for(;(W=s.indexOf(D,W+P))!==-1;)if((!C||L(C,s,O,W,P))&&(h[b++]=new v.FindMatch(new f.Range(i,W+1+o,i,W+1+P+o),null),b>=d))return b;return b}const E=new y(g.wordSeparators,g.regex);let R;E.reset(0);do if(R=E.next(s),R&&(h[b++]=p(new f.Range(i,R.index+1+o,i,R.index+1+R[0].length+o),R,a),b>=d))return b;while(R);return b}static findNextMatch(g,s,i,o){const b=s.parseSearchRequest();if(!b)return null;const h=new y(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(g,i,h,o):this._doFindNextMatchLineByLine(g,i,h,o)}static _doFindNextMatchMultiline(g,s,i,o){const b=new N.Position(s.lineNumber,1),h=g.getOffsetAt(b),a=g.getLineCount(),d=g.getValueInRange(new f.Range(b.lineNumber,b.column,a,g.getLineMaxColumn(a)),1),C=g.getEOL()===`\r
`?new t(d):null;i.reset(s.column-1);const E=i.next(d);return E?p(this._getMultilineMatchRange(g,h,d,C,E.index,E[0]),E,o):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(g,new N.Position(1,1),i,o):null}static _doFindNextMatchLineByLine(g,s,i,o){const b=g.getLineCount(),h=s.lineNumber,a=g.getLineContent(h),d=this._findFirstMatchInLine(i,a,h,s.column,o);if(d)return d;for(let C=1;C<=b;C++){const E=(h+C-1)%b,R=g.getLineContent(E+1),D=this._findFirstMatchInLine(i,R,E+1,1,o);if(D)return D}return null}static _findFirstMatchInLine(g,s,i,o,b){g.reset(o-1);const h=g.next(s);return h?p(new f.Range(i,h.index+1,i,h.index+1+h[0].length),h,b):null}static findPreviousMatch(g,s,i,o){const b=s.parseSearchRequest();if(!b)return null;const h=new y(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(g,i,h,o):this._doFindPreviousMatchLineByLine(g,i,h,o)}static _doFindPreviousMatchMultiline(g,s,i,o){const b=this._doFindMatchesMultiline(g,new f.Range(1,1,s.lineNumber,s.column),i,o,10*m);if(b.length>0)return b[b.length-1];const h=g.getLineCount();return s.lineNumber!==h||s.column!==g.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(g,new N.Position(h,g.getLineMaxColumn(h)),i,o):null}static _doFindPreviousMatchLineByLine(g,s,i,o){const b=g.getLineCount(),h=s.lineNumber,a=g.getLineContent(h).substring(0,s.column-1),d=this._findLastMatchInLine(i,a,h,o);if(d)return d;for(let C=1;C<=b;C++){const E=(b+h-C-1)%b,R=g.getLineContent(E+1),D=this._findLastMatchInLine(i,R,E+1,o);if(D)return D}return null}static _findLastMatchInLine(g,s,i,o){let b=null,h;for(g.reset(0);h=g.next(s);)b=p(new f.Range(i,h.index+1,i,h.index+1+h[0].length),h,o);return b}}r.TextModelSearch=w;function u(S,g,s,i,o){if(i===0)return!0;const b=g.charCodeAt(i-1);if(S.get(b)!==0||b===13||b===10)return!0;if(o>0){const h=g.charCodeAt(i);if(S.get(h)!==0)return!0}return!1}function _(S,g,s,i,o){if(i+o===s)return!0;const b=g.charCodeAt(i+o);if(S.get(b)!==0||b===13||b===10)return!0;if(o>0){const h=g.charCodeAt(i+o-1);if(S.get(h)!==0)return!0}return!1}function L(S,g,s,i,o){return u(S,g,s,i,o)&&_(S,g,s,i,o)}r.isValidMatch=L;class y{constructor(g,s){this._wordSeparators=g,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const s=g.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(g),!i))return null;const o=i.index,b=i[0].length;if(o===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){A.getNextCodePoint(g,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=b,!this._wordSeparators||L(this._wordSeparators,g,s,o,b))return i}while(i);return null}}r.Searcher=y}),Y(X[46],Z([0,1,2,45,4,9,18]),function(F,r,A,e,N,f,v){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.UnicodeTextModelHighlighter=void 0;class m{static computeUnicodeHighlights(w,u,_){const L=_?_.startLineNumber:1,y=_?_.endLineNumber:w.getLineCount(),S=new c(u),g=S.getCandidateCodePoints();let s;g==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${l(Array.from(g))}`,"g");const i=new e.Searcher(null,s),o=[];let b=!1,h,a=0,d=0,C=0;e:for(let E=L,R=y;E<=R;E++){const D=w.getLineContent(E),P=D.length;i.reset(0);do if(h=i.next(D),h){let O=h.index,W=h.index+h[0].length;if(O>0){const U=D.charCodeAt(O-1);N.isHighSurrogate(U)&&O--}if(W+1<P){const U=D.charCodeAt(W-1);N.isHighSurrogate(U)&&W++}const H=D.substring(O,W),q=(0,v.getWordAtText)(O+1,v.DEFAULT_WORD_REGEXP,D,0),k=S.shouldHighlightNonBasicASCII(H,q?q.word:null);if(k!==0){k===3?a++:k===2?d++:k===1?C++:(0,f.assertNever)(k);const U=1e3;if(o.length>=U){b=!0;break e}o.push(new A.Range(E,O+1,E,W+1))}}while(h)}return{ranges:o,hasMore:b,ambiguousCharacterCount:a,invisibleCharacterCount:d,nonBasicAsciiCharacterCount:C}}static computeUnicodeHighlightReason(w,u){const _=new c(u);switch(_.shouldHighlightNonBasicASCII(w,null)){case 0:return null;case 2:return{kind:1};case 3:{const y=w.codePointAt(0),S=_.ambiguousCharacters.getPrimaryConfusable(y),g=N.AmbiguousCharacters.getLocales().filter(s=>!N.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,s])).isAmbiguous(y));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}r.UnicodeTextModelHighlighter=m;function l(t,w){return`[${N.escapeRegExpCharacters(t.map(_=>String.fromCodePoint(_)).join(""))}]`}class c{constructor(w){this.options=w,this.allowedCodePoints=new Set(w.allowedCodePoints),this.ambiguousCharacters=N.AmbiguousCharacters.getInstance(new Set(w.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const w=new Set;if(this.options.invisibleCharacters)for(const u of N.InvisibleCharacters.codePoints)p(String.fromCodePoint(u))||w.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())w.add(u);for(const u of this.allowedCodePoints)w.delete(u);return w}shouldHighlightNonBasicASCII(w,u){const _=w.codePointAt(0);if(this.allowedCodePoints.has(_))return 0;if(this.options.nonBasicASCII)return 1;let L=!1,y=!1;if(u)for(const S of u){const g=S.codePointAt(0),s=N.isBasicASCII(S);L=L||s,!s&&!this.ambiguousCharacters.isAmbiguous(g)&&!N.InvisibleCharacters.isInvisibleCharacter(g)&&(y=!0)}return!L&&y?0:this.options.invisibleCharacters&&!p(w)&&N.InvisibleCharacters.isInvisibleCharacter(_)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(_)?3:0}}function p(t){return t===" "||t===`
`||t==="	"}}),Y(X[47],Z([0,1]),function(F,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.WrappingIndent=r.TrackedRangeStickiness=r.TextEditorCursorStyle=r.TextEditorCursorBlinkingStyle=r.SymbolTag=r.SymbolKind=r.SignatureHelpTriggerKind=r.SelectionDirection=r.ScrollbarVisibility=r.ScrollType=r.RenderMinimap=r.RenderLineNumbersType=r.PositionAffinity=r.OverviewRulerLane=r.OverlayWidgetPositionPreference=r.MouseTargetType=r.MinimapPosition=r.MarkerTag=r.MarkerSeverity=r.KeyCode=r.InlineCompletionTriggerKind=r.InlayHintKind=r.InjectedTextCursorStops=r.IndentAction=r.EndOfLineSequence=r.EndOfLinePreference=r.EditorOption=r.EditorAutoIndentStrategy=r.DocumentHighlightKind=r.DefaultEndOfLine=r.CursorChangeReason=r.ContentWidgetPositionPreference=r.CompletionTriggerKind=r.CompletionItemTag=r.CompletionItemKind=r.CompletionItemInsertTextRule=r.CodeActionTriggerType=r.AccessibilitySupport=void 0;var A;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(A=r.AccessibilitySupport||(r.AccessibilitySupport={}));var e;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(e=r.CodeActionTriggerType||(r.CodeActionTriggerType={}));var N;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(N=r.CompletionItemInsertTextRule||(r.CompletionItemInsertTextRule={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f=r.CompletionItemKind||(r.CompletionItemKind={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v=r.CompletionItemTag||(r.CompletionItemTag={}));var m;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=r.CompletionTriggerKind||(r.CompletionTriggerKind={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l=r.ContentWidgetPositionPreference||(r.ContentWidgetPositionPreference={}));var c;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(c=r.CursorChangeReason||(r.CursorChangeReason={}));var p;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p=r.DefaultEndOfLine||(r.DefaultEndOfLine={}));var t;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(t=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));var w;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(w=r.EditorAutoIndentStrategy||(r.EditorAutoIndentStrategy={}));var u;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.columnSelection=18]="columnSelection",n[n.comments=19]="comments",n[n.contextmenu=20]="contextmenu",n[n.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",n[n.cursorBlinking=22]="cursorBlinking",n[n.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",n[n.cursorStyle=24]="cursorStyle",n[n.cursorSurroundingLines=25]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",n[n.cursorWidth=27]="cursorWidth",n[n.disableLayerHinting=28]="disableLayerHinting",n[n.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",n[n.domReadOnly=30]="domReadOnly",n[n.dragAndDrop=31]="dragAndDrop",n[n.dropIntoEditor=32]="dropIntoEditor",n[n.emptySelectionClipboard=33]="emptySelectionClipboard",n[n.extraEditorClassName=34]="extraEditorClassName",n[n.fastScrollSensitivity=35]="fastScrollSensitivity",n[n.find=36]="find",n[n.fixedOverflowWidgets=37]="fixedOverflowWidgets",n[n.folding=38]="folding",n[n.foldingStrategy=39]="foldingStrategy",n[n.foldingHighlight=40]="foldingHighlight",n[n.foldingImportsByDefault=41]="foldingImportsByDefault",n[n.foldingMaximumRegions=42]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=44]="fontFamily",n[n.fontInfo=45]="fontInfo",n[n.fontLigatures=46]="fontLigatures",n[n.fontSize=47]="fontSize",n[n.fontWeight=48]="fontWeight",n[n.formatOnPaste=49]="formatOnPaste",n[n.formatOnType=50]="formatOnType",n[n.glyphMargin=51]="glyphMargin",n[n.gotoLocation=52]="gotoLocation",n[n.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",n[n.hover=54]="hover",n[n.inDiffEditor=55]="inDiffEditor",n[n.inlineSuggest=56]="inlineSuggest",n[n.letterSpacing=57]="letterSpacing",n[n.lightbulb=58]="lightbulb",n[n.lineDecorationsWidth=59]="lineDecorationsWidth",n[n.lineHeight=60]="lineHeight",n[n.lineNumbers=61]="lineNumbers",n[n.lineNumbersMinChars=62]="lineNumbersMinChars",n[n.linkedEditing=63]="linkedEditing",n[n.links=64]="links",n[n.matchBrackets=65]="matchBrackets",n[n.minimap=66]="minimap",n[n.mouseStyle=67]="mouseStyle",n[n.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=69]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",n[n.multiCursorModifier=71]="multiCursorModifier",n[n.multiCursorPaste=72]="multiCursorPaste",n[n.occurrencesHighlight=73]="occurrencesHighlight",n[n.overviewRulerBorder=74]="overviewRulerBorder",n[n.overviewRulerLanes=75]="overviewRulerLanes",n[n.padding=76]="padding",n[n.parameterHints=77]="parameterHints",n[n.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",n[n.quickSuggestions=80]="quickSuggestions",n[n.quickSuggestionsDelay=81]="quickSuggestionsDelay",n[n.readOnly=82]="readOnly",n[n.renameOnType=83]="renameOnType",n[n.renderControlCharacters=84]="renderControlCharacters",n[n.renderFinalNewline=85]="renderFinalNewline",n[n.renderLineHighlight=86]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=88]="renderValidationDecorations",n[n.renderWhitespace=89]="renderWhitespace",n[n.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",n[n.roundedSelection=91]="roundedSelection",n[n.rulers=92]="rulers",n[n.scrollbar=93]="scrollbar",n[n.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=95]="scrollBeyondLastLine",n[n.scrollPredominantAxis=96]="scrollPredominantAxis",n[n.selectionClipboard=97]="selectionClipboard",n[n.selectionHighlight=98]="selectionHighlight",n[n.selectOnLineNumbers=99]="selectOnLineNumbers",n[n.showFoldingControls=100]="showFoldingControls",n[n.showUnused=101]="showUnused",n[n.snippetSuggestions=102]="snippetSuggestions",n[n.smartSelect=103]="smartSelect",n[n.smoothScrolling=104]="smoothScrolling",n[n.stickyScroll=105]="stickyScroll",n[n.stickyTabStops=106]="stickyTabStops",n[n.stopRenderingLineAfter=107]="stopRenderingLineAfter",n[n.suggest=108]="suggest",n[n.suggestFontSize=109]="suggestFontSize",n[n.suggestLineHeight=110]="suggestLineHeight",n[n.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",n[n.suggestSelection=112]="suggestSelection",n[n.tabCompletion=113]="tabCompletion",n[n.tabIndex=114]="tabIndex",n[n.unicodeHighlighting=115]="unicodeHighlighting",n[n.unusualLineTerminators=116]="unusualLineTerminators",n[n.useShadowDOM=117]="useShadowDOM",n[n.useTabStops=118]="useTabStops",n[n.wordSeparators=119]="wordSeparators",n[n.wordWrap=120]="wordWrap",n[n.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=123]="wordWrapColumn",n[n.wordWrapOverride1=124]="wordWrapOverride1",n[n.wordWrapOverride2=125]="wordWrapOverride2",n[n.wrappingIndent=126]="wrappingIndent",n[n.wrappingStrategy=127]="wrappingStrategy",n[n.showDeprecated=128]="showDeprecated",n[n.inlayHints=129]="inlayHints",n[n.editorClassName=130]="editorClassName",n[n.pixelRatio=131]="pixelRatio",n[n.tabFocusMode=132]="tabFocusMode",n[n.layoutInfo=133]="layoutInfo",n[n.wrappingInfo=134]="wrappingInfo"})(u=r.EditorOption||(r.EditorOption={}));var _;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(_=r.EndOfLinePreference||(r.EndOfLinePreference={}));var L;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(L=r.EndOfLineSequence||(r.EndOfLineSequence={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y=r.IndentAction||(r.IndentAction={}));var S;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(S=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));var g;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(g=r.InlayHintKind||(r.InlayHintKind={}));var s;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(s=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var i;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(i=r.KeyCode||(r.KeyCode={}));var o;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(o=r.MarkerSeverity||(r.MarkerSeverity={}));var b;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(b=r.MarkerTag||(r.MarkerTag={}));var h;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(h=r.MinimapPosition||(r.MinimapPosition={}));var a;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(a=r.MouseTargetType||(r.MouseTargetType={}));var d;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(d=r.OverlayWidgetPositionPreference||(r.OverlayWidgetPositionPreference={}));var C;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(C=r.OverviewRulerLane||(r.OverviewRulerLane={}));var E;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(E=r.PositionAffinity||(r.PositionAffinity={}));var R;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(R=r.RenderLineNumbersType||(r.RenderLineNumbersType={}));var D;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(D=r.RenderMinimap||(r.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=r.ScrollType||(r.ScrollType={}));var O;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(O=r.ScrollbarVisibility||(r.ScrollbarVisibility={}));var W;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(W=r.SelectionDirection||(r.SelectionDirection={}));var H;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(H=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q=r.SymbolKind||(r.SymbolKind={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k=r.SymbolTag||(r.SymbolTag={}));var U;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(U=r.TextEditorCursorBlinkingStyle||(r.TextEditorCursorBlinkingStyle={}));var T;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(T=r.TextEditorCursorStyle||(r.TextEditorCursorStyle={}));var B;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(B=r.TrackedRangeStickiness||(r.TrackedRangeStickiness={}));var z;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(z=r.WrappingIndent||(r.WrappingIndent={}))}),Y(X[48],Z([21,55]),function(F,r){return F.create("vs/base/common/platform",r)}),Y(X[5],Z([0,1,48]),function(F,r,A){"use strict";var e;Object.defineProperty(r,"__esModule",{value:!0}),r.isAndroid=r.isEdge=r.isSafari=r.isFirefox=r.isChrome=r.isLittleEndian=r.OS=r.setTimeout0=r.setTimeout0IsFaster=r.language=r.userAgent=r.isMobile=r.isIOS=r.isWebWorker=r.isWeb=r.isNative=r.isLinux=r.isMacintosh=r.isWindows=r.globals=r.LANGUAGE_DEFAULT=void 0,r.LANGUAGE_DEFAULT="en";let N=!1,f=!1,v=!1,m=!1,l=!1,c=!1,p=!1,t=!1,w=!1,u=!1,_,L=r.LANGUAGE_DEFAULT,y,S;r.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof r.globals.vscode<"u"&&typeof r.globals.vscode.process<"u"?g=r.globals.vscode.process:typeof process<"u"&&(g=process);const s=typeof((e=g?.versions)===null||e===void 0?void 0:e.electron)=="string",i=s&&g?.type==="renderer";if(typeof navigator=="object"&&!i)S=navigator.userAgent,N=S.indexOf("Windows")>=0,f=S.indexOf("Macintosh")>=0,t=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=S.indexOf("Linux")>=0,u=S?.indexOf("Mobi")>=0,c=!0,_=A.getConfiguredDefaultLocale(A.localize(0,null))||r.LANGUAGE_DEFAULT,L=_;else if(typeof g=="object"){N=g.platform==="win32",f=g.platform==="darwin",v=g.platform==="linux",m=v&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,p=s,w=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=r.LANGUAGE_DEFAULT,L=r.LANGUAGE_DEFAULT;const d=g.env.VSCODE_NLS_CONFIG;if(d)try{const C=JSON.parse(d),E=C.availableLanguages["*"];_=C.locale,L=E||r.LANGUAGE_DEFAULT,y=C._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");let o=0;f?o=1:N?o=3:v&&(o=2),r.isWindows=N,r.isMacintosh=f,r.isLinux=v,r.isNative=l,r.isWeb=c,r.isWebWorker=c&&typeof r.globals.importScripts=="function",r.isIOS=t,r.isMobile=u,r.userAgent=S,r.language=L,r.setTimeout0IsFaster=typeof r.globals.postMessage=="function"&&!r.globals.importScripts,r.setTimeout0=(()=>{if(r.setTimeout0IsFaster){const d=[];r.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let R=0,D=d.length;R<D;R++){const P=d[R];if(P.id===E.data.vscodeScheduleAsyncWork){d.splice(R,1),P.callback();return}}});let C=0;return E=>{const R=++C;d.push({id:R,callback:E}),r.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return d=>setTimeout(d)})(),r.OS=f||t?2:N?1:3;let b=!0,h=!1;function a(){if(!h){h=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,b=new Uint16Array(d.buffer)[0]===(2<<8)+1}return b}r.isLittleEndian=a,r.isChrome=!!(r.userAgent&&r.userAgent.indexOf("Chrome")>=0),r.isFirefox=!!(r.userAgent&&r.userAgent.indexOf("Firefox")>=0),r.isSafari=!!(!r.isChrome&&r.userAgent&&r.userAgent.indexOf("Safari")>=0),r.isEdge=!!(r.userAgent&&r.userAgent.indexOf("Edg/")>=0),r.isAndroid=!!(r.userAgent&&r.userAgent.indexOf("Android")>=0)}),Y(X[49],Z([0,1,5]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.platform=r.env=r.cwd=void 0;let e;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const N=A.globals.vscode.process;e={get platform(){return N.platform},get arch(){return N.arch},get env(){return N.env},cwd(){return N.cwd()}}}else typeof process<"u"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};r.cwd=e.cwd,r.env=e.env,r.platform=e.platform}),Y(X[50],Z([0,1,49]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.sep=r.extname=r.basename=r.dirname=r.relative=r.resolve=r.normalize=r.posix=r.win32=void 0;const e=65,N=97,f=90,v=122,m=46,l=47,c=92,p=58,t=63;class w extends Error{constructor(i,o,b){let h;typeof o=="string"&&o.indexOf("not ")===0?(h="must not be",o=o.replace(/^not /,"")):h="must be";const a=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${a} ${h} of type ${o}`;d+=`. Received type ${typeof b}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function u(s,i){if(typeof s!="string")throw new w(i,"string",s)}function _(s){return s===l||s===c}function L(s){return s===l}function y(s){return s>=e&&s<=f||s>=N&&s<=v}function S(s,i,o,b){let h="",a=0,d=-1,C=0,E=0;for(let R=0;R<=s.length;++R){if(R<s.length)E=s.charCodeAt(R);else{if(b(E))break;E=l}if(b(E)){if(!(d===R-1||C===1))if(C===2){if(h.length<2||a!==2||h.charCodeAt(h.length-1)!==m||h.charCodeAt(h.length-2)!==m){if(h.length>2){const D=h.lastIndexOf(o);D===-1?(h="",a=0):(h=h.slice(0,D),a=h.length-1-h.lastIndexOf(o)),d=R,C=0;continue}else if(h.length!==0){h="",a=0,d=R,C=0;continue}}i&&(h+=h.length>0?`${o}..`:"..",a=2)}else h.length>0?h+=`${o}${s.slice(d+1,R)}`:h=s.slice(d+1,R),a=R-d-1;d=R,C=0}else E===m&&C!==-1?++C:C=-1}return h}function g(s,i){if(i===null||typeof i!="object")throw new w("pathObject","Object",i);const o=i.dir||i.root,b=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${b}`:`${o}${s}${b}`:b}r.win32={resolve(...s){let i="",o="",b=!1;for(let h=s.length-1;h>=-1;h--){let a;if(h>=0){if(a=s[h],u(a,"path"),a.length===0)continue}else i.length===0?a=A.cwd():(a=A.env[`=${i}`]||A.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${i}\\`));const d=a.length;let C=0,E="",R=!1;const D=a.charCodeAt(0);if(d===1)_(D)&&(C=1,R=!0);else if(_(D))if(R=!0,_(a.charCodeAt(1))){let P=2,O=P;for(;P<d&&!_(a.charCodeAt(P));)P++;if(P<d&&P!==O){const W=a.slice(O,P);for(O=P;P<d&&_(a.charCodeAt(P));)P++;if(P<d&&P!==O){for(O=P;P<d&&!_(a.charCodeAt(P));)P++;(P===d||P!==O)&&(E=`\\\\${W}\\${a.slice(O,P)}`,C=P)}}}else C=1;else y(D)&&a.charCodeAt(1)===p&&(E=a.slice(0,2),C=2,d>2&&_(a.charCodeAt(2))&&(R=!0,C=3));if(E.length>0)if(i.length>0){if(E.toLowerCase()!==i.toLowerCase())continue}else i=E;if(b){if(i.length>0)break}else if(o=`${a.slice(C)}\\${o}`,b=R,R&&i.length>0)break}return o=S(o,!b,"\\",_),b?`${i}\\${o}`:`${i}${o}`||"."},normalize(s){u(s,"path");const i=s.length;if(i===0)return".";let o=0,b,h=!1;const a=s.charCodeAt(0);if(i===1)return L(a)?"\\":s;if(_(a))if(h=!0,_(s.charCodeAt(1))){let C=2,E=C;for(;C<i&&!_(s.charCodeAt(C));)C++;if(C<i&&C!==E){const R=s.slice(E,C);for(E=C;C<i&&_(s.charCodeAt(C));)C++;if(C<i&&C!==E){for(E=C;C<i&&!_(s.charCodeAt(C));)C++;if(C===i)return`\\\\${R}\\${s.slice(E)}\\`;C!==E&&(b=`\\\\${R}\\${s.slice(E,C)}`,o=C)}}}else o=1;else y(a)&&s.charCodeAt(1)===p&&(b=s.slice(0,2),o=2,i>2&&_(s.charCodeAt(2))&&(h=!0,o=3));let d=o<i?S(s.slice(o),!h,"\\",_):"";return d.length===0&&!h&&(d="."),d.length>0&&_(s.charCodeAt(i-1))&&(d+="\\"),b===void 0?h?`\\${d}`:d:h?`${b}\\${d}`:`${b}${d}`},isAbsolute(s){u(s,"path");const i=s.length;if(i===0)return!1;const o=s.charCodeAt(0);return _(o)||i>2&&y(o)&&s.charCodeAt(1)===p&&_(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,o;for(let a=0;a<s.length;++a){const d=s[a];u(d,"path"),d.length>0&&(i===void 0?i=o=d:i+=`\\${d}`)}if(i===void 0)return".";let b=!0,h=0;if(typeof o=="string"&&_(o.charCodeAt(0))){++h;const a=o.length;a>1&&_(o.charCodeAt(1))&&(++h,a>2&&(_(o.charCodeAt(2))?++h:b=!1))}if(b){for(;h<i.length&&_(i.charCodeAt(h));)h++;h>=2&&(i=`\\${i.slice(h)}`)}return r.win32.normalize(i)},relative(s,i){if(u(s,"from"),u(i,"to"),s===i)return"";const o=r.win32.resolve(s),b=r.win32.resolve(i);if(o===b||(s=o.toLowerCase(),i=b.toLowerCase(),s===i))return"";let h=0;for(;h<s.length&&s.charCodeAt(h)===c;)h++;let a=s.length;for(;a-1>h&&s.charCodeAt(a-1)===c;)a--;const d=a-h;let C=0;for(;C<i.length&&i.charCodeAt(C)===c;)C++;let E=i.length;for(;E-1>C&&i.charCodeAt(E-1)===c;)E--;const R=E-C,D=d<R?d:R;let P=-1,O=0;for(;O<D;O++){const H=s.charCodeAt(h+O);if(H!==i.charCodeAt(C+O))break;H===c&&(P=O)}if(O!==D){if(P===-1)return b}else{if(R>D){if(i.charCodeAt(C+O)===c)return b.slice(C+O+1);if(O===2)return b.slice(C+O)}d>D&&(s.charCodeAt(h+O)===c?P=O:O===2&&(P=3)),P===-1&&(P=0)}let W="";for(O=h+P+1;O<=a;++O)(O===a||s.charCodeAt(O)===c)&&(W+=W.length===0?"..":"\\..");return C+=P,W.length>0?`${W}${b.slice(C,E)}`:(b.charCodeAt(C)===c&&++C,b.slice(C,E))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=r.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===c){if(i.charCodeAt(1)===c){const o=i.charCodeAt(2);if(o!==t&&o!==m)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(y(i.charCodeAt(0))&&i.charCodeAt(1)===p&&i.charCodeAt(2)===c)return`\\\\?\\${i}`;return s},dirname(s){u(s,"path");const i=s.length;if(i===0)return".";let o=-1,b=0;const h=s.charCodeAt(0);if(i===1)return _(h)?s:".";if(_(h)){if(o=b=1,_(s.charCodeAt(1))){let C=2,E=C;for(;C<i&&!_(s.charCodeAt(C));)C++;if(C<i&&C!==E){for(E=C;C<i&&_(s.charCodeAt(C));)C++;if(C<i&&C!==E){for(E=C;C<i&&!_(s.charCodeAt(C));)C++;if(C===i)return s;C!==E&&(o=b=C+1)}}}}else y(h)&&s.charCodeAt(1)===p&&(o=i>2&&_(s.charCodeAt(2))?3:2,b=o);let a=-1,d=!0;for(let C=i-1;C>=b;--C)if(_(s.charCodeAt(C))){if(!d){a=C;break}}else d=!1;if(a===-1){if(o===-1)return".";a=o}return s.slice(0,a)},basename(s,i){i!==void 0&&u(i,"ext"),u(s,"path");let o=0,b=-1,h=!0,a;if(s.length>=2&&y(s.charCodeAt(0))&&s.charCodeAt(1)===p&&(o=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,C=-1;for(a=s.length-1;a>=o;--a){const E=s.charCodeAt(a);if(_(E)){if(!h){o=a+1;break}}else C===-1&&(h=!1,C=a+1),d>=0&&(E===i.charCodeAt(d)?--d===-1&&(b=a):(d=-1,b=C))}return o===b?b=C:b===-1&&(b=s.length),s.slice(o,b)}for(a=s.length-1;a>=o;--a)if(_(s.charCodeAt(a))){if(!h){o=a+1;break}}else b===-1&&(h=!1,b=a+1);return b===-1?"":s.slice(o,b)},extname(s){u(s,"path");let i=0,o=-1,b=0,h=-1,a=!0,d=0;s.length>=2&&s.charCodeAt(1)===p&&y(s.charCodeAt(0))&&(i=b=2);for(let C=s.length-1;C>=i;--C){const E=s.charCodeAt(C);if(_(E)){if(!a){b=C+1;break}continue}h===-1&&(a=!1,h=C+1),E===m?o===-1?o=C:d!==1&&(d=1):o!==-1&&(d=-1)}return o===-1||h===-1||d===0||d===1&&o===h-1&&o===b+1?"":s.slice(o,h)},format:g.bind(null,"\\"),parse(s){u(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const o=s.length;let b=0,h=s.charCodeAt(0);if(o===1)return _(h)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(_(h)){if(b=1,_(s.charCodeAt(1))){let P=2,O=P;for(;P<o&&!_(s.charCodeAt(P));)P++;if(P<o&&P!==O){for(O=P;P<o&&_(s.charCodeAt(P));)P++;if(P<o&&P!==O){for(O=P;P<o&&!_(s.charCodeAt(P));)P++;P===o?b=P:P!==O&&(b=P+1)}}}}else if(y(h)&&s.charCodeAt(1)===p){if(o<=2)return i.root=i.dir=s,i;if(b=2,_(s.charCodeAt(2))){if(o===3)return i.root=i.dir=s,i;b=3}}b>0&&(i.root=s.slice(0,b));let a=-1,d=b,C=-1,E=!0,R=s.length-1,D=0;for(;R>=b;--R){if(h=s.charCodeAt(R),_(h)){if(!E){d=R+1;break}continue}C===-1&&(E=!1,C=R+1),h===m?a===-1?a=R:D!==1&&(D=1):a!==-1&&(D=-1)}return C!==-1&&(a===-1||D===0||D===1&&a===C-1&&a===d+1?i.base=i.name=s.slice(d,C):(i.name=s.slice(d,a),i.base=s.slice(d,C),i.ext=s.slice(a,C))),d>0&&d!==b?i.dir=s.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},r.posix={resolve(...s){let i="",o=!1;for(let b=s.length-1;b>=-1&&!o;b--){const h=b>=0?s[b]:A.cwd();u(h,"path"),h.length!==0&&(i=`${h}/${i}`,o=h.charCodeAt(0)===l)}return i=S(i,!o,"/",L),o?`/${i}`:i.length>0?i:"."},normalize(s){if(u(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===l,o=s.charCodeAt(s.length-1)===l;return s=S(s,!i,"/",L),s.length===0?i?"/":o?"./":".":(o&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return u(s,"path"),s.length>0&&s.charCodeAt(0)===l},join(...s){if(s.length===0)return".";let i;for(let o=0;o<s.length;++o){const b=s[o];u(b,"path"),b.length>0&&(i===void 0?i=b:i+=`/${b}`)}return i===void 0?".":r.posix.normalize(i)},relative(s,i){if(u(s,"from"),u(i,"to"),s===i||(s=r.posix.resolve(s),i=r.posix.resolve(i),s===i))return"";const o=1,b=s.length,h=b-o,a=1,d=i.length-a,C=h<d?h:d;let E=-1,R=0;for(;R<C;R++){const P=s.charCodeAt(o+R);if(P!==i.charCodeAt(a+R))break;P===l&&(E=R)}if(R===C)if(d>C){if(i.charCodeAt(a+R)===l)return i.slice(a+R+1);if(R===0)return i.slice(a+R)}else h>C&&(s.charCodeAt(o+R)===l?E=R:R===0&&(E=0));let D="";for(R=o+E+1;R<=b;++R)(R===b||s.charCodeAt(R)===l)&&(D+=D.length===0?"..":"/..");return`${D}${i.slice(a+E)}`},toNamespacedPath(s){return s},dirname(s){if(u(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===l;let o=-1,b=!0;for(let h=s.length-1;h>=1;--h)if(s.charCodeAt(h)===l){if(!b){o=h;break}}else b=!1;return o===-1?i?"/":".":i&&o===1?"//":s.slice(0,o)},basename(s,i){i!==void 0&&u(i,"ext"),u(s,"path");let o=0,b=-1,h=!0,a;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,C=-1;for(a=s.length-1;a>=0;--a){const E=s.charCodeAt(a);if(E===l){if(!h){o=a+1;break}}else C===-1&&(h=!1,C=a+1),d>=0&&(E===i.charCodeAt(d)?--d===-1&&(b=a):(d=-1,b=C))}return o===b?b=C:b===-1&&(b=s.length),s.slice(o,b)}for(a=s.length-1;a>=0;--a)if(s.charCodeAt(a)===l){if(!h){o=a+1;break}}else b===-1&&(h=!1,b=a+1);return b===-1?"":s.slice(o,b)},extname(s){u(s,"path");let i=-1,o=0,b=-1,h=!0,a=0;for(let d=s.length-1;d>=0;--d){const C=s.charCodeAt(d);if(C===l){if(!h){o=d+1;break}continue}b===-1&&(h=!1,b=d+1),C===m?i===-1?i=d:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||b===-1||a===0||a===1&&i===b-1&&i===o+1?"":s.slice(i,b)},format:g.bind(null,"/"),parse(s){u(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const o=s.charCodeAt(0)===l;let b;o?(i.root="/",b=1):b=0;let h=-1,a=0,d=-1,C=!0,E=s.length-1,R=0;for(;E>=b;--E){const D=s.charCodeAt(E);if(D===l){if(!C){a=E+1;break}continue}d===-1&&(C=!1,d=E+1),D===m?h===-1?h=E:R!==1&&(R=1):h!==-1&&(R=-1)}if(d!==-1){const D=a===0&&o?1:a;h===-1||R===0||R===1&&h===d-1&&h===a+1?i.base=i.name=s.slice(D,d):(i.name=s.slice(D,h),i.base=s.slice(D,d),i.ext=s.slice(h,d))}return a>0?i.dir=s.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},r.posix.win32=r.win32.win32=r.win32,r.posix.posix=r.win32.posix=r.posix,r.normalize=A.platform==="win32"?r.win32.normalize:r.posix.normalize,r.resolve=A.platform==="win32"?r.win32.resolve:r.posix.resolve,r.relative=A.platform==="win32"?r.win32.relative:r.posix.relative,r.dirname=A.platform==="win32"?r.win32.dirname:r.posix.dirname,r.basename=A.platform==="win32"?r.win32.basename:r.posix.basename,r.extname=A.platform==="win32"?r.win32.extname:r.posix.extname,r.sep=A.platform==="win32"?r.win32.sep:r.posix.sep}),Y(X[20],Z([0,1,5]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StopWatch=void 0;const e=A.globals.performance&&typeof A.globals.performance.now=="function";class N{static create(v=!0){return new N(v)}constructor(v){this._highResolution=e&&v,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?A.globals.performance.now():Date.now()}}r.StopWatch=N}),Y(X[7],Z([0,1,8,10,14,20]),function(F,r,A,e,N,f){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Relay=r.EventBufferer=r.MicrotaskEmitter=r.DebounceEmitter=r.PauseableEmitter=r.EventDeliveryQueue=r.Emitter=r.EventProfiling=r.Event=void 0;const v=!1,m=!1;var l;(function(h){h.None=()=>e.Disposable.None;function a(J){if(m){const{onDidAddListener:j}=J,Q=w.create();let G=0;J.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),j?.()}}}function d(J,j){return k(J,()=>{},0,void 0,void 0,j)}h.defer=d;function C(J,j=0,Q){return h.debounce(J,(G,x)=>G?(G.push(x),G):[x],j,void 0,void 0,Q)}h.accumulate=C;function E(J){return(j,Q=null,G)=>{let x=!1,ee;return ee=J(te=>{if(!x)return ee?ee.dispose():x=!0,j.call(Q,te)},null,G),x&&ee.dispose(),ee}}h.once=E;function R(J,j,Q){return q((G,x=null,ee)=>J(te=>G.call(x,j(te)),null,ee),Q)}h.map=R;function D(J,j,Q){return q((G,x=null,ee)=>J(te=>{j(te),G.call(x,te)},null,ee),Q)}h.forEach=D;function P(J,j,Q){return q((G,x=null,ee)=>J(te=>j(te)&&G.call(x,te),null,ee),Q)}h.filter=P;function O(J){return J}h.signal=O;function W(...J){return(j,Q=null,G)=>(0,e.combinedDisposable)(...J.map(x=>x(ee=>j.call(Q,ee),null,G)))}h.any=W;function H(J,j,Q,G){let x=Q;return R(J,ee=>(x=j(x,ee),x),G)}h.reduce=H;function q(J,j){let Q;const G={onWillAddFirstListener(){Q=J(x.fire,x)},onDidRemoveLastListener(){Q?.dispose()}};j||a(G);const x=new _(G);return j?.add(x),x.event}function k(J,j,Q=100,G=!1,x,ee){let te,ne,_e,we=0;const ve={leakWarningThreshold:x,onWillAddFirstListener(){te=J(ue=>{we++,ne=j(ne,ue),G&&!_e&&(Ce.fire(ne),ne=void 0),clearTimeout(_e),_e=setTimeout(()=>{const me=ne;ne=void 0,_e=void 0,(!G||we>1)&&Ce.fire(me),we=0},Q)})},onDidRemoveLastListener(){te.dispose()}};ee||a(ve);const Ce=new _(ve);return ee?.add(Ce),Ce.event}h.debounce=k;function U(J,j=(G,x)=>G===x,Q){let G=!0,x;return P(J,ee=>{const te=G||!j(ee,x);return G=!1,x=ee,te},Q)}h.latch=U;function T(J,j,Q){return[h.filter(J,j,Q),h.filter(J,G=>!j(G),Q)]}h.split=T;function B(J,j=!1,Q=[]){let G=Q.slice(),x=J(ne=>{G?G.push(ne):te.fire(ne)});const ee=()=>{G?.forEach(ne=>te.fire(ne)),G=null},te=new _({onWillAddFirstListener(){x||(x=J(ne=>te.fire(ne)))},onDidAddFirstListener(){G&&(j?setTimeout(ee):ee())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return te.event}h.buffer=B;class z{constructor(j){this.event=j,this.disposables=new e.DisposableStore}map(j){return new z(R(this.event,j,this.disposables))}forEach(j){return new z(D(this.event,j,this.disposables))}filter(j){return new z(P(this.event,j,this.disposables))}reduce(j,Q){return new z(H(this.event,j,Q,this.disposables))}latch(){return new z(U(this.event,void 0,this.disposables))}debounce(j,Q=100,G=!1,x){return new z(k(this.event,j,Q,G,x,this.disposables))}on(j,Q,G){return this.event(j,Q,G)}once(j,Q,G){return E(this.event)(j,Q,G)}dispose(){this.disposables.dispose()}}function n(J){return new z(J)}h.chain=n;function ae(J,j,Q=G=>G){const G=(...ne)=>te.fire(Q(...ne)),x=()=>J.on(j,G),ee=()=>J.removeListener(j,G),te=new _({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}h.fromNodeEventEmitter=ae;function de(J,j,Q=G=>G){const G=(...ne)=>te.fire(Q(...ne)),x=()=>J.addEventListener(j,G),ee=()=>J.removeEventListener(j,G),te=new _({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}h.fromDOMEventEmitter=de;function ge(J){return new Promise(j=>E(J)(j))}h.toPromise=ge;function Le(J,j){return j(void 0),J(Q=>j(Q))}h.runAndSubscribe=Le;function ye(J,j){let Q=null;function G(ee){Q?.dispose(),Q=new e.DisposableStore,j(ee,Q)}G(void 0);const x=J(ee=>G(ee));return(0,e.toDisposable)(()=>{x.dispose(),Q?.dispose()})}h.runAndSubscribeWithStore=ye;class Se{constructor(j,Q){this.obs=j,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};Q||a(G),this.emitter=new _(G),Q&&Q.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,Q){this._hasChanged=!0}endUpdate(j){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Ae(J,j){return new Se(J,j).emitter.event}h.fromObservable=Ae})(l=r.Event||(r.Event={}));class c{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${c._idPool++}`,c.all.add(this)}start(a){this._stopWatch=new f.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}r.EventProfiling=c,c.all=new Set,c._idPool=0;let p=-1;class t{constructor(a,d=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=d,this._warnCountdown=0}dispose(){var a;(a=this._stacks)===null||a===void 0||a.clear()}check(a,d){const C=this.threshold;if(C<=0||d<C)return;this._stacks||(this._stacks=new Map);const E=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,E+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let R,D=0;for(const[P,O]of this._stacks)(!R||D<O)&&(R=P,D=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${D}):`),console.warn(R)}return()=>{const R=this._stacks.get(a.value)||0;this._stacks.set(a.value,R-1)}}}class w{static create(){var a;return new w((a=new Error().stack)!==null&&a!==void 0?a:"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(a,d,C){this.callback=a,this.callbackThis=d,this.stack=C,this.subscription=new e.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class _{constructor(a){var d,C,E,R,D;this._disposed=!1,this._options=a,this._leakageMon=p>0||((d=this._options)===null||d===void 0?void 0:d.leakWarningThreshold)?new t((E=(C=this._options)===null||C===void 0?void 0:C.leakWarningThreshold)!==null&&E!==void 0?E:p):void 0,this._perfMon=!((R=this._options)===null||R===void 0)&&R._profName?new c(this._options._profName):void 0,this._deliveryQueue=(D=this._options)===null||D===void 0?void 0:D.deliveryQueue}dispose(){var a,d,C,E;if(!this._disposed){if(this._disposed=!0,this._listeners){if(v){const R=Array.from(this._listeners);queueMicrotask(()=>{var D;for(const P of R)P.subscription.isset()&&(P.subscription.unset(),(D=P.stack)===null||D===void 0||D.print())})}this._listeners.clear()}(a=this._deliveryQueue)===null||a===void 0||a.clear(this),(C=(d=this._options)===null||d===void 0?void 0:d.onDidRemoveLastListener)===null||C===void 0||C.call(d),(E=this._leakageMon)===null||E===void 0||E.dispose()}}get event(){return this._event||(this._event=(a,d,C)=>{var E,R,D;if(this._listeners||(this._listeners=new N.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),e.Disposable.None;const P=this._listeners.isEmpty();P&&((E=this._options)===null||E===void 0?void 0:E.onWillAddFirstListener)&&this._options.onWillAddFirstListener(this);let O,W;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(W=w.create(),O=this._leakageMon.check(W,this._listeners.size+1)),v&&(W=W??w.create());const H=new u(a,d,W),q=this._listeners.push(H);P&&((R=this._options)===null||R===void 0?void 0:R.onDidAddFirstListener)&&this._options.onDidAddFirstListener(this),!((D=this._options)===null||D===void 0)&&D.onDidAddListener&&this._options.onDidAddListener(this,a,d);const k=H.subscription.set(()=>{O?.(),this._disposed||(q(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return C instanceof e.DisposableStore?C.add(k):Array.isArray(C)&&C.push(k),k}),this._event}fire(a){var d,C;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y);for(const E of this._listeners)this._deliveryQueue.push(this,E,a);(d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(C=this._perfMon)===null||C===void 0||C.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}r.Emitter=_;class L{constructor(){this._queue=new N.LinkedList}get size(){return this._queue.size}push(a,d,C){this._queue.push(new S(a,d,C))}clear(a){const d=new N.LinkedList;for(const C of this._queue)C.emitter!==a&&d.push(C);this._queue=d}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(d){(0,A.onUnexpectedError)(d)}}}}r.EventDeliveryQueue=L;class y extends L{clear(a){this._queue.clear()}}class S{constructor(a,d,C){this.emitter=a,this.listener=d,this.event=C}}class g extends _{constructor(a){super(a),this._isPaused=0,this._eventQueue=new N.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}r.PauseableEmitter=g;class s extends g{constructor(a){var d;super(a),this._delay=(d=a.delay)!==null&&d!==void 0?d:100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}r.DebounceEmitter=s;class i extends _{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}r.MicrotaskEmitter=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(d,C,E)=>a(R=>{const D=this.buffers[this.buffers.length-1];D?D.push(()=>d.call(C,R)):d.call(C,R)},void 0,E)}bufferEvents(a){const d=[];this.buffers.push(d);const C=a();return this.buffers.pop(),d.forEach(E=>E()),C}}r.EventBufferer=o;class b{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=e.Disposable.None,this.emitter=new _({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}r.Relay=b}),Y(X[51],Z([0,1,7]),function(F,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CancellationTokenSource=r.CancellationToken=void 0;const e=Object.freeze(function(m,l){const c=setTimeout(m.bind(l),0);return{dispose(){clearTimeout(c)}}});var N;(function(m){function l(c){return c===m.None||c===m.Cancelled||c instanceof f?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}m.isCancellationToken=l,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(N=r.CancellationToken||(r.CancellationToken={}));class f{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new A.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class v{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new f),this._token}cancel(){this._token?this._token instanceof f&&this._token.cancel():this._token=N.Cancelled}dispose(l=!1){var c;l&&this.cancel(),(c=this._parentListener)===null||c===void 0||c.dispose(),this._token?this._token instanceof f&&this._token.dispose():this._token=N.None}}r.CancellationTokenSource=v}),Y(X[12],Z([0,1,50,5]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.uriToFsPath=r.URI=void 0;const N=/^\w[\w\d+.-]*$/,f=/^\//,v=/^\/\//;function m(a,d){if(!a.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!N.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!f.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(a,d){return!a&&!d?"file":a}function c(a,d){switch(a){case"https":case"http":case"file":d?d[0]!==t&&(d=t+d):d=t;break}return d}const p="",t="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(d){return d instanceof u?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,C,E,R,D,P=!1){typeof d=="object"?(this.scheme=d.scheme||p,this.authority=d.authority||p,this.path=d.path||p,this.query=d.query||p,this.fragment=d.fragment||p):(this.scheme=l(d,P),this.authority=C||p,this.path=c(this.scheme,E||p),this.query=R||p,this.fragment=D||p,m(this,P))}get fsPath(){return s(this,!1)}with(d){if(!d)return this;let{scheme:C,authority:E,path:R,query:D,fragment:P}=d;return C===void 0?C=this.scheme:C===null&&(C=p),E===void 0?E=this.authority:E===null&&(E=p),R===void 0?R=this.path:R===null&&(R=p),D===void 0?D=this.query:D===null&&(D=p),P===void 0?P=this.fragment:P===null&&(P=p),C===this.scheme&&E===this.authority&&R===this.path&&D===this.query&&P===this.fragment?this:new L(C,E,R,D,P)}static parse(d,C=!1){const E=w.exec(d);return E?new L(E[2]||p,h(E[4]||p),h(E[5]||p),h(E[7]||p),h(E[9]||p),C):new L(p,p,p,p,p)}static file(d){let C=p;if(e.isWindows&&(d=d.replace(/\\/g,t)),d[0]===t&&d[1]===t){const E=d.indexOf(t,2);E===-1?(C=d.substring(2),d=t):(C=d.substring(2,E),d=d.substring(E)||t)}return new L("file",C,d,p,p)}static from(d){const C=new L(d.scheme,d.authority,d.path,d.query,d.fragment);return m(C,!0),C}static joinPath(d,...C){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return e.isWindows&&d.scheme==="file"?E=u.file(A.win32.join(s(d,!0),...C)).path:E=A.posix.join(d.path,...C),d.with({path:E})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof u)return d;{const C=new L(d);return C._formatted=d.external,C._fsPath=d._sep===_?d.fsPath:null,C}}else return d}}r.URI=u;const _=e.isWindows?1:void 0;class L extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=_),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(a,d){let C,E=-1;for(let R=0;R<a.length;R++){const D=a.charCodeAt(R);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||d&&D===47)E!==-1&&(C+=encodeURIComponent(a.substring(E,R)),E=-1),C!==void 0&&(C+=a.charAt(R));else{C===void 0&&(C=a.substr(0,R));const P=y[D];P!==void 0?(E!==-1&&(C+=encodeURIComponent(a.substring(E,R)),E=-1),C+=P):E===-1&&(E=R)}}return E!==-1&&(C+=encodeURIComponent(a.substring(E))),C!==void 0?C:a}function g(a){let d;for(let C=0;C<a.length;C++){const E=a.charCodeAt(C);E===35||E===63?(d===void 0&&(d=a.substr(0,C)),d+=y[E]):d!==void 0&&(d+=a[C])}return d!==void 0?d:a}function s(a,d){let C;return a.authority&&a.path.length>1&&a.scheme==="file"?C=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?d?C=a.path.substr(1):C=a.path[1].toLowerCase()+a.path.substr(2):C=a.path,e.isWindows&&(C=C.replace(/\//g,"\\")),C}r.uriToFsPath=s;function i(a,d){const C=d?g:S;let E="",{scheme:R,authority:D,path:P,query:O,fragment:W}=a;if(R&&(E+=R,E+=":"),(D||R==="file")&&(E+=t,E+=t),D){let H=D.indexOf("@");if(H!==-1){const q=D.substr(0,H);D=D.substr(H+1),H=q.indexOf(":"),H===-1?E+=C(q,!1):(E+=C(q.substr(0,H),!1),E+=":",E+=C(q.substr(H+1),!1)),E+="@"}D=D.toLowerCase(),H=D.indexOf(":"),H===-1?E+=C(D,!1):(E+=C(D.substr(0,H),!1),E+=D.substr(H))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const H=P.charCodeAt(1);H>=65&&H<=90&&(P=`/${String.fromCharCode(H+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const H=P.charCodeAt(0);H>=65&&H<=90&&(P=`${String.fromCharCode(H+32)}:${P.substr(2)}`)}E+=C(P,!0)}return O&&(E+="?",E+=C(O,!1)),W&&(E+="#",E+=d?W:S(W,!1)),E}function o(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+o(a.substr(3)):a}}const b=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(a){return a.match(b)?a.replace(b,d=>o(d)):a}}),Y(X[56],Z([0,1,8,7,10,11,5,4]),function(F,r,A,e,N,f,v,m){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;const l="$initialize";let c=!1;function p(h){!v.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(h.message))}r.logOnceWebWorkerWarning=p;class t{constructor(a,d,C,E){this.vsWorker=a,this.req=d,this.method=C,this.args=E,this.type=0}}class w{constructor(a,d,C,E){this.vsWorker=a,this.seq=d,this.res=C,this.err=E,this.type=1}}class u{constructor(a,d,C,E){this.vsWorker=a,this.req=d,this.eventName=C,this.arg=E,this.type=2}}class _{constructor(a,d,C){this.vsWorker=a,this.req=d,this.event=C,this.type=3}}class L{constructor(a,d){this.vsWorker=a,this.req=d,this.type=4}}class y{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,d){const C=String(++this._lastSentReq);return new Promise((E,R)=>{this._pendingReplies[C]={resolve:E,reject:R},this._send(new t(this._workerId,C,a,d))})}listen(a,d){let C=null;const E=new e.Emitter({onWillAddFirstListener:()=>{C=String(++this._lastSentReq),this._pendingEmitters.set(C,E),this._send(new u(this._workerId,C,a,d))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(C),this._send(new L(this._workerId,C)),C=null}});return E.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const d=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let C=a.err;a.err.$isError&&(C=new Error,C.name=a.err.name,C.message=a.err.message,C.stack=a.err.stack),d.reject(C);return}d.resolve(a.res)}_handleRequestMessage(a){const d=a.req;this._handler.handleMessage(a.method,a.args).then(E=>{this._send(new w(this._workerId,d,E,void 0))},E=>{E.detail instanceof Error&&(E.detail=(0,A.transformErrorForSerialization)(E.detail)),this._send(new w(this._workerId,d,void 0,(0,A.transformErrorForSerialization)(E)))})}_handleSubscribeEventMessage(a){const d=a.req,C=this._handler.handleEvent(a.eventName,a.arg)(E=>{this._send(new _(this._workerId,d,E))});this._pendingEvents.set(d,C)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const d=[];if(a.type===0)for(let C=0;C<a.args.length;C++)a.args[C]instanceof ArrayBuffer&&d.push(a.args[C]);else a.type===1&&a.res instanceof ArrayBuffer&&d.push(a.res);this._handler.sendMessage(a,d)}}class S extends N.Disposable{constructor(a,d,C){super();let E=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",W=>{this._protocol.handleMessage(W)},W=>{E?.(W)})),this._protocol=new y({sendMessage:(W,H)=>{this._worker.postMessage(W,H)},handleMessage:(W,H)=>{if(typeof C[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(C[W].apply(C,H))}catch(q){return Promise.reject(q)}},handleEvent:(W,H)=>{if(s(W)){const q=C[W].call(C,H);if(typeof q!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return q}if(g(W)){const q=C[W];if(typeof q!="function")throw new Error(`Missing event ${W} on main thread host.`);return q}throw new Error(`Malformed event name ${W}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;typeof v.globals.require<"u"&&typeof v.globals.require.getConfig=="function"?R=v.globals.require.getConfig():typeof v.globals.requirejs<"u"&&(R=v.globals.requirejs.s.contexts._.config);const D=(0,f.getAllMethodNames)(C);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(R)),d,D]);const P=(W,H)=>this._request(W,H),O=(W,H)=>this._protocol.listen(W,H);this._lazyProxy=new Promise((W,H)=>{E=H,this._onModuleLoaded.then(q=>{W(i(q,P,O))},q=>{H(q),this._onError("Worker failed to load "+d,q)})})}getProxyObject(){return this._lazyProxy}_request(a,d){return new Promise((C,E)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,d).then(C,E)},E)})}_onError(a,d){console.error(a),console.info(d)}}r.SimpleWorkerClient=S;function g(h){return h[0]==="o"&&h[1]==="n"&&m.isUpperAsciiLetter(h.charCodeAt(2))}function s(h){return/^onDynamic/.test(h)&&m.isUpperAsciiLetter(h.charCodeAt(9))}function i(h,a,d){const C=D=>function(){const P=Array.prototype.slice.call(arguments,0);return a(D,P)},E=D=>function(P){return d(D,P)},R={};for(const D of h){if(s(D)){R[D]=E(D);continue}if(g(D)){R[D]=d(D,void 0);continue}R[D]=C(D)}return R}class o{constructor(a,d){this._requestHandlerFactory=d,this._requestHandler=null,this._protocol=new y({sendMessage:(C,E)=>{a(C,E)},handleMessage:(C,E)=>this._handleMessage(C,E),handleEvent:(C,E)=>this._handleEvent(C,E)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,d){if(a===l)return this.initialize(d[0],d[1],d[2],d[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,d))}catch(C){return Promise.reject(C)}}_handleEvent(a,d){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(a)){const C=this._requestHandler[a].call(this._requestHandler,d);if(typeof C!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return C}if(g(a)){const C=this._requestHandler[a];if(typeof C!="function")throw new Error(`Missing event ${a} on request handler.`);return C}throw new Error(`Malformed event name ${a}`)}initialize(a,d,C,E){this._protocol.setWorkerId(a);const P=i(E,(O,W)=>this._protocol.sendMessage(O,W),(O,W)=>this._protocol.listen(O,W));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,f.getAllMethodNames)(this._requestHandler))):(d&&(typeof d.baseUrl<"u"&&delete d.baseUrl,typeof d.paths<"u"&&typeof d.paths.vs<"u"&&delete d.paths.vs,typeof d.trustedTypesPolicy!==void 0&&delete d.trustedTypesPolicy,d.catchError=!0,v.globals.require.config(d)),new Promise((O,W)=>{(v.globals.require||F)([C],q=>{if(this._requestHandler=q.create(P),!this._requestHandler){W(new Error("No RequestHandler!"));return}O((0,f.getAllMethodNames)(this._requestHandler))},W)}))}}r.SimpleWorkerServer=o;function b(h){return new o(h,null)}r.create=b}),Y(X[52],Z([0,1,7,10]),function(F,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=void 0;class N{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(m){this._onDidChange.fire({changedLanguages:m,changedColorMap:!1})}register(m,l){return this._map.set(m,l),this.fire([m]),(0,e.toDisposable)(()=>{this._map.get(m)===l&&(this._map.delete(m),this.fire([m]))})}registerFactory(m,l){var c;(c=this._factories.get(m))===null||c===void 0||c.dispose();const p=new f(this,m,l);return this._factories.set(m,p),(0,e.toDisposable)(()=>{const t=this._factories.get(m);!t||t!==p||(this._factories.delete(m),t.dispose())})}getOrCreate(m){return le(this,void 0,void 0,function*(){const l=this.get(m);if(l)return l;const c=this._factories.get(m);return!c||c.isResolved?null:(yield c.resolve(),this.get(m))})}get(m){return this._map.get(m)||null}isResolved(m){if(this.get(m))return!0;const c=this._factories.get(m);return!!(!c||c.isResolved)}setColorMap(m){this._colorMap=m,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}r.TokenizationRegistry=N;class f extends e.Disposable{get isResolved(){return this._isResolved}constructor(m,l,c){super(),this._registry=m,this._languageId=l,this._factory=c,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const m=yield Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,m&&!this._isDisposed&&this._register(this._registry.register(this._languageId,m))})}}}),Y(X[53],Z([0,1,24,12,2,52]),function(F,r,A,e,N,f){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=r.InlayHintKind=r.Command=r.FoldingRangeKind=r.SymbolKinds=r.isLocationLink=r.DocumentHighlightKind=r.SignatureHelpTriggerKind=r.InlineCompletionTriggerKind=r.CompletionItemKinds=r.EncodedTokenizationResult=r.TokenizationResult=r.Token=void 0;class v{constructor(s,i,o){this._tokenBrand=void 0,this.offset=s,this.type=i,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}r.Token=v;class m{constructor(s,i){this._tokenizationResultBrand=void 0,this.tokens=s,this.endState=i}}r.TokenizationResult=m;class l{constructor(s,i){this._encodedTokenizationResultBrand=void 0,this.tokens=s,this.endState=i}}r.EncodedTokenizationResult=l;var c;(function(g){const s=new Map;s.set(0,A.Codicon.symbolMethod),s.set(1,A.Codicon.symbolFunction),s.set(2,A.Codicon.symbolConstructor),s.set(3,A.Codicon.symbolField),s.set(4,A.Codicon.symbolVariable),s.set(5,A.Codicon.symbolClass),s.set(6,A.Codicon.symbolStruct),s.set(7,A.Codicon.symbolInterface),s.set(8,A.Codicon.symbolModule),s.set(9,A.Codicon.symbolProperty),s.set(10,A.Codicon.symbolEvent),s.set(11,A.Codicon.symbolOperator),s.set(12,A.Codicon.symbolUnit),s.set(13,A.Codicon.symbolValue),s.set(15,A.Codicon.symbolEnum),s.set(14,A.Codicon.symbolConstant),s.set(15,A.Codicon.symbolEnum),s.set(16,A.Codicon.symbolEnumMember),s.set(17,A.Codicon.symbolKeyword),s.set(27,A.Codicon.symbolSnippet),s.set(18,A.Codicon.symbolText),s.set(19,A.Codicon.symbolColor),s.set(20,A.Codicon.symbolFile),s.set(21,A.Codicon.symbolReference),s.set(22,A.Codicon.symbolCustomColor),s.set(23,A.Codicon.symbolFolder),s.set(24,A.Codicon.symbolTypeParameter),s.set(25,A.Codicon.account),s.set(26,A.Codicon.issues);function i(h){let a=s.get(h);return a||(console.info("No codicon found for CompletionItemKind "+h),a=A.Codicon.symbolProperty),a}g.toIcon=i;const o=new Map;o.set("method",0),o.set("function",1),o.set("constructor",2),o.set("field",3),o.set("variable",4),o.set("class",5),o.set("struct",6),o.set("interface",7),o.set("module",8),o.set("property",9),o.set("event",10),o.set("operator",11),o.set("unit",12),o.set("value",13),o.set("constant",14),o.set("enum",15),o.set("enum-member",16),o.set("enumMember",16),o.set("keyword",17),o.set("snippet",27),o.set("text",18),o.set("color",19),o.set("file",20),o.set("reference",21),o.set("customcolor",22),o.set("folder",23),o.set("type-parameter",24),o.set("typeParameter",24),o.set("account",25),o.set("issue",26);function b(h,a){let d=o.get(h);return typeof d>"u"&&!a&&(d=9),d}g.fromString=b})(c=r.CompletionItemKinds||(r.CompletionItemKinds={}));var p;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(p=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var t;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(t=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var w;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(w=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));function u(g){return g&&e.URI.isUri(g.uri)&&N.Range.isIRange(g.range)&&(N.Range.isIRange(g.originSelectionRange)||N.Range.isIRange(g.targetSelectionRange))}r.isLocationLink=u;var _;(function(g){const s=new Map;s.set(0,A.Codicon.symbolFile),s.set(1,A.Codicon.symbolModule),s.set(2,A.Codicon.symbolNamespace),s.set(3,A.Codicon.symbolPackage),s.set(4,A.Codicon.symbolClass),s.set(5,A.Codicon.symbolMethod),s.set(6,A.Codicon.symbolProperty),s.set(7,A.Codicon.symbolField),s.set(8,A.Codicon.symbolConstructor),s.set(9,A.Codicon.symbolEnum),s.set(10,A.Codicon.symbolInterface),s.set(11,A.Codicon.symbolFunction),s.set(12,A.Codicon.symbolVariable),s.set(13,A.Codicon.symbolConstant),s.set(14,A.Codicon.symbolString),s.set(15,A.Codicon.symbolNumber),s.set(16,A.Codicon.symbolBoolean),s.set(17,A.Codicon.symbolArray),s.set(18,A.Codicon.symbolObject),s.set(19,A.Codicon.symbolKey),s.set(20,A.Codicon.symbolNull),s.set(21,A.Codicon.symbolEnumMember),s.set(22,A.Codicon.symbolStruct),s.set(23,A.Codicon.symbolEvent),s.set(24,A.Codicon.symbolOperator),s.set(25,A.Codicon.symbolTypeParameter);function i(o){let b=s.get(o);return b||(console.info("No codicon found for SymbolKind "+o),b=A.Codicon.symbolProperty),b}g.toIcon=i})(_=r.SymbolKinds||(r.SymbolKinds={}));class L{constructor(s){this.value=s}}r.FoldingRangeKind=L,L.Comment=new L("comment"),L.Imports=new L("imports"),L.Region=new L("region");var y;(function(g){function s(i){return!i||typeof i!="object"?!1:typeof i.id=="string"&&typeof i.title=="string"}g.is=s})(y=r.Command||(r.Command={}));var S;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(S=r.InlayHintKind||(r.InlayHintKind={})),r.TokenizationRegistry=new f.TokenizationRegistry}),Y(X[54],Z([0,1,51,7,27,12,3,2,31,53,47]),function(F,r,A,e,N,f,v,m,l,c,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createMonacoBaseAPI=r.KeyMod=void 0;class t{static chord(_,L){return(0,N.KeyChord)(_,L)}}r.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:e.Emitter,KeyCode:p.KeyCode,KeyMod:t,Position:v.Position,Range:m.Range,Selection:l.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:f.URI,Token:c.Token}}r.createMonacoBaseAPI=w}),Y(X[57],Z([0,1,15,5,12,3,2,44,18,40,41,54,20,46,39,11]),function(F,r,A,e,N,f,v,m,l,c,p,t,w,u,_,L){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.EditorSimpleWorker=void 0;class y extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,o){const b=(0,l.getWordAtText)(i.column,(0,l.ensureValidWordDefinition)(o),this._lines[i.lineNumber-1],0);return b?new v.Range(i.lineNumber,b.startColumn,i.lineNumber,b.endColumn):null}words(i){const o=this._lines,b=this._wordenize.bind(this);let h=0,a="",d=0,C=[];return{*[Symbol.iterator](){for(;;)if(d<C.length){const E=a.substring(C[d].start,C[d].end);d+=1,yield E}else if(h<o.length)a=o[h],C=b(a,i),d=0,h+=1;else break}}}getLineWords(i,o){const b=this._lines[i-1],h=this._wordenize(b,o),a=[];for(const d of h)a.push({word:b.substring(d.start,d.end),startColumn:d.start+1,endColumn:d.end+1});return a}_wordenize(i,o){const b=[];let h;for(o.lastIndex=0;(h=o.exec(i))&&h[0].length!==0;)b.push({start:h.index,end:h.index+h[0].length});return b}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const o=this._eol,b=i.startLineNumber-1,h=i.endLineNumber-1,a=[];a.push(this._lines[b].substring(i.startColumn-1));for(let d=b+1;d<h;d++)a.push(this._lines[d]);return a.push(this._lines[h].substring(0,i.endColumn-1)),a.join(o)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(i),b=this._lines[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,b)}}_validateRange(i){const o=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),b=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return o.lineNumber!==i.startLineNumber||o.column!==i.startColumn||b.lineNumber!==i.endLineNumber||b.column!==i.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:b.lineNumber,endColumn:b.column}:i}_validatePosition(i){if(!f.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:o,column:b}=i,h=!1;if(o<1)o=1,b=1,h=!0;else if(o>this._lines.length)o=this._lines.length,b=this._lines[o-1].length+1,h=!0;else{const a=this._lines[o-1].length+1;b<1?(b=1,h=!0):b>a&&(b=a,h=!0)}return h?{lineNumber:o,column:b}:i}}class S{constructor(i,o){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=o,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(o=>i.push(this._models[o])),i}acceptNewModel(i){this._models[i.url]=new y(N.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,o){if(!this._models[i])return;this._models[i].onEvents(o)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,o,b){return le(this,void 0,void 0,function*(){const h=this._getModel(i);return h?u.UnicodeTextModelHighlighter.computeUnicodeHighlights(h,o,b):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(i,o,b){return le(this,void 0,void 0,function*(){const h=this._getModel(i),a=this._getModel(o);return!h||!a?null:S.computeDiff(h,a,b)})}static computeDiff(i,o,b){const h=b.diffAlgorithm==="experimental"?_.linesDiffComputers.experimental:_.linesDiffComputers.smart,a=i.getLinesContent(),d=o.getLinesContent(),C=h.computeDiff(a,d,b);return{identical:C.changes.length>0?!1:this._modelsAreIdentical(i,o),quitEarly:C.quitEarly,changes:C.changes.map(R=>{var D;return[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,(D=R.innerChanges)===null||D===void 0?void 0:D.map(P=>[P.originalRange.startLineNumber,P.originalRange.startColumn,P.originalRange.endLineNumber,P.originalRange.endColumn,P.modifiedRange.startLineNumber,P.modifiedRange.startColumn,P.modifiedRange.endLineNumber,P.modifiedRange.endColumn])]})}}static _modelsAreIdentical(i,o){const b=i.getLineCount(),h=o.getLineCount();if(b!==h)return!1;for(let a=1;a<=b;a++){const d=i.getLineContent(a),C=o.getLineContent(a);if(d!==C)return!1}return!0}computeMoreMinimalEdits(i,o){return le(this,void 0,void 0,function*(){const b=this._getModel(i);if(!b)return o;const h=[];let a;o=o.slice(0).sort((d,C)=>{if(d.range&&C.range)return v.Range.compareRangesUsingStarts(d.range,C.range);const E=d.range?0:1,R=C.range?0:1;return E-R});for(let{range:d,text:C,eol:E}of o){if(typeof E=="number"&&(a=E),v.Range.isEmpty(d)&&!C)continue;const R=b.getValueInRange(d);if(C=C.replace(/\r\n|\n|\r/g,b.eol),R===C)continue;if(Math.max(C.length,R.length)>S._diffLimit){h.push({range:d,text:C});continue}const D=(0,A.stringDiff)(R,C,!1),P=b.offsetAt(v.Range.lift(d).getStartPosition());for(const O of D){const W=b.positionAt(P+O.originalStart),H=b.positionAt(P+O.originalStart+O.originalLength),q={text:C.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:H.lineNumber,endColumn:H.column}};b.getValueInRange(q.range)!==q.text&&h.push(q)}}return typeof a=="number"&&h.push({eol:a,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),h})}computeLinks(i){return le(this,void 0,void 0,function*(){const o=this._getModel(i);return o?(0,c.computeLinks)(o):null})}textualSuggest(i,o,b,h){return le(this,void 0,void 0,function*(){const a=new w.StopWatch(!0),d=new RegExp(b,h),C=new Set;e:for(const E of i){const R=this._getModel(E);if(!!R){for(const D of R.words(d))if(!(D===o||!isNaN(Number(D)))&&(C.add(D),C.size>S._suggestionsLimit))break e}}return{words:Array.from(C),duration:a.elapsed()}})}computeWordRanges(i,o,b,h){return le(this,void 0,void 0,function*(){const a=this._getModel(i);if(!a)return Object.create(null);const d=new RegExp(b,h),C=Object.create(null);for(let E=o.startLineNumber;E<o.endLineNumber;E++){const R=a.getLineWords(E,d);for(const D of R){if(!isNaN(Number(D.word)))continue;let P=C[D.word];P||(P=[],C[D.word]=P),P.push({startLineNumber:E,startColumn:D.startColumn,endLineNumber:E,endColumn:D.endColumn})}}return C})}navigateValueSet(i,o,b,h,a){return le(this,void 0,void 0,function*(){const d=this._getModel(i);if(!d)return null;const C=new RegExp(h,a);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const E=d.getValueInRange(o),R=d.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},C);if(!R)return null;const D=d.getValueInRange(R);return p.BasicInplaceReplace.INSTANCE.navigateValueSet(o,E,R,D,b)})}loadForeignModule(i,o,b){const h=(C,E)=>this._host.fhr(C,E),d={host:(0,L.createProxyObject)(b,h),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(d,o),Promise.resolve((0,L.getAllMethodNames)(this._foreignModule))):new Promise((C,E)=>{F([i],R=>{this._foreignModule=R.create(d,o),C((0,L.getAllMethodNames)(this._foreignModule))},E)})}fmr(i,o){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,o))}catch(b){return Promise.reject(b)}}}r.EditorSimpleWorker=S,S._diffLimit=1e5,S._suggestionsLimit=1e4;function g(s){return new S(s,null)}r.create=g,typeof importScripts=="function"&&(e.globals.monaco=(0,t.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map